/* game-view.c generated by valac 0.43.4, the Vala compiler
 * generated from game-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <librsvg/rsvg.h>

#define TYPE_GAME_VIEW (game_view_get_type ())
#define GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_VIEW, GameView))
#define GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_VIEW, GameViewClass))
#define IS_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_VIEW))
#define IS_GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_VIEW))
#define GAME_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_VIEW, GameViewClass))

typedef struct _GameView GameView;
typedef struct _GameViewClass GameViewClass;
typedef struct _GameViewPrivate GameViewPrivate;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;

#define TYPE_IAGNO (iagno_get_type ())
#define IAGNO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IAGNO, Iagno))
#define IAGNO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IAGNO, IagnoClass))
#define IS_IAGNO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IAGNO))
#define IS_IAGNO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IAGNO))
#define IAGNO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IAGNO, IagnoClass))

typedef struct _Iagno Iagno;
typedef struct _IagnoClass IagnoClass;

#define TYPE_GAME_STATE_OBJECT (game_state_object_get_type ())
#define GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_STATE_OBJECT, GameStateObject))
#define GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))
#define IS_GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_STATE_OBJECT))
#define IS_GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_STATE_OBJECT))
#define GAME_STATE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))

typedef struct _GameStateObject GameStateObject;
typedef struct _GameStateObjectClass GameStateObjectClass;
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
enum  {
	GAME_VIEW_0_PROPERTY,
	GAME_VIEW_SHOW_TURNABLE_TILES_PROPERTY,
	GAME_VIEW_SCOREBOARD_PROPERTY,
	GAME_VIEW_SOUND_FLIP_PROPERTY,
	GAME_VIEW_SOUND_GAMEOVER_PROPERTY,
	GAME_VIEW_GAME_PROPERTY,
	GAME_VIEW_THEME_PROPERTY,
	GAME_VIEW_NUM_PROPERTIES
};
static GParamSpec* game_view_properties[GAME_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

#define TYPE_COMPUTER_PLAYER (computer_player_get_type ())
#define COMPUTER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPUTER_PLAYER, ComputerPlayer))
#define COMPUTER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPUTER_PLAYER, ComputerPlayerClass))
#define IS_COMPUTER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPUTER_PLAYER))
#define IS_COMPUTER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPUTER_PLAYER))
#define COMPUTER_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPUTER_PLAYER, ComputerPlayerClass))

typedef struct _ComputerPlayer ComputerPlayer;
typedef struct _ComputerPlayerClass ComputerPlayerClass;

#define TYPE_POSSIBLE_MOVE (possible_move_get_type ())
typedef struct _PossibleMove PossibleMove;
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
enum  {
	GAME_VIEW_MOVE_SIGNAL,
	GAME_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL,
	GAME_VIEW_NUM_SIGNALS
};
static guint game_view_signals[GAME_VIEW_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GameView {
	GtkDrawingArea parent_instance;
	GameViewPrivate * priv;
};

struct _GameViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _GameViewPrivate {
	gboolean _show_turnable_tiles;
	GtkDrawingArea* _scoreboard;
	gchar* pieces_file;
	gdouble background_red;
	gdouble background_green;
	gdouble background_blue;
	gint background_radius;
	gdouble texture_alpha;
	gboolean apply_texture;
	gdouble mark_red;
	gdouble mark_green;
	gdouble mark_blue;
	gint mark_width;
	gdouble border_red;
	gdouble border_green;
	gdouble border_blue;
	gint border_width;
	gdouble half_border_width;
	gdouble spacing_red;
	gdouble spacing_green;
	gdouble spacing_blue;
	gint spacing_width;
	gdouble highlight_hard_red;
	gdouble highlight_hard_green;
	gdouble highlight_hard_blue;
	gdouble highlight_hard_alpha;
	gdouble highlight_soft_red;
	gdouble highlight_soft_green;
	gdouble highlight_soft_blue;
	gdouble highlight_soft_alpha;
	gchar* _sound_flip;
	gchar* _sound_gameover;
	gint board_x;
	gint board_y;
	gboolean show_highlight;
	gboolean highlight_set;
	guint8 highlight_x;
	guint8 highlight_y;
	guint8 old_highlight_x;
	guint8 old_highlight_y;
	guint8 highlight_state;
	gboolean show_mouse_highlight;
	gboolean mouse_position_set;
	guint8 mouse_highlight_x;
	guint8 mouse_highlight_y;
	guint8 mouse_position_x;
	guint8 mouse_position_y;
	guint render_size;
	cairo_pattern_t* tiles_pattern;
	cairo_pattern_t* scoreboard_tiles_pattern;
	cairo_pattern_t* board_pattern;
	gboolean noise_pixbuf_loaded;
	gint* pixmaps;
	gint pixmaps_length1;
	gint pixmaps_length2;
	guint animate_timeout;
	gint current_player_number;
	gboolean game_is_set;
	guint8 game_size;
	Game* _game;
	Iagno* iagno_instance;
	gchar* _theme;
	gint paving_size;
	gint tile_size;
	gint board_size;
	gint* tile_xs;
	gint tile_xs_length1;
	gint tile_xs_length2;
	gint* tile_ys;
	gint tile_ys_length1;
	gint tile_ys_length2;
	gboolean last_state_set;
	GameStateObject* last_state;
	gboolean flip_final_result_now;
	Player winning_color;
	gint n_winning_tiles;
	Player losing_color;
	gint n_losing_tiles;
	GtkEventControllerMotion* motion_controller;
	gboolean mouse_is_in;
	guint timeout_id;
	guint8 playable_tiles_highlight_state;
	gboolean* possible_moves;
	gint possible_moves_length1;
	gint possible_moves_length2;
};

struct _PossibleMove {
	guint8 x;
	guint8 y;
	guint8 n_tiles;
	guint8 n_tiles_n;
	guint8 n_tiles_ne;
	guint8 n_tiles_e;
	guint8 n_tiles_se;
	guint8 n_tiles_s;
	guint8 n_tiles_so;
	guint8 n_tiles_o;
	guint8 n_tiles_no;
};

struct _Block2Data {
	int _ref_count_;
	GameView* self;
	gboolean is_final_animation;
};

struct _Block3Data {
	int _ref_count_;
	GameView* self;
	guint8 x;
	guint8 y;
};

static gint GameView_private_offset;
static gpointer game_view_parent_class = NULL;

GType game_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameView, g_object_unref)
GType game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
GType iagno_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Iagno, g_object_unref)
GType game_state_object_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameStateObject, g_object_unref)
GType player_get_type (void) G_GNUC_CONST;
#define GAME_VIEW_HIGHLIGHT_MAX ((guint8) 5)
#define GAME_VIEW_PIXMAP_FLIP_DELAY 20
#define GAME_VIEW_HALF_PI G_PI_2
GameView* game_view_new (Iagno* iagno_instance);
GameView* game_view_construct (GType object_type,
                               Iagno* iagno_instance);
static void game_view_set_default_theme (GameView* self,
                                  GKeyFile* * key);
static void game_view_load_theme (GameView* self,
                           GKeyFile* key);
static void game_view_set_sound_flip (GameView* self,
                               const gchar* value);
static void game_view_set_sound_gameover (GameView* self,
                                   const gchar* value);
static inline void game_view_calculate (GameView* self);
static gboolean game_view_real_draw (GtkWidget* base,
                              cairo_t* cr);
static inline void game_view_init_patterns (GameView* self,
                              cairo_t* cr);
static inline void game_view_draw_highlight (GameView* self,
                               cairo_t* cr);
static inline void game_view_add_highlights (GameView* self,
                               cairo_t* cr);
static inline void game_view_draw_playables (GameView* self,
                               cairo_t* cr);
static void game_view_load_image (GameView* self,
                           cairo_t* c,
                           gint width,
                           gint height);
static inline void game_view_draw_board_background (GameView* self,
                                      cairo_t* cr);
static inline void game_view_draw_tiles_background (GameView* self,
                                      cairo_t* cr,
                                      cairo_pattern_t* * noise_pattern);
static inline void game_view_draw_tile_background (GameView* self,
                                     cairo_t* cr,
                                     cairo_pattern_t* * noise_pattern,
                                     gint tile_x,
                                     gint tile_y);
static void game_view_rounded_square (GameView* self,
                               cairo_t* cr,
                               gdouble x,
                               gdouble y,
                               gint size,
                               gdouble width,
                               gdouble radius_percent);
Game* game_view_get_game (GameView* self);
gboolean game_get_is_complete (Game* self);
Player iagno_get_player_one (Iagno* self);
Player game_get_current_color (Game* self);
GType computer_player_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComputerPlayer, g_object_unref)
ComputerPlayer* iagno_get_computer (Iagno* self);
static inline void game_view_draw_tile_highlight (GameView* self,
                                    cairo_t* cr,
                                    guint8 x,
                                    guint8 y);
GType possible_move_get_type (void) G_GNUC_CONST;
PossibleMove* possible_move_dup (const PossibleMove* self);
void possible_move_free (PossibleMove* self);
gboolean game_test_placing_tile (Game* self,
                                 guint8 x,
                                 guint8 y,
                                 PossibleMove* move);
static void game_view_queue_draw_tile (GameView* self,
                                guint8 x,
                                guint8 y);
static void game_view_highlight_tile (GameView* self,
                               cairo_t* cr,
                               guint8 x,
                               guint8 y,
                               guint8 intensity,
                               gboolean soft_highlight);
static gboolean game_view_get_show_turnable_tiles (GameView* self);
static inline void game_view_highlight_turnable_tiles (GameView* self,
                                         cairo_t* cr,
                                         guint8 x,
                                         guint8 y,
                                         gint8 x_step,
                                         gint8 y_step,
                                         guint8 count);
static void game_view_init_possible_moves (GameView* self);
static inline void game_view_add_highlight (GameView* self,
                              cairo_t* cr,
                              guint8 x,
                              guint8 y,
                              guint8 intensity);
static inline void game_view_draw_playable (GameView* self,
                              cairo_t* cr,
                              gint pixmap,
                              gint tile_x,
                              gint tile_y);
static inline void game_view_update_highlight_after_undo (GameView* self);
static void game_view_get_missing_tile (GameView* self,
                                 guint8* x,
                                 guint8* y);
static void game_view_set_square (GameView* self,
                           guint8 x,
                           guint8 y,
                           gint pixmap,
                           gboolean is_final_animation,
                           gboolean force_redraw);
static gint game_view_get_pixmap (Player color);
Player game_get_owner (Game* self,
                       guint8 x,
                       guint8 y);
Player game_state_object_get_owner (GameStateObject* self,
                                    guint8 x,
                                    guint8 y);
static void game_view_turn_ended_cb (GameView* self,
                              gboolean undoing,
                              gboolean no_draw);
static inline void game_view_update_squares (GameView* self);
GameStateObject* game_get_current_state (Game* self);
static inline void game_view_update_square (GameView* self,
                              guint8 x,
                              guint8 y);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean ____lambda9_ (Block2Data* _data2_);
static void game_view_flip_final_result_tile (GameView* self,
                                       guint8 x,
                                       guint8 y);
static void _game_view_on_motion (GameView* self,
                           guint8 x,
                           guint8 y,
                           gboolean force_redraw);
static gboolean _____lambda9__gsource_func (gpointer self);
static void game_view_game_is_complete_cb (GameView* self);
guint8 game_get_n_light_tiles (Game* self);
guint8 game_get_n_dark_tiles (Game* self);
static gboolean ___lambda8_ (GameView* self);
static void game_view_set_winner_and_loser_variables (GameView* self);
static gboolean ____lambda8__gsource_func (gpointer self);
gboolean game_view_undo_final_animation (GameView* self);
static void game_view_init_mouse (GameView* self);
static void game_view_on_motion (GameView* self,
                          GtkEventControllerMotion* _motion_controller,
                          gdouble event_x,
                          gdouble event_y);
static void _game_view_on_motion_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                              gdouble x,
                                                              gdouble y,
                                                              gpointer self);
static gboolean game_view_real_enter_notify_event (GtkWidget* base,
                                            GdkEventCrossing* event);
static gboolean game_view_pointer_is_in_board (GameView* self,
                                        gdouble pos_x,
                                        gdouble pos_y,
                                        guint8* x,
                                        guint8* y);
static void game_view_on_cursor_moving_in (GameView* self,
                                    guint8 x,
                                    guint8 y);
static gboolean game_view_real_leave_notify_event (GtkWidget* base,
                                            GdkEventCrossing* event);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean ______lambda11_ (Block3Data* _data3_);
static gboolean _______lambda11__gsource_func (gpointer self);
static gboolean game_view_real_button_press_event (GtkWidget* base,
                                            GdkEventButton* event);
static inline void game_view_move_if_possible (GameView* self,
                                 guint8 x,
                                 guint8 y);
static gboolean game_view_real_key_press_event (GtkWidget* base,
                                         GdkEventKey* event);
static inline void game_view_highlight_playable_tiles (GameView* self);
void game_get_possible_moves (Game* self,
                              GSList* * moves);
static void _possible_move_free0_ (gpointer var);
static inline void _g_slist_free__possible_move_free0_ (GSList* self);
static void __lambda12_ (GameView* self,
                  PossibleMove* move);
static void ___lambda12__gfunc (gconstpointer data,
                         gpointer self);
static gboolean game_view_draw_scoreboard (GameView* self,
                                    cairo_t* cr);
static GtkDrawingArea* game_view_get_scoreboard (GameView* self);
void game_view_update_scoreboard (GameView* self);
void game_view_set_show_turnable_tiles (GameView* self,
                                        gboolean value);
void game_view_set_scoreboard (GameView* self,
                               GtkDrawingArea* value);
static gboolean _game_view_draw_scoreboard_gtk_widget_draw (GtkWidget* _sender,
                                                     cairo_t* cr,
                                                     gpointer self);
const gchar* game_view_get_sound_flip (GameView* self);
const gchar* game_view_get_sound_gameover (GameView* self);
void game_view_set_game (GameView* self,
                         Game* value);
guint8 game_get_size (Game* self);
static void _game_view_game_is_complete_cb_game_completeness_updated (Game* _sender,
                                                               gboolean completeness,
                                                               gpointer self);
static void _game_view_turn_ended_cb_game_turn_ended (Game* _sender,
                                               gboolean undoing,
                                               gboolean no_draw,
                                               gpointer self);
gboolean game_get_alternative_start (Game* self);
const gchar* game_view_get_theme (GameView* self);
void game_view_set_theme (GameView* self,
                          const gchar* value);
static void g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static GObject * game_view_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void game_view_finalize (GObject * obj);
static void _vala_game_view_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_game_view_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
game_view_get_instance_private (GameView* self)
{
	return G_STRUCT_MEMBER_P (self, GameView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 182 "../src/game-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 499 "game-view.c"
}

GameView*
game_view_construct (GType object_type,
                     Iagno* iagno_instance)
{
	GameView * self = NULL;
	Iagno* _tmp0_;
#line 180 "../src/game-view.vala"
	g_return_val_if_fail (iagno_instance != NULL, NULL);
#line 180 "../src/game-view.vala"
	self = (GameView*) g_object_new (object_type, NULL);
#line 182 "../src/game-view.vala"
	_tmp0_ = _g_object_ref0 (iagno_instance);
#line 182 "../src/game-view.vala"
	_g_object_unref0 (self->priv->iagno_instance);
#line 182 "../src/game-view.vala"
	self->priv->iagno_instance = _tmp0_;
#line 180 "../src/game-view.vala"
	return self;
#line 520 "game-view.c"
}

GameView*
game_view_new (Iagno* iagno_instance)
{
#line 180 "../src/game-view.vala"
	return game_view_construct (TYPE_GAME_VIEW, iagno_instance);
#line 528 "game-view.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 547 "game-view.c"
}

static void
game_view_set_default_theme (GameView* self,
                             GKeyFile* * key)
{
	GtkSettings* defaults = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	gchar* filename = NULL;
	gboolean _tmp2_ = FALSE;
	GtkSettings* _tmp3_;
	gchar* filepath = NULL;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	GError * _inner_error_ = NULL;
#line 225 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/game-view.vala"
	g_return_if_fail (*key != NULL);
#line 227 "../src/game-view.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 227 "../src/game-view.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 227 "../src/game-view.vala"
	defaults = _tmp1_;
#line 230 "../src/game-view.vala"
	_tmp3_ = defaults;
#line 230 "../src/game-view.vala"
	if (_tmp3_ != NULL) {
#line 578 "game-view.c"
		GtkSettings* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 230 "../src/game-view.vala"
		_tmp4_ = defaults;
#line 230 "../src/game-view.vala"
		g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp5_, NULL);
#line 230 "../src/game-view.vala"
		_tmp6_ = _tmp5_;
#line 230 "../src/game-view.vala"
		_tmp7_ = _tmp6_;
#line 230 "../src/game-view.vala"
		_tmp2_ = string_contains (_tmp7_, "HighContrast");
#line 230 "../src/game-view.vala"
		_g_free0 (_tmp7_);
#line 595 "game-view.c"
	} else {
#line 230 "../src/game-view.vala"
		_tmp2_ = FALSE;
#line 599 "game-view.c"
	}
#line 230 "../src/game-view.vala"
	if (_tmp2_) {
#line 603 "game-view.c"
		gchar* _tmp8_;
#line 231 "../src/game-view.vala"
		_tmp8_ = g_strdup ("high_contrast.theme");
#line 231 "../src/game-view.vala"
		_g_free0 (filename);
#line 231 "../src/game-view.vala"
		filename = _tmp8_;
#line 611 "game-view.c"
	} else {
		gboolean _tmp9_ = FALSE;
		GtkSettings* _tmp10_;
#line 232 "../src/game-view.vala"
		_tmp10_ = defaults;
#line 232 "../src/game-view.vala"
		if (_tmp10_ != NULL) {
#line 619 "game-view.c"
			gboolean _tmp11_ = FALSE;
			GtkSettings* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 232 "../src/game-view.vala"
			_tmp12_ = defaults;
#line 232 "../src/game-view.vala"
			g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_settings_get_type (), GtkSettings), "gtk-application-prefer-dark-theme", &_tmp13_, NULL);
#line 232 "../src/game-view.vala"
			_tmp14_ = _tmp13_;
#line 232 "../src/game-view.vala"
			if (_tmp14_ == TRUE) {
#line 232 "../src/game-view.vala"
				_tmp11_ = TRUE;
#line 634 "game-view.c"
			} else {
				GtkSettings* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
#line 233 "../src/game-view.vala"
				_tmp15_ = defaults;
#line 233 "../src/game-view.vala"
				g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp16_, NULL);
#line 233 "../src/game-view.vala"
				_tmp17_ = _tmp16_;
#line 233 "../src/game-view.vala"
				_tmp18_ = _tmp17_;
#line 233 "../src/game-view.vala"
				_tmp11_ = g_strcmp0 (_tmp18_, "Adwaita-dark") == 0;
#line 233 "../src/game-view.vala"
				_g_free0 (_tmp18_);
#line 652 "game-view.c"
			}
#line 232 "../src/game-view.vala"
			_tmp9_ = _tmp11_;
#line 656 "game-view.c"
		} else {
#line 232 "../src/game-view.vala"
			_tmp9_ = FALSE;
#line 660 "game-view.c"
		}
#line 232 "../src/game-view.vala"
		if (_tmp9_) {
#line 664 "game-view.c"
			gchar* _tmp19_;
#line 234 "../src/game-view.vala"
			_tmp19_ = g_strdup ("adwaita.theme");
#line 234 "../src/game-view.vala"
			_g_free0 (filename);
#line 234 "../src/game-view.vala"
			filename = _tmp19_;
#line 672 "game-view.c"
		} else {
			gchar* _tmp20_;
#line 236 "../src/game-view.vala"
			_tmp20_ = g_strdup ("classic.theme");
#line 236 "../src/game-view.vala"
			_g_free0 (filename);
#line 236 "../src/game-view.vala"
			filename = _tmp20_;
#line 681 "game-view.c"
		}
	}
#line 238 "../src/game-view.vala"
	_tmp21_ = filename;
#line 238 "../src/game-view.vala"
	_tmp22_ = g_build_filename (DATA_DIRECTORY, "themes", "key", _tmp21_, NULL);
#line 238 "../src/game-view.vala"
	filepath = _tmp22_;
#line 690 "game-view.c"
	{
#line 241 "../src/game-view.vala"
		g_key_file_load_from_file (*key, filepath, G_KEY_FILE_NONE, &_inner_error_);
#line 241 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 696 "game-view.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 239 "../src/game-view.vala"
		g_clear_error (&_inner_error_);
#line 239 "../src/game-view.vala"
		_inner_error_ = NULL;
#line 243 "../src/game-view.vala"
		g_assert_not_reached ();
#line 709 "game-view.c"
	}
	__finally0:
#line 239 "../src/game-view.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 239 "../src/game-view.vala"
		_g_free0 (filepath);
#line 239 "../src/game-view.vala"
		_g_free0 (filename);
#line 239 "../src/game-view.vala"
		_g_object_unref0 (defaults);
#line 239 "../src/game-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 239 "../src/game-view.vala"
		g_clear_error (&_inner_error_);
#line 239 "../src/game-view.vala"
		return;
#line 726 "game-view.c"
	}
#line 225 "../src/game-view.vala"
	_g_free0 (filepath);
#line 225 "../src/game-view.vala"
	_g_free0 (filename);
#line 225 "../src/game-view.vala"
	_g_object_unref0 (defaults);
#line 734 "game-view.c"
}

static void
game_view_load_theme (GameView* self,
                      GKeyFile* key)
{
	GError * _inner_error_ = NULL;
#line 246 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 246 "../src/game-view.vala"
	g_return_if_fail (key != NULL);
#line 746 "game-view.c"
	{
		gchar* svg_path = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gboolean _tmp9_;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		gint _tmp15_ = 0;
		gdouble _tmp16_ = 0.0;
		gboolean _tmp17_ = FALSE;
		gdouble _tmp18_ = 0.0;
		gdouble _tmp19_ = 0.0;
		gdouble _tmp20_ = 0.0;
		gint _tmp21_ = 0;
		gdouble _tmp22_ = 0.0;
		gdouble _tmp23_ = 0.0;
		gdouble _tmp24_ = 0.0;
		gint _tmp25_ = 0;
		gdouble _tmp26_ = 0.0;
		gdouble _tmp27_ = 0.0;
		gdouble _tmp28_ = 0.0;
		gint _tmp29_ = 0;
		gdouble _tmp30_ = 0.0;
		gdouble _tmp31_ = 0.0;
		gdouble _tmp32_ = 0.0;
		gdouble _tmp33_ = 0.0;
		gdouble _tmp34_ = 0.0;
		gdouble _tmp35_ = 0.0;
		gdouble _tmp36_ = 0.0;
		gdouble _tmp37_ = 0.0;
		gchar* _tmp38_ = NULL;
		gchar* _tmp39_;
		gchar* _tmp40_ = NULL;
		gchar* _tmp41_;
#line 250 "../src/game-view.vala"
		_tmp0_ = g_build_filename (DATA_DIRECTORY, "themes", "svg", NULL);
#line 250 "../src/game-view.vala"
		svg_path = _tmp0_;
#line 251 "../src/game-view.vala"
		_tmp2_ = g_key_file_get_string (key, "Pieces", "File", &_inner_error_);
#line 251 "../src/game-view.vala"
		_tmp1_ = _tmp2_;
#line 251 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 251 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 251 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 803 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 251 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 251 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 251 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 251 "../src/game-view.vala"
			return;
#line 814 "game-view.c"
		}
#line 251 "../src/game-view.vala"
		_tmp3_ = svg_path;
#line 251 "../src/game-view.vala"
		_tmp4_ = g_build_filename (_tmp3_, _tmp1_, NULL);
#line 251 "../src/game-view.vala"
		_g_free0 (self->priv->pieces_file);
#line 251 "../src/game-view.vala"
		self->priv->pieces_file = _tmp4_;
#line 252 "../src/game-view.vala"
		_tmp5_ = self->priv->pieces_file;
#line 252 "../src/game-view.vala"
		_tmp6_ = g_path_get_dirname (_tmp5_);
#line 252 "../src/game-view.vala"
		_tmp7_ = _tmp6_;
#line 252 "../src/game-view.vala"
		_tmp8_ = svg_path;
#line 252 "../src/game-view.vala"
		_tmp9_ = g_strcmp0 (_tmp7_, _tmp8_) != 0;
#line 252 "../src/game-view.vala"
		_g_free0 (_tmp7_);
#line 252 "../src/game-view.vala"
		if (_tmp9_) {
#line 838 "game-view.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 253 "../src/game-view.vala"
			_tmp10_ = svg_path;
#line 253 "../src/game-view.vala"
			_tmp11_ = g_build_filename (_tmp10_, "black_and_white.svg", NULL);
#line 253 "../src/game-view.vala"
			_g_free0 (self->priv->pieces_file);
#line 253 "../src/game-view.vala"
			self->priv->pieces_file = _tmp11_;
#line 849 "game-view.c"
		}
#line 255 "../src/game-view.vala"
		_tmp12_ = g_key_file_get_double (key, "Background", "Red", &_inner_error_);
#line 255 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 255 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 255 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 255 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 861 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 255 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 255 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 255 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 255 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 255 "../src/game-view.vala"
			return;
#line 874 "game-view.c"
		}
#line 255 "../src/game-view.vala"
		self->priv->background_red = _tmp12_;
#line 256 "../src/game-view.vala"
		_tmp13_ = g_key_file_get_double (key, "Background", "Green", &_inner_error_);
#line 256 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 256 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 256 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 256 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 888 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 256 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 256 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 256 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 256 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 256 "../src/game-view.vala"
			return;
#line 901 "game-view.c"
		}
#line 256 "../src/game-view.vala"
		self->priv->background_green = _tmp13_;
#line 257 "../src/game-view.vala"
		_tmp14_ = g_key_file_get_double (key, "Background", "Blue", &_inner_error_);
#line 257 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 257 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 257 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 257 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 915 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 257 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 257 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 257 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 257 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 257 "../src/game-view.vala"
			return;
#line 928 "game-view.c"
		}
#line 257 "../src/game-view.vala"
		self->priv->background_blue = _tmp14_;
#line 258 "../src/game-view.vala"
		_tmp15_ = g_key_file_get_integer (key, "Background", "Radius", &_inner_error_);
#line 258 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 258 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 258 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 258 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 942 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 258 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 258 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 258 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 258 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 258 "../src/game-view.vala"
			return;
#line 955 "game-view.c"
		}
#line 258 "../src/game-view.vala"
		self->priv->background_radius = _tmp15_;
#line 260 "../src/game-view.vala"
		_tmp16_ = g_key_file_get_double (key, "Background", "TextureAlpha", &_inner_error_);
#line 260 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 260 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 260 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 260 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 969 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 260 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 260 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 260 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 260 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 260 "../src/game-view.vala"
			return;
#line 982 "game-view.c"
		}
#line 260 "../src/game-view.vala"
		self->priv->texture_alpha = _tmp16_;
#line 261 "../src/game-view.vala"
		if (self->priv->texture_alpha > 0.0) {
#line 261 "../src/game-view.vala"
			_tmp17_ = self->priv->texture_alpha <= 1.0;
#line 990 "game-view.c"
		} else {
#line 261 "../src/game-view.vala"
			_tmp17_ = FALSE;
#line 994 "game-view.c"
		}
#line 261 "../src/game-view.vala"
		self->priv->apply_texture = _tmp17_;
#line 263 "../src/game-view.vala"
		_tmp18_ = g_key_file_get_double (key, "Mark", "Red", &_inner_error_);
#line 263 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 263 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 263 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 263 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1008 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 263 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 263 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 263 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 263 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 263 "../src/game-view.vala"
			return;
#line 1021 "game-view.c"
		}
#line 263 "../src/game-view.vala"
		self->priv->mark_red = _tmp18_;
#line 264 "../src/game-view.vala"
		_tmp19_ = g_key_file_get_double (key, "Mark", "Green", &_inner_error_);
#line 264 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 264 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 264 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 264 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1035 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 264 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 264 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 264 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 264 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 264 "../src/game-view.vala"
			return;
#line 1048 "game-view.c"
		}
#line 264 "../src/game-view.vala"
		self->priv->mark_green = _tmp19_;
#line 265 "../src/game-view.vala"
		_tmp20_ = g_key_file_get_double (key, "Mark", "Blue", &_inner_error_);
#line 265 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 265 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 265 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 265 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1062 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 265 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 265 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 265 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 265 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 265 "../src/game-view.vala"
			return;
#line 1075 "game-view.c"
		}
#line 265 "../src/game-view.vala"
		self->priv->mark_blue = _tmp20_;
#line 266 "../src/game-view.vala"
		_tmp21_ = g_key_file_get_integer (key, "Mark", "Width", &_inner_error_);
#line 266 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 266 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 266 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 266 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1089 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 266 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 266 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 266 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 266 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 266 "../src/game-view.vala"
			return;
#line 1102 "game-view.c"
		}
#line 266 "../src/game-view.vala"
		self->priv->mark_width = _tmp21_;
#line 268 "../src/game-view.vala"
		_tmp22_ = g_key_file_get_double (key, "Border", "Red", &_inner_error_);
#line 268 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 268 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 268 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 268 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1116 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 268 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 268 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 268 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 268 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 268 "../src/game-view.vala"
			return;
#line 1129 "game-view.c"
		}
#line 268 "../src/game-view.vala"
		self->priv->border_red = _tmp22_;
#line 269 "../src/game-view.vala"
		_tmp23_ = g_key_file_get_double (key, "Border", "Green", &_inner_error_);
#line 269 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 269 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 269 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 269 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1143 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 269 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 269 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 269 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 269 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 269 "../src/game-view.vala"
			return;
#line 1156 "game-view.c"
		}
#line 269 "../src/game-view.vala"
		self->priv->border_green = _tmp23_;
#line 270 "../src/game-view.vala"
		_tmp24_ = g_key_file_get_double (key, "Border", "Blue", &_inner_error_);
#line 270 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 270 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 270 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 270 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1170 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 270 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 270 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 270 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 270 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 270 "../src/game-view.vala"
			return;
#line 1183 "game-view.c"
		}
#line 270 "../src/game-view.vala"
		self->priv->border_blue = _tmp24_;
#line 271 "../src/game-view.vala"
		_tmp25_ = g_key_file_get_integer (key, "Border", "Width", &_inner_error_);
#line 271 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 271 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 271 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 271 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1197 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 271 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 271 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 271 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 271 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 271 "../src/game-view.vala"
			return;
#line 1210 "game-view.c"
		}
#line 271 "../src/game-view.vala"
		self->priv->border_width = _tmp25_;
#line 272 "../src/game-view.vala"
		self->priv->half_border_width = ((gdouble) self->priv->border_width) / 2.0;
#line 274 "../src/game-view.vala"
		_tmp26_ = g_key_file_get_double (key, "Spacing", "Red", &_inner_error_);
#line 274 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 274 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 274 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 274 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1226 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 274 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 274 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 274 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 274 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 274 "../src/game-view.vala"
			return;
#line 1239 "game-view.c"
		}
#line 274 "../src/game-view.vala"
		self->priv->spacing_red = _tmp26_;
#line 275 "../src/game-view.vala"
		_tmp27_ = g_key_file_get_double (key, "Spacing", "Green", &_inner_error_);
#line 275 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 275 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 275 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 275 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1253 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 275 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 275 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 275 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 275 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 275 "../src/game-view.vala"
			return;
#line 1266 "game-view.c"
		}
#line 275 "../src/game-view.vala"
		self->priv->spacing_green = _tmp27_;
#line 276 "../src/game-view.vala"
		_tmp28_ = g_key_file_get_double (key, "Spacing", "Blue", &_inner_error_);
#line 276 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 276 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 276 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 276 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1280 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 276 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 276 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 276 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 276 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 276 "../src/game-view.vala"
			return;
#line 1293 "game-view.c"
		}
#line 276 "../src/game-view.vala"
		self->priv->spacing_blue = _tmp28_;
#line 277 "../src/game-view.vala"
		_tmp29_ = g_key_file_get_integer (key, "Spacing", "Width", &_inner_error_);
#line 277 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 277 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 277 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 277 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1307 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 277 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 277 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 277 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 277 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 277 "../src/game-view.vala"
			return;
#line 1320 "game-view.c"
		}
#line 277 "../src/game-view.vala"
		self->priv->spacing_width = _tmp29_;
#line 279 "../src/game-view.vala"
		_tmp30_ = g_key_file_get_double (key, "Highlight hard", "Red", &_inner_error_);
#line 279 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 279 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 279 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 279 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1334 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 279 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 279 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 279 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 279 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 279 "../src/game-view.vala"
			return;
#line 1347 "game-view.c"
		}
#line 279 "../src/game-view.vala"
		self->priv->highlight_hard_red = _tmp30_;
#line 280 "../src/game-view.vala"
		_tmp31_ = g_key_file_get_double (key, "Highlight hard", "Green", &_inner_error_);
#line 280 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 280 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 280 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 280 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1361 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 280 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 280 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 280 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 280 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 280 "../src/game-view.vala"
			return;
#line 1374 "game-view.c"
		}
#line 280 "../src/game-view.vala"
		self->priv->highlight_hard_green = _tmp31_;
#line 281 "../src/game-view.vala"
		_tmp32_ = g_key_file_get_double (key, "Highlight hard", "Blue", &_inner_error_);
#line 281 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 281 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 281 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 281 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1388 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 281 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 281 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 281 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 281 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 281 "../src/game-view.vala"
			return;
#line 1401 "game-view.c"
		}
#line 281 "../src/game-view.vala"
		self->priv->highlight_hard_blue = _tmp32_;
#line 282 "../src/game-view.vala"
		_tmp33_ = g_key_file_get_double (key, "Highlight hard", "Alpha", &_inner_error_);
#line 282 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 282 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 282 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 282 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1415 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 282 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 282 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 282 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 282 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 282 "../src/game-view.vala"
			return;
#line 1428 "game-view.c"
		}
#line 282 "../src/game-view.vala"
		self->priv->highlight_hard_alpha = _tmp33_;
#line 284 "../src/game-view.vala"
		_tmp34_ = g_key_file_get_double (key, "Highlight soft", "Red", &_inner_error_);
#line 284 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 284 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 284 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 284 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1442 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 284 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 284 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 284 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 284 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 284 "../src/game-view.vala"
			return;
#line 1455 "game-view.c"
		}
#line 284 "../src/game-view.vala"
		self->priv->highlight_soft_red = _tmp34_;
#line 285 "../src/game-view.vala"
		_tmp35_ = g_key_file_get_double (key, "Highlight soft", "Green", &_inner_error_);
#line 285 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 285 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 285 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 285 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1469 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 285 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 285 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 285 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 285 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 285 "../src/game-view.vala"
			return;
#line 1482 "game-view.c"
		}
#line 285 "../src/game-view.vala"
		self->priv->highlight_soft_green = _tmp35_;
#line 286 "../src/game-view.vala"
		_tmp36_ = g_key_file_get_double (key, "Highlight soft", "Blue", &_inner_error_);
#line 286 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 286 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 286 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 286 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1496 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 286 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 286 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 286 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 286 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 286 "../src/game-view.vala"
			return;
#line 1509 "game-view.c"
		}
#line 286 "../src/game-view.vala"
		self->priv->highlight_soft_blue = _tmp36_;
#line 287 "../src/game-view.vala"
		_tmp37_ = g_key_file_get_double (key, "Highlight soft", "Alpha", &_inner_error_);
#line 287 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 287 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 287 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 287 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1523 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 287 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 287 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 287 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 287 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 287 "../src/game-view.vala"
			return;
#line 1536 "game-view.c"
		}
#line 287 "../src/game-view.vala"
		self->priv->highlight_soft_alpha = _tmp37_;
#line 291 "../src/game-view.vala"
		_tmp39_ = g_key_file_get_string (key, "Sound", "Flip", &_inner_error_);
#line 291 "../src/game-view.vala"
		_tmp38_ = _tmp39_;
#line 291 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 291 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 291 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 291 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1552 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 291 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 291 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 291 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 291 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 291 "../src/game-view.vala"
			return;
#line 1565 "game-view.c"
		}
#line 291 "../src/game-view.vala"
		game_view_set_sound_flip (self, _tmp38_);
#line 292 "../src/game-view.vala"
		_tmp41_ = g_key_file_get_string (key, "Sound", "GameOver", &_inner_error_);
#line 292 "../src/game-view.vala"
		_tmp40_ = _tmp41_;
#line 292 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 292 "../src/game-view.vala"
			_g_free0 (_tmp38_);
#line 292 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 292 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 292 "../src/game-view.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1583 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 292 "../src/game-view.vala"
			_g_free0 (_tmp38_);
#line 292 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 292 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 292 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 292 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 292 "../src/game-view.vala"
			return;
#line 1598 "game-view.c"
		}
#line 292 "../src/game-view.vala"
		game_view_set_sound_gameover (self, _tmp40_);
#line 248 "../src/game-view.vala"
		_g_free0 (_tmp40_);
#line 248 "../src/game-view.vala"
		_g_free0 (_tmp38_);
#line 248 "../src/game-view.vala"
		_g_free0 (_tmp1_);
#line 248 "../src/game-view.vala"
		_g_free0 (svg_path);
#line 1610 "game-view.c"
	}
	goto __finally1;
	__catch1_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp42_;
		const gchar* _tmp43_;
#line 248 "../src/game-view.vala"
		e = _inner_error_;
#line 248 "../src/game-view.vala"
		_inner_error_ = NULL;
#line 296 "../src/game-view.vala"
		_tmp42_ = e;
#line 296 "../src/game-view.vala"
		_tmp43_ = _tmp42_->message;
#line 296 "../src/game-view.vala"
		g_warning ("game-view.vala:296: Errors when loading theme: %s", _tmp43_);
#line 248 "../src/game-view.vala"
		_g_error_free0 (e);
#line 1630 "game-view.c"
	}
	__finally1:
#line 248 "../src/game-view.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 248 "../src/game-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 248 "../src/game-view.vala"
		g_clear_error (&_inner_error_);
#line 248 "../src/game-view.vala"
		return;
#line 1641 "game-view.c"
	}
}

static inline void
game_view_calculate (GameView* self)
{
	gint allocated_width = 0;
	gint allocated_height = 0;
	gint size = 0;
#line 310 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 310 "../src/game-view.vala"
	_vala_return_if_fail (self->priv->game_is_set, "game_is_set");
#line 313 "../src/game-view.vala"
	allocated_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 314 "../src/game-view.vala"
	allocated_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 315 "../src/game-view.vala"
	size = MIN (allocated_width, allocated_height);
#line 316 "../src/game-view.vala"
	self->priv->paving_size = ((size - (2 * self->priv->border_width)) + self->priv->spacing_width) / self->priv->game_size;
#line 317 "../src/game-view.vala"
	self->priv->tile_size = self->priv->paving_size - self->priv->spacing_width;
#line 318 "../src/game-view.vala"
	self->priv->board_size = ((self->priv->paving_size * self->priv->game_size) - self->priv->spacing_width) + (2 * self->priv->border_width);
#line 319 "../src/game-view.vala"
	self->priv->board_x = ((allocated_width - self->priv->board_size) / 2) + self->priv->border_width;
#line 320 "../src/game-view.vala"
	self->priv->board_y = ((allocated_height - self->priv->board_size) / 2) + self->priv->border_width;
#line 1671 "game-view.c"
	{
		guint8 x = 0U;
#line 322 "../src/game-view.vala"
		x = (guint8) 0;
#line 1676 "game-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 322 "../src/game-view.vala"
			_tmp0_ = TRUE;
#line 322 "../src/game-view.vala"
			while (TRUE) {
#line 322 "../src/game-view.vala"
				if (!_tmp0_) {
#line 1685 "game-view.c"
					guint8 _tmp1_;
#line 322 "../src/game-view.vala"
					_tmp1_ = x;
#line 322 "../src/game-view.vala"
					x = _tmp1_ + 1;
#line 1691 "game-view.c"
				}
#line 322 "../src/game-view.vala"
				_tmp0_ = FALSE;
#line 322 "../src/game-view.vala"
				if (!(x < self->priv->game_size)) {
#line 322 "../src/game-view.vala"
					break;
#line 1699 "game-view.c"
				}
				{
					guint8 y = 0U;
#line 324 "../src/game-view.vala"
					y = (guint8) 0;
#line 1705 "game-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 324 "../src/game-view.vala"
						_tmp2_ = TRUE;
#line 324 "../src/game-view.vala"
						while (TRUE) {
#line 1712 "game-view.c"
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
#line 324 "../src/game-view.vala"
							if (!_tmp2_) {
#line 1721 "game-view.c"
								guint8 _tmp3_;
#line 324 "../src/game-view.vala"
								_tmp3_ = y;
#line 324 "../src/game-view.vala"
								y = _tmp3_ + 1;
#line 1727 "game-view.c"
							}
#line 324 "../src/game-view.vala"
							_tmp2_ = FALSE;
#line 324 "../src/game-view.vala"
							if (!(y < self->priv->game_size)) {
#line 324 "../src/game-view.vala"
								break;
#line 1735 "game-view.c"
							}
#line 326 "../src/game-view.vala"
							_tmp4_ = self->priv->tile_xs;
#line 326 "../src/game-view.vala"
							_tmp4__length1 = self->priv->tile_xs_length1;
#line 326 "../src/game-view.vala"
							_tmp4__length2 = self->priv->tile_xs_length2;
#line 326 "../src/game-view.vala"
							_tmp4_[(x * _tmp4__length2) + y] = self->priv->paving_size * ((gint) x);
#line 327 "../src/game-view.vala"
							_tmp5_ = self->priv->tile_ys;
#line 327 "../src/game-view.vala"
							_tmp5__length1 = self->priv->tile_ys_length1;
#line 327 "../src/game-view.vala"
							_tmp5__length2 = self->priv->tile_ys_length2;
#line 327 "../src/game-view.vala"
							_tmp5_[(x * _tmp5__length2) + y] = self->priv->paving_size * ((gint) y);
#line 1753 "game-view.c"
						}
					}
				}
			}
		}
	}
}

static gboolean
game_view_real_draw (GtkWidget* base,
                     cairo_t* cr)
{
	GameView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp4_;
#line 332 "../src/game-view.vala"
	self = (GameView*) base;
#line 332 "../src/game-view.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 334 "../src/game-view.vala"
	if (!self->priv->game_is_set) {
#line 335 "../src/game-view.vala"
		result = FALSE;
#line 335 "../src/game-view.vala"
		return result;
#line 1782 "game-view.c"
	}
#line 338 "../src/game-view.vala"
	game_view_calculate (self);
#line 340 "../src/game-view.vala"
	_tmp2_ = self->priv->board_pattern;
#line 340 "../src/game-view.vala"
	if (_tmp2_ == NULL) {
#line 340 "../src/game-view.vala"
		_tmp1_ = TRUE;
#line 1792 "game-view.c"
	} else {
		cairo_pattern_t* _tmp3_;
#line 340 "../src/game-view.vala"
		_tmp3_ = self->priv->tiles_pattern;
#line 340 "../src/game-view.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 1799 "game-view.c"
	}
#line 340 "../src/game-view.vala"
	if (_tmp1_) {
#line 340 "../src/game-view.vala"
		_tmp0_ = TRUE;
#line 1805 "game-view.c"
	} else {
#line 340 "../src/game-view.vala"
		_tmp0_ = self->priv->render_size != ((guint) self->priv->tile_size);
#line 1809 "game-view.c"
	}
#line 340 "../src/game-view.vala"
	if (_tmp0_) {
#line 341 "../src/game-view.vala"
		game_view_init_patterns (self, cr);
#line 1815 "game-view.c"
	}
#line 344 "../src/game-view.vala"
	cairo_translate (cr, (gdouble) (self->priv->board_x - self->priv->border_width), (gdouble) (self->priv->board_y - self->priv->border_width));
#line 346 "../src/game-view.vala"
	_tmp4_ = self->priv->board_pattern;
#line 346 "../src/game-view.vala"
	cairo_set_source (cr, (cairo_pattern_t*) _tmp4_);
#line 347 "../src/game-view.vala"
	cairo_rectangle (cr, (gdouble) 0, (gdouble) 0, (gdouble) self->priv->board_size, (gdouble) self->priv->board_size);
#line 348 "../src/game-view.vala"
	cairo_fill (cr);
#line 351 "../src/game-view.vala"
	cairo_translate (cr, (gdouble) self->priv->border_width, (gdouble) self->priv->border_width);
#line 353 "../src/game-view.vala"
	game_view_draw_highlight (self, cr);
#line 354 "../src/game-view.vala"
	game_view_add_highlights (self, cr);
#line 355 "../src/game-view.vala"
	game_view_draw_playables (self, cr);
#line 357 "../src/game-view.vala"
	result = FALSE;
#line 357 "../src/game-view.vala"
	return result;
#line 1839 "game-view.c"
}

static inline void
game_view_init_patterns (GameView* self,
                         cairo_t* cr)
{
	cairo_surface_t* surface = NULL;
	cairo_t* context = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
	cairo_t* _tmp3_;
	cairo_t* _tmp4_;
	cairo_surface_t* _tmp5_;
	cairo_pattern_t* _tmp6_;
	GdkPixbuf* noise_pixbuf = NULL;
	cairo_pattern_t* noise_pattern = NULL;
	cairo_surface_t* _tmp22_;
	cairo_surface_t* _tmp23_;
	cairo_surface_t* _tmp24_;
	cairo_t* _tmp25_;
	cairo_t* _tmp26_;
	cairo_t* _tmp27_;
	cairo_surface_t* _tmp28_;
	cairo_pattern_t* _tmp29_;
	GError * _inner_error_ = NULL;
#line 360 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 360 "../src/game-view.vala"
	g_return_if_fail (cr != NULL);
#line 362 "../src/game-view.vala"
	self->priv->render_size = (guint) self->priv->tile_size;
#line 368 "../src/game-view.vala"
	_tmp0_ = cairo_get_target (cr);
#line 368 "../src/game-view.vala"
	_tmp1_ = cairo_surface_create_similar (_tmp0_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->tile_size * 8, self->priv->tile_size * 4);
#line 368 "../src/game-view.vala"
	_cairo_surface_destroy0 (surface);
#line 368 "../src/game-view.vala"
	surface = _tmp1_;
#line 370 "../src/game-view.vala"
	_tmp2_ = surface;
#line 370 "../src/game-view.vala"
	_tmp3_ = cairo_create (_tmp2_);
#line 370 "../src/game-view.vala"
	_cairo_destroy0 (context);
#line 370 "../src/game-view.vala"
	context = _tmp3_;
#line 371 "../src/game-view.vala"
	_tmp4_ = context;
#line 371 "../src/game-view.vala"
	game_view_load_image (self, _tmp4_, self->priv->tile_size * 8, self->priv->tile_size * 4);
#line 372 "../src/game-view.vala"
	_tmp5_ = surface;
#line 372 "../src/game-view.vala"
	_tmp6_ = cairo_pattern_create_for_surface (_tmp5_);
#line 372 "../src/game-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 372 "../src/game-view.vala"
	self->priv->tiles_pattern = _tmp6_;
#line 375 "../src/game-view.vala"
	noise_pixbuf = NULL;
#line 376 "../src/game-view.vala"
	noise_pattern = NULL;
#line 378 "../src/game-view.vala"
	if (self->priv->apply_texture) {
#line 1906 "game-view.c"
		GdkPixbuf* _tmp12_;
		{
			GdkPixbuf* _tmp7_ = NULL;
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
#line 382 "../src/game-view.vala"
			_tmp8_ = gdk_pixbuf_new_from_resource_at_scale ("/org/gnome/Reversi/ui/noise.png", self->priv->tile_size, self->priv->tile_size, FALSE, &_inner_error_);
#line 382 "../src/game-view.vala"
			_tmp7_ = _tmp8_;
#line 382 "../src/game-view.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1918 "game-view.c"
				goto __catch2_g_error;
			}
#line 382 "../src/game-view.vala"
			_tmp9_ = _tmp7_;
#line 382 "../src/game-view.vala"
			_tmp7_ = NULL;
#line 382 "../src/game-view.vala"
			_g_object_unref0 (noise_pixbuf);
#line 382 "../src/game-view.vala"
			noise_pixbuf = _tmp9_;
#line 380 "../src/game-view.vala"
			_g_object_unref0 (_tmp7_);
#line 1931 "game-view.c"
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			GError* _tmp10_;
			const gchar* _tmp11_;
#line 380 "../src/game-view.vala"
			e = _inner_error_;
#line 380 "../src/game-view.vala"
			_inner_error_ = NULL;
#line 386 "../src/game-view.vala"
			_tmp10_ = e;
#line 386 "../src/game-view.vala"
			_tmp11_ = _tmp10_->message;
#line 386 "../src/game-view.vala"
			g_warning ("game-view.vala:386: %s", _tmp11_);
#line 380 "../src/game-view.vala"
			_g_error_free0 (e);
#line 1951 "game-view.c"
		}
		__finally2:
#line 380 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 380 "../src/game-view.vala"
			_cairo_pattern_destroy0 (noise_pattern);
#line 380 "../src/game-view.vala"
			_g_object_unref0 (noise_pixbuf);
#line 380 "../src/game-view.vala"
			_cairo_destroy0 (context);
#line 380 "../src/game-view.vala"
			_cairo_surface_destroy0 (surface);
#line 380 "../src/game-view.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 380 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 380 "../src/game-view.vala"
			return;
#line 1970 "game-view.c"
		}
#line 387 "../src/game-view.vala"
		_tmp12_ = noise_pixbuf;
#line 387 "../src/game-view.vala"
		self->priv->noise_pixbuf_loaded = _tmp12_ != NULL;
#line 388 "../src/game-view.vala"
		if (self->priv->noise_pixbuf_loaded) {
#line 1978 "game-view.c"
			cairo_surface_t* _tmp13_;
			cairo_surface_t* _tmp14_;
			cairo_surface_t* _tmp15_;
			cairo_t* _tmp16_;
			cairo_t* _tmp17_;
			GdkPixbuf* _tmp18_;
			cairo_t* _tmp19_;
			cairo_surface_t* _tmp20_;
			cairo_pattern_t* _tmp21_;
#line 390 "../src/game-view.vala"
			_tmp13_ = cairo_get_target (cr);
#line 390 "../src/game-view.vala"
			_tmp14_ = cairo_surface_create_similar (_tmp13_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->tile_size, self->priv->tile_size);
#line 390 "../src/game-view.vala"
			_cairo_surface_destroy0 (surface);
#line 390 "../src/game-view.vala"
			surface = _tmp14_;
#line 392 "../src/game-view.vala"
			_tmp15_ = surface;
#line 392 "../src/game-view.vala"
			_tmp16_ = cairo_create (_tmp15_);
#line 392 "../src/game-view.vala"
			_cairo_destroy0 (context);
#line 392 "../src/game-view.vala"
			context = _tmp16_;
#line 393 "../src/game-view.vala"
			_tmp17_ = context;
#line 393 "../src/game-view.vala"
			_tmp18_ = noise_pixbuf;
#line 393 "../src/game-view.vala"
			gdk_cairo_set_source_pixbuf (_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gdk_pixbuf_get_type (), GdkPixbuf), (gdouble) 0, (gdouble) 0);
#line 394 "../src/game-view.vala"
			_tmp19_ = context;
#line 394 "../src/game-view.vala"
			cairo_paint_with_alpha (_tmp19_, self->priv->texture_alpha);
#line 397 "../src/game-view.vala"
			_tmp20_ = surface;
#line 397 "../src/game-view.vala"
			_tmp21_ = cairo_pattern_create_for_surface (_tmp20_);
#line 397 "../src/game-view.vala"
			_cairo_pattern_destroy0 (noise_pattern);
#line 397 "../src/game-view.vala"
			noise_pattern = _tmp21_;
#line 2022 "game-view.c"
		}
	}
#line 403 "../src/game-view.vala"
	_tmp22_ = cairo_get_target (cr);
#line 403 "../src/game-view.vala"
	_tmp23_ = cairo_surface_create_similar (_tmp22_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->board_size, self->priv->board_size);
#line 403 "../src/game-view.vala"
	_cairo_surface_destroy0 (surface);
#line 403 "../src/game-view.vala"
	surface = _tmp23_;
#line 405 "../src/game-view.vala"
	_tmp24_ = surface;
#line 405 "../src/game-view.vala"
	_tmp25_ = cairo_create (_tmp24_);
#line 405 "../src/game-view.vala"
	_cairo_destroy0 (context);
#line 405 "../src/game-view.vala"
	context = _tmp25_;
#line 407 "../src/game-view.vala"
	_tmp26_ = context;
#line 407 "../src/game-view.vala"
	game_view_draw_board_background (self, _tmp26_);
#line 408 "../src/game-view.vala"
	_tmp27_ = context;
#line 408 "../src/game-view.vala"
	game_view_draw_tiles_background (self, _tmp27_, &noise_pattern);
#line 410 "../src/game-view.vala"
	_tmp28_ = surface;
#line 410 "../src/game-view.vala"
	_tmp29_ = cairo_pattern_create_for_surface (_tmp28_);
#line 410 "../src/game-view.vala"
	_cairo_pattern_destroy0 (self->priv->board_pattern);
#line 410 "../src/game-view.vala"
	self->priv->board_pattern = _tmp29_;
#line 360 "../src/game-view.vala"
	_cairo_pattern_destroy0 (noise_pattern);
#line 360 "../src/game-view.vala"
	_g_object_unref0 (noise_pixbuf);
#line 360 "../src/game-view.vala"
	_cairo_destroy0 (context);
#line 360 "../src/game-view.vala"
	_cairo_surface_destroy0 (surface);
#line 2065 "game-view.c"
}

static inline void
game_view_draw_board_background (GameView* self,
                                 cairo_t* cr)
{
#line 413 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 413 "../src/game-view.vala"
	g_return_if_fail (cr != NULL);
#line 415 "../src/game-view.vala"
	cairo_set_source_rgba (cr, self->priv->spacing_red, self->priv->spacing_green, self->priv->spacing_blue, 1.0);
#line 416 "../src/game-view.vala"
	cairo_rectangle (cr, self->priv->half_border_width, self->priv->half_border_width, (gdouble) (self->priv->board_size - self->priv->border_width), (gdouble) (self->priv->board_size - self->priv->border_width));
#line 417 "../src/game-view.vala"
	cairo_fill_preserve (cr);
#line 418 "../src/game-view.vala"
	cairo_set_source_rgba (cr, self->priv->border_red, self->priv->border_green, self->priv->border_blue, 1.0);
#line 419 "../src/game-view.vala"
	cairo_set_line_width (cr, (gdouble) self->priv->border_width);
#line 420 "../src/game-view.vala"
	cairo_stroke (cr);
#line 2088 "game-view.c"
}

static inline void
game_view_draw_tiles_background (GameView* self,
                                 cairo_t* cr,
                                 cairo_pattern_t* * noise_pattern)
{
#line 423 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 423 "../src/game-view.vala"
	g_return_if_fail (cr != NULL);
#line 425 "../src/game-view.vala"
	cairo_translate (cr, (gdouble) self->priv->border_width, (gdouble) self->priv->border_width);
#line 2102 "game-view.c"
	{
		guint8 x = 0U;
#line 427 "../src/game-view.vala"
		x = (guint8) 0;
#line 2107 "game-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 427 "../src/game-view.vala"
			_tmp0_ = TRUE;
#line 427 "../src/game-view.vala"
			while (TRUE) {
#line 427 "../src/game-view.vala"
				if (!_tmp0_) {
#line 2116 "game-view.c"
					guint8 _tmp1_;
#line 427 "../src/game-view.vala"
					_tmp1_ = x;
#line 427 "../src/game-view.vala"
					x = _tmp1_ + 1;
#line 2122 "game-view.c"
				}
#line 427 "../src/game-view.vala"
				_tmp0_ = FALSE;
#line 427 "../src/game-view.vala"
				if (!(x < self->priv->game_size)) {
#line 427 "../src/game-view.vala"
					break;
#line 2130 "game-view.c"
				}
				{
					guint8 y = 0U;
#line 428 "../src/game-view.vala"
					y = (guint8) 0;
#line 2136 "game-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 428 "../src/game-view.vala"
						_tmp2_ = TRUE;
#line 428 "../src/game-view.vala"
						while (TRUE) {
#line 2143 "game-view.c"
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint _tmp5_;
							gint* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							gint _tmp7_;
#line 428 "../src/game-view.vala"
							if (!_tmp2_) {
#line 2154 "game-view.c"
								guint8 _tmp3_;
#line 428 "../src/game-view.vala"
								_tmp3_ = y;
#line 428 "../src/game-view.vala"
								y = _tmp3_ + 1;
#line 2160 "game-view.c"
							}
#line 428 "../src/game-view.vala"
							_tmp2_ = FALSE;
#line 428 "../src/game-view.vala"
							if (!(y < self->priv->game_size)) {
#line 428 "../src/game-view.vala"
								break;
#line 2168 "game-view.c"
							}
#line 429 "../src/game-view.vala"
							_tmp4_ = self->priv->tile_xs;
#line 429 "../src/game-view.vala"
							_tmp4__length1 = self->priv->tile_xs_length1;
#line 429 "../src/game-view.vala"
							_tmp4__length2 = self->priv->tile_xs_length2;
#line 429 "../src/game-view.vala"
							_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
#line 429 "../src/game-view.vala"
							_tmp6_ = self->priv->tile_ys;
#line 429 "../src/game-view.vala"
							_tmp6__length1 = self->priv->tile_ys_length1;
#line 429 "../src/game-view.vala"
							_tmp6__length2 = self->priv->tile_ys_length2;
#line 429 "../src/game-view.vala"
							_tmp7_ = _tmp6_[(x * _tmp6__length2) + y];
#line 429 "../src/game-view.vala"
							game_view_draw_tile_background (self, cr, noise_pattern, _tmp5_, _tmp7_);
#line 2188 "game-view.c"
						}
					}
				}
			}
		}
	}
}

static inline void
game_view_draw_tile_background (GameView* self,
                                cairo_t* cr,
                                cairo_pattern_t* * noise_pattern,
                                gint tile_x,
                                gint tile_y)
{
	gboolean _tmp0_ = FALSE;
#line 431 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 431 "../src/game-view.vala"
	g_return_if_fail (cr != NULL);
#line 433 "../src/game-view.vala"
	cairo_set_source_rgba (cr, self->priv->background_red, self->priv->background_green, self->priv->background_blue, 1.0);
#line 434 "../src/game-view.vala"
	game_view_rounded_square (self, cr, (gdouble) tile_x, (gdouble) tile_y, self->priv->tile_size, (gdouble) 0, (gdouble) self->priv->background_radius);
#line 435 "../src/game-view.vala"
	if (self->priv->apply_texture) {
#line 435 "../src/game-view.vala"
		_tmp0_ = self->priv->noise_pixbuf_loaded;
#line 2217 "game-view.c"
	} else {
#line 435 "../src/game-view.vala"
		_tmp0_ = FALSE;
#line 2221 "game-view.c"
	}
#line 435 "../src/game-view.vala"
	if (_tmp0_) {
#line 2225 "game-view.c"
		cairo_matrix_t matrix = {0};
		cairo_matrix_t _tmp1_;
#line 437 "../src/game-view.vala"
		cairo_fill_preserve (cr);
#line 439 "../src/game-view.vala"
		cairo_matrix_init_identity (&matrix);
#line 440 "../src/game-view.vala"
		cairo_matrix_translate (&matrix, (gdouble) (-tile_x), (gdouble) (-tile_y));
#line 441 "../src/game-view.vala"
		_tmp1_ = matrix;
#line 441 "../src/game-view.vala"
		cairo_pattern_set_matrix ((cairo_pattern_t*) (*noise_pattern), &_tmp1_);
#line 442 "../src/game-view.vala"
		cairo_set_source (cr, (cairo_pattern_t*) (*noise_pattern));
#line 2240 "game-view.c"
	}
#line 444 "../src/game-view.vala"
	cairo_fill (cr);
#line 2244 "game-view.c"
}

static inline void
game_view_draw_highlight (GameView* self,
                          cairo_t* cr)
{
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean display_mouse_highlight = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean display_keybd_highlight = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean display_ghost_highlight = FALSE;
#line 447 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 447 "../src/game-view.vala"
	g_return_if_fail (cr != NULL);
#line 449 "../src/game-view.vala"
	_tmp0_ = game_view_get_game (self);
#line 449 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 449 "../src/game-view.vala"
	_tmp2_ = game_get_is_complete (_tmp1_);
#line 449 "../src/game-view.vala"
	_tmp3_ = _tmp2_;
#line 449 "../src/game-view.vala"
	if (_tmp3_) {
#line 450 "../src/game-view.vala"
		return;
#line 2281 "game-view.c"
	}
#line 452 "../src/game-view.vala"
	if (!self->priv->show_highlight) {
#line 2285 "game-view.c"
		gboolean _tmp6_ = FALSE;
#line 453 "../src/game-view.vala"
		if (self->priv->show_mouse_highlight) {
#line 453 "../src/game-view.vala"
			_tmp6_ = TRUE;
#line 2291 "game-view.c"
		} else {
#line 453 "../src/game-view.vala"
			_tmp6_ = ((gint) self->priv->highlight_state) != 0;
#line 2295 "game-view.c"
		}
#line 453 "../src/game-view.vala"
		_tmp5_ = _tmp6_;
#line 2299 "game-view.c"
	} else {
#line 452 "../src/game-view.vala"
		_tmp5_ = FALSE;
#line 2303 "game-view.c"
	}
#line 452 "../src/game-view.vala"
	if (_tmp5_) {
#line 2307 "game-view.c"
		gboolean _tmp7_ = FALSE;
		Iagno* _tmp8_;
		Player _tmp9_;
		Player _tmp10_;
		Game* _tmp11_;
		Game* _tmp12_;
		Player _tmp13_;
		Player _tmp14_;
#line 455 "../src/game-view.vala"
		_tmp8_ = self->priv->iagno_instance;
#line 455 "../src/game-view.vala"
		_tmp9_ = iagno_get_player_one (_tmp8_);
#line 455 "../src/game-view.vala"
		_tmp10_ = _tmp9_;
#line 455 "../src/game-view.vala"
		_tmp11_ = game_view_get_game (self);
#line 455 "../src/game-view.vala"
		_tmp12_ = _tmp11_;
#line 455 "../src/game-view.vala"
		_tmp13_ = game_get_current_color (_tmp12_);
#line 455 "../src/game-view.vala"
		_tmp14_ = _tmp13_;
#line 455 "../src/game-view.vala"
		if (_tmp10_ == _tmp14_) {
#line 455 "../src/game-view.vala"
			_tmp7_ = TRUE;
#line 2334 "game-view.c"
		} else {
			Iagno* _tmp15_;
			ComputerPlayer* _tmp16_;
			ComputerPlayer* _tmp17_;
#line 455 "../src/game-view.vala"
			_tmp15_ = self->priv->iagno_instance;
#line 455 "../src/game-view.vala"
			_tmp16_ = iagno_get_computer (_tmp15_);
#line 455 "../src/game-view.vala"
			_tmp17_ = _tmp16_;
#line 455 "../src/game-view.vala"
			_tmp7_ = _tmp17_ == NULL;
#line 2347 "game-view.c"
		}
#line 455 "../src/game-view.vala"
		_tmp4_ = _tmp7_;
#line 2351 "game-view.c"
	} else {
#line 452 "../src/game-view.vala"
		_tmp4_ = FALSE;
#line 2355 "game-view.c"
	}
#line 452 "../src/game-view.vala"
	display_mouse_highlight = _tmp4_;
#line 457 "../src/game-view.vala"
	if (self->priv->show_highlight) {
#line 458 "../src/game-view.vala"
		_tmp18_ = !self->priv->show_mouse_highlight;
#line 2363 "game-view.c"
	} else {
#line 457 "../src/game-view.vala"
		_tmp18_ = FALSE;
#line 2367 "game-view.c"
	}
#line 457 "../src/game-view.vala"
	display_keybd_highlight = _tmp18_;
#line 461 "../src/game-view.vala"
	if (!self->priv->show_highlight) {
#line 462 "../src/game-view.vala"
		_tmp22_ = !self->priv->show_mouse_highlight;
#line 2375 "game-view.c"
	} else {
#line 461 "../src/game-view.vala"
		_tmp22_ = FALSE;
#line 2379 "game-view.c"
	}
#line 461 "../src/game-view.vala"
	if (_tmp22_) {
#line 463 "../src/game-view.vala"
		_tmp21_ = ((gint) self->priv->highlight_state) != 0;
#line 2385 "game-view.c"
	} else {
#line 461 "../src/game-view.vala"
		_tmp21_ = FALSE;
#line 2389 "game-view.c"
	}
#line 461 "../src/game-view.vala"
	if (_tmp21_) {
#line 464 "../src/game-view.vala"
		_tmp20_ = self->priv->old_highlight_x != G_MAXUINT8;
#line 2395 "game-view.c"
	} else {
#line 461 "../src/game-view.vala"
		_tmp20_ = FALSE;
#line 2399 "game-view.c"
	}
#line 461 "../src/game-view.vala"
	if (_tmp20_) {
#line 465 "../src/game-view.vala"
		_tmp19_ = self->priv->old_highlight_y != G_MAXUINT8;
#line 2405 "game-view.c"
	} else {
#line 461 "../src/game-view.vala"
		_tmp19_ = FALSE;
#line 2409 "game-view.c"
	}
#line 461 "../src/game-view.vala"
	display_ghost_highlight = _tmp19_;
#line 467 "../src/game-view.vala"
	if (display_ghost_highlight) {
#line 468 "../src/game-view.vala"
		game_view_draw_tile_highlight (self, cr, self->priv->old_highlight_x, self->priv->old_highlight_y);
#line 2417 "game-view.c"
	} else {
#line 469 "../src/game-view.vala"
		if (display_mouse_highlight) {
#line 470 "../src/game-view.vala"
			game_view_draw_tile_highlight (self, cr, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 2423 "game-view.c"
		} else {
#line 471 "../src/game-view.vala"
			if (display_keybd_highlight) {
#line 472 "../src/game-view.vala"
				game_view_draw_tile_highlight (self, cr, self->priv->highlight_x, self->priv->highlight_y);
#line 2429 "game-view.c"
			}
		}
	}
}

static inline void
game_view_draw_tile_highlight (GameView* self,
                               cairo_t* cr,
                               guint8 x,
                               guint8 y)
{
	PossibleMove move = {0};
	gboolean test_placing_tile = FALSE;
	Game* _tmp0_;
	Game* _tmp1_;
	PossibleMove _tmp2_ = {0};
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean highlight_on = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
#line 474 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 474 "../src/game-view.vala"
	g_return_if_fail (cr != NULL);
#line 477 "../src/game-view.vala"
	_tmp0_ = game_view_get_game (self);
#line 477 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 477 "../src/game-view.vala"
	_tmp3_ = game_test_placing_tile (_tmp1_, x, y, &_tmp2_);
#line 477 "../src/game-view.vala"
	move = _tmp2_;
#line 477 "../src/game-view.vala"
	test_placing_tile = _tmp3_;
#line 478 "../src/game-view.vala"
	if (self->priv->show_highlight) {
#line 478 "../src/game-view.vala"
		_tmp4_ = TRUE;
#line 2470 "game-view.c"
	} else {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 478 "../src/game-view.vala"
		if (self->priv->mouse_is_in) {
#line 478 "../src/game-view.vala"
			_tmp6_ = self->priv->show_mouse_highlight;
#line 2478 "game-view.c"
		} else {
#line 478 "../src/game-view.vala"
			_tmp6_ = FALSE;
#line 2482 "game-view.c"
		}
#line 478 "../src/game-view.vala"
		if (_tmp6_) {
#line 478 "../src/game-view.vala"
			_tmp5_ = test_placing_tile;
#line 2488 "game-view.c"
		} else {
#line 478 "../src/game-view.vala"
			_tmp5_ = FALSE;
#line 2492 "game-view.c"
		}
#line 478 "../src/game-view.vala"
		_tmp4_ = _tmp5_;
#line 2496 "game-view.c"
	}
#line 478 "../src/game-view.vala"
	highlight_on = _tmp4_;
#line 481 "../src/game-view.vala"
	if (highlight_on) {
#line 481 "../src/game-view.vala"
		_tmp7_ = self->priv->highlight_state != GAME_VIEW_HIGHLIGHT_MAX;
#line 2504 "game-view.c"
	} else {
#line 481 "../src/game-view.vala"
		_tmp7_ = FALSE;
#line 2508 "game-view.c"
	}
#line 481 "../src/game-view.vala"
	if (_tmp7_) {
#line 2512 "game-view.c"
		guint8 _tmp8_;
#line 483 "../src/game-view.vala"
		_tmp8_ = self->priv->highlight_state;
#line 483 "../src/game-view.vala"
		self->priv->highlight_state = _tmp8_ + 1;
#line 484 "../src/game-view.vala"
		game_view_queue_draw_tile (self, x, y);
#line 2520 "game-view.c"
	} else {
		gboolean _tmp9_ = FALSE;
#line 486 "../src/game-view.vala"
		if (!highlight_on) {
#line 486 "../src/game-view.vala"
			_tmp9_ = ((gint) self->priv->highlight_state) != 0;
#line 2527 "game-view.c"
		} else {
#line 486 "../src/game-view.vala"
			_tmp9_ = FALSE;
#line 2531 "game-view.c"
		}
#line 486 "../src/game-view.vala"
		if (_tmp9_) {
#line 2535 "game-view.c"
			guint8 _tmp10_;
			gboolean _tmp11_ = FALSE;
#line 492 "../src/game-view.vala"
			_tmp10_ = self->priv->highlight_state;
#line 492 "../src/game-view.vala"
			self->priv->highlight_state = _tmp10_ - 1;
#line 493 "../src/game-view.vala"
			game_view_queue_draw_tile (self, x, y);
#line 494 "../src/game-view.vala"
			if (self->priv->old_highlight_x != x) {
#line 494 "../src/game-view.vala"
				_tmp11_ = TRUE;
#line 2548 "game-view.c"
			} else {
#line 494 "../src/game-view.vala"
				_tmp11_ = self->priv->old_highlight_y != y;
#line 2552 "game-view.c"
			}
#line 494 "../src/game-view.vala"
			if (_tmp11_) {
#line 496 "../src/game-view.vala"
				return;
#line 2558 "game-view.c"
			}
		}
	}
#line 498 "../src/game-view.vala"
	game_view_highlight_tile (self, cr, x, y, self->priv->highlight_state, FALSE);
#line 499 "../src/game-view.vala"
	if (test_placing_tile) {
#line 2566 "game-view.c"
		gboolean _tmp14_;
#line 500 "../src/game-view.vala"
		_tmp14_ = self->priv->_show_turnable_tiles;
#line 500 "../src/game-view.vala"
		_tmp13_ = _tmp14_;
#line 2572 "game-view.c"
	} else {
#line 499 "../src/game-view.vala"
		_tmp13_ = FALSE;
#line 2576 "game-view.c"
	}
#line 499 "../src/game-view.vala"
	if (_tmp13_) {
#line 2580 "game-view.c"
		gboolean _tmp15_ = FALSE;
		Iagno* _tmp16_;
		ComputerPlayer* _tmp17_;
		ComputerPlayer* _tmp18_;
#line 501 "../src/game-view.vala"
		_tmp16_ = self->priv->iagno_instance;
#line 501 "../src/game-view.vala"
		_tmp17_ = iagno_get_computer (_tmp16_);
#line 501 "../src/game-view.vala"
		_tmp18_ = _tmp17_;
#line 501 "../src/game-view.vala"
		if (_tmp18_ != NULL) {
#line 2593 "game-view.c"
			Iagno* _tmp19_;
			Player _tmp20_;
			Player _tmp21_;
			Game* _tmp22_;
			Game* _tmp23_;
			Player _tmp24_;
			Player _tmp25_;
#line 501 "../src/game-view.vala"
			_tmp19_ = self->priv->iagno_instance;
#line 501 "../src/game-view.vala"
			_tmp20_ = iagno_get_player_one (_tmp19_);
#line 501 "../src/game-view.vala"
			_tmp21_ = _tmp20_;
#line 501 "../src/game-view.vala"
			_tmp22_ = game_view_get_game (self);
#line 501 "../src/game-view.vala"
			_tmp23_ = _tmp22_;
#line 501 "../src/game-view.vala"
			_tmp24_ = game_get_current_color (_tmp23_);
#line 501 "../src/game-view.vala"
			_tmp25_ = _tmp24_;
#line 501 "../src/game-view.vala"
			_tmp15_ = _tmp21_ != _tmp25_;
#line 2617 "game-view.c"
		} else {
#line 501 "../src/game-view.vala"
			_tmp15_ = FALSE;
#line 2621 "game-view.c"
		}
#line 501 "../src/game-view.vala"
		_tmp12_ = !_tmp15_;
#line 2625 "game-view.c"
	} else {
#line 499 "../src/game-view.vala"
		_tmp12_ = FALSE;
#line 2629 "game-view.c"
	}
#line 499 "../src/game-view.vala"
	if (_tmp12_) {
#line 2633 "game-view.c"
		PossibleMove _tmp26_;
		PossibleMove _tmp27_;
		PossibleMove _tmp28_;
		PossibleMove _tmp29_;
		PossibleMove _tmp30_;
		PossibleMove _tmp31_;
		PossibleMove _tmp32_;
		PossibleMove _tmp33_;
		PossibleMove _tmp34_;
		PossibleMove _tmp35_;
		PossibleMove _tmp36_;
		PossibleMove _tmp37_;
		PossibleMove _tmp38_;
		PossibleMove _tmp39_;
		PossibleMove _tmp40_;
		PossibleMove _tmp41_;
		PossibleMove _tmp42_;
		PossibleMove _tmp43_;
		PossibleMove _tmp44_;
		PossibleMove _tmp45_;
		PossibleMove _tmp46_;
		PossibleMove _tmp47_;
		PossibleMove _tmp48_;
		PossibleMove _tmp49_;
#line 503 "../src/game-view.vala"
		_tmp26_ = move;
#line 503 "../src/game-view.vala"
		_tmp27_ = move;
#line 503 "../src/game-view.vala"
		_tmp28_ = move;
#line 503 "../src/game-view.vala"
		game_view_highlight_turnable_tiles (self, cr, _tmp26_.x, _tmp27_.y, (gint8) 0, (gint8) -1, _tmp28_.n_tiles_n);
#line 504 "../src/game-view.vala"
		_tmp29_ = move;
#line 504 "../src/game-view.vala"
		_tmp30_ = move;
#line 504 "../src/game-view.vala"
		_tmp31_ = move;
#line 504 "../src/game-view.vala"
		game_view_highlight_turnable_tiles (self, cr, _tmp29_.x, _tmp30_.y, (gint8) 1, (gint8) -1, _tmp31_.n_tiles_ne);
#line 505 "../src/game-view.vala"
		_tmp32_ = move;
#line 505 "../src/game-view.vala"
		_tmp33_ = move;
#line 505 "../src/game-view.vala"
		_tmp34_ = move;
#line 505 "../src/game-view.vala"
		game_view_highlight_turnable_tiles (self, cr, _tmp32_.x, _tmp33_.y, (gint8) 1, (gint8) 0, _tmp34_.n_tiles_e);
#line 506 "../src/game-view.vala"
		_tmp35_ = move;
#line 506 "../src/game-view.vala"
		_tmp36_ = move;
#line 506 "../src/game-view.vala"
		_tmp37_ = move;
#line 506 "../src/game-view.vala"
		game_view_highlight_turnable_tiles (self, cr, _tmp35_.x, _tmp36_.y, (gint8) 1, (gint8) 1, _tmp37_.n_tiles_se);
#line 507 "../src/game-view.vala"
		_tmp38_ = move;
#line 507 "../src/game-view.vala"
		_tmp39_ = move;
#line 507 "../src/game-view.vala"
		_tmp40_ = move;
#line 507 "../src/game-view.vala"
		game_view_highlight_turnable_tiles (self, cr, _tmp38_.x, _tmp39_.y, (gint8) 0, (gint8) 1, _tmp40_.n_tiles_s);
#line 508 "../src/game-view.vala"
		_tmp41_ = move;
#line 508 "../src/game-view.vala"
		_tmp42_ = move;
#line 508 "../src/game-view.vala"
		_tmp43_ = move;
#line 508 "../src/game-view.vala"
		game_view_highlight_turnable_tiles (self, cr, _tmp41_.x, _tmp42_.y, (gint8) -1, (gint8) 1, _tmp43_.n_tiles_so);
#line 509 "../src/game-view.vala"
		_tmp44_ = move;
#line 509 "../src/game-view.vala"
		_tmp45_ = move;
#line 509 "../src/game-view.vala"
		_tmp46_ = move;
#line 509 "../src/game-view.vala"
		game_view_highlight_turnable_tiles (self, cr, _tmp44_.x, _tmp45_.y, (gint8) -1, (gint8) 0, _tmp46_.n_tiles_o);
#line 510 "../src/game-view.vala"
		_tmp47_ = move;
#line 510 "../src/game-view.vala"
		_tmp48_ = move;
#line 510 "../src/game-view.vala"
		_tmp49_ = move;
#line 510 "../src/game-view.vala"
		game_view_highlight_turnable_tiles (self, cr, _tmp47_.x, _tmp48_.y, (gint8) -1, (gint8) -1, _tmp49_.n_tiles_no);
#line 2722 "game-view.c"
	}
}

static inline void
game_view_highlight_turnable_tiles (GameView* self,
                                    cairo_t* cr,
                                    guint8 x,
                                    guint8 y,
                                    gint8 x_step,
                                    gint8 y_step,
                                    guint8 count)
{
#line 513 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 513 "../src/game-view.vala"
	g_return_if_fail (cr != NULL);
#line 2739 "game-view.c"
	{
		gboolean _tmp0_ = FALSE;
#line 515 "../src/game-view.vala"
		_tmp0_ = TRUE;
#line 515 "../src/game-view.vala"
		while (TRUE) {
#line 2746 "game-view.c"
			gint8 _x = 0;
			gint8 _y = 0;
#line 515 "../src/game-view.vala"
			if (!_tmp0_) {
#line 2751 "game-view.c"
				guint8 _tmp1_;
#line 515 "../src/game-view.vala"
				_tmp1_ = count;
#line 515 "../src/game-view.vala"
				count = _tmp1_ - 1;
#line 2757 "game-view.c"
			}
#line 515 "../src/game-view.vala"
			_tmp0_ = FALSE;
#line 515 "../src/game-view.vala"
			if (!(((gint) count) > 0)) {
#line 515 "../src/game-view.vala"
				break;
#line 2765 "game-view.c"
			}
#line 517 "../src/game-view.vala"
			_x = ((gint8) x) + (((gint8) count) * x_step);
#line 518 "../src/game-view.vala"
			_y = ((gint8) y) + (((gint8) count) * y_step);
#line 519 "../src/game-view.vala"
			game_view_queue_draw_tile (self, (guint8) _x, (guint8) _y);
#line 520 "../src/game-view.vala"
			game_view_highlight_tile (self, cr, (guint8) _x, (guint8) _y, self->priv->highlight_state, TRUE);
#line 2775 "game-view.c"
		}
	}
}

static inline void
game_view_add_highlights (GameView* self,
                          cairo_t* cr)
{
	gboolean _tmp0_ = FALSE;
	Iagno* _tmp1_;
	ComputerPlayer* _tmp2_;
	ComputerPlayer* _tmp3_;
	gboolean decreasing = FALSE;
	guint8 intensity = 0U;
	gboolean _tmp15_ = FALSE;
#line 524 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 524 "../src/game-view.vala"
	g_return_if_fail (cr != NULL);
#line 526 "../src/game-view.vala"
	if (((gint) self->priv->playable_tiles_highlight_state) == 0) {
#line 527 "../src/game-view.vala"
		return;
#line 2799 "game-view.c"
	}
#line 528 "../src/game-view.vala"
	_tmp1_ = self->priv->iagno_instance;
#line 528 "../src/game-view.vala"
	_tmp2_ = iagno_get_computer (_tmp1_);
#line 528 "../src/game-view.vala"
	_tmp3_ = _tmp2_;
#line 528 "../src/game-view.vala"
	if (_tmp3_ != NULL) {
#line 2809 "game-view.c"
		Iagno* _tmp4_;
		Player _tmp5_;
		Player _tmp6_;
		Game* _tmp7_;
		Game* _tmp8_;
		Player _tmp9_;
		Player _tmp10_;
#line 528 "../src/game-view.vala"
		_tmp4_ = self->priv->iagno_instance;
#line 528 "../src/game-view.vala"
		_tmp5_ = iagno_get_player_one (_tmp4_);
#line 528 "../src/game-view.vala"
		_tmp6_ = _tmp5_;
#line 528 "../src/game-view.vala"
		_tmp7_ = game_view_get_game (self);
#line 528 "../src/game-view.vala"
		_tmp8_ = _tmp7_;
#line 528 "../src/game-view.vala"
		_tmp9_ = game_get_current_color (_tmp8_);
#line 528 "../src/game-view.vala"
		_tmp10_ = _tmp9_;
#line 528 "../src/game-view.vala"
		_tmp0_ = _tmp6_ != _tmp10_;
#line 2833 "game-view.c"
	} else {
#line 528 "../src/game-view.vala"
		_tmp0_ = FALSE;
#line 2837 "game-view.c"
	}
#line 528 "../src/game-view.vala"
	if (_tmp0_) {
#line 530 "../src/game-view.vala"
		game_view_init_possible_moves (self);
#line 531 "../src/game-view.vala"
		return;
#line 2845 "game-view.c"
	}
#line 534 "../src/game-view.vala"
	decreasing = self->priv->playable_tiles_highlight_state > GAME_VIEW_HIGHLIGHT_MAX;
#line 536 "../src/game-view.vala"
	if (decreasing) {
#line 537 "../src/game-view.vala"
		intensity = (guint8) (((2 * GAME_VIEW_HIGHLIGHT_MAX) + 1) - self->priv->playable_tiles_highlight_state);
#line 2853 "game-view.c"
	} else {
#line 539 "../src/game-view.vala"
		intensity = self->priv->playable_tiles_highlight_state;
#line 2857 "game-view.c"
	}
	{
		guint8 x = 0U;
#line 541 "../src/game-view.vala"
		x = (guint8) 0;
#line 2863 "game-view.c"
		{
			gboolean _tmp11_ = FALSE;
#line 541 "../src/game-view.vala"
			_tmp11_ = TRUE;
#line 541 "../src/game-view.vala"
			while (TRUE) {
#line 541 "../src/game-view.vala"
				if (!_tmp11_) {
#line 2872 "game-view.c"
					guint8 _tmp12_;
#line 541 "../src/game-view.vala"
					_tmp12_ = x;
#line 541 "../src/game-view.vala"
					x = _tmp12_ + 1;
#line 2878 "game-view.c"
				}
#line 541 "../src/game-view.vala"
				_tmp11_ = FALSE;
#line 541 "../src/game-view.vala"
				if (!(x < self->priv->game_size)) {
#line 541 "../src/game-view.vala"
					break;
#line 2886 "game-view.c"
				}
				{
					guint8 y = 0U;
#line 542 "../src/game-view.vala"
					y = (guint8) 0;
#line 2892 "game-view.c"
					{
						gboolean _tmp13_ = FALSE;
#line 542 "../src/game-view.vala"
						_tmp13_ = TRUE;
#line 542 "../src/game-view.vala"
						while (TRUE) {
#line 542 "../src/game-view.vala"
							if (!_tmp13_) {
#line 2901 "game-view.c"
								guint8 _tmp14_;
#line 542 "../src/game-view.vala"
								_tmp14_ = y;
#line 542 "../src/game-view.vala"
								y = _tmp14_ + 1;
#line 2907 "game-view.c"
							}
#line 542 "../src/game-view.vala"
							_tmp13_ = FALSE;
#line 542 "../src/game-view.vala"
							if (!(y < self->priv->game_size)) {
#line 542 "../src/game-view.vala"
								break;
#line 2915 "game-view.c"
							}
#line 543 "../src/game-view.vala"
							game_view_add_highlight (self, cr, x, y, intensity);
#line 2919 "game-view.c"
						}
					}
				}
			}
		}
	}
#line 545 "../src/game-view.vala"
	if (decreasing) {
#line 545 "../src/game-view.vala"
		_tmp15_ = ((gint) intensity) == 1;
#line 2930 "game-view.c"
	} else {
#line 545 "../src/game-view.vala"
		_tmp15_ = FALSE;
#line 2934 "game-view.c"
	}
#line 545 "../src/game-view.vala"
	if (_tmp15_) {
#line 546 "../src/game-view.vala"
		game_view_init_possible_moves (self);
#line 2940 "game-view.c"
	} else {
		guint8 _tmp16_;
#line 548 "../src/game-view.vala"
		_tmp16_ = self->priv->playable_tiles_highlight_state;
#line 548 "../src/game-view.vala"
		self->priv->playable_tiles_highlight_state = _tmp16_ + 1;
#line 2947 "game-view.c"
	}
}

static inline void
game_view_add_highlight (GameView* self,
                         cairo_t* cr,
                         guint8 x,
                         guint8 y,
                         guint8 intensity)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gboolean _tmp1_;
#line 550 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 550 "../src/game-view.vala"
	g_return_if_fail (cr != NULL);
#line 552 "../src/game-view.vala"
	_tmp0_ = self->priv->possible_moves;
#line 552 "../src/game-view.vala"
	_tmp0__length1 = self->priv->possible_moves_length1;
#line 552 "../src/game-view.vala"
	_tmp0__length2 = self->priv->possible_moves_length2;
#line 552 "../src/game-view.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 552 "../src/game-view.vala"
	if (_tmp1_ == FALSE) {
#line 553 "../src/game-view.vala"
		return;
#line 2978 "game-view.c"
	}
#line 555 "../src/game-view.vala"
	game_view_queue_draw_tile (self, x, y);
#line 556 "../src/game-view.vala"
	game_view_highlight_tile (self, cr, x, y, intensity, TRUE);
#line 2984 "game-view.c"
}

static inline void
game_view_draw_playables (GameView* self,
                          cairo_t* cr)
{
#line 559 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 559 "../src/game-view.vala"
	g_return_if_fail (cr != NULL);
#line 2995 "game-view.c"
	{
		guint8 x = 0U;
#line 561 "../src/game-view.vala"
		x = (guint8) 0;
#line 3000 "game-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 561 "../src/game-view.vala"
			_tmp0_ = TRUE;
#line 561 "../src/game-view.vala"
			while (TRUE) {
#line 561 "../src/game-view.vala"
				if (!_tmp0_) {
#line 3009 "game-view.c"
					guint8 _tmp1_;
#line 561 "../src/game-view.vala"
					_tmp1_ = x;
#line 561 "../src/game-view.vala"
					x = _tmp1_ + 1;
#line 3015 "game-view.c"
				}
#line 561 "../src/game-view.vala"
				_tmp0_ = FALSE;
#line 561 "../src/game-view.vala"
				if (!(x < self->priv->game_size)) {
#line 561 "../src/game-view.vala"
					break;
#line 3023 "game-view.c"
				}
				{
					guint8 y = 0U;
#line 562 "../src/game-view.vala"
					y = (guint8) 0;
#line 3029 "game-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 562 "../src/game-view.vala"
						_tmp2_ = TRUE;
#line 562 "../src/game-view.vala"
						while (TRUE) {
#line 3036 "game-view.c"
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint _tmp5_;
							gint* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							gint _tmp7_;
							gint* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							gint _tmp9_;
#line 562 "../src/game-view.vala"
							if (!_tmp2_) {
#line 3051 "game-view.c"
								guint8 _tmp3_;
#line 562 "../src/game-view.vala"
								_tmp3_ = y;
#line 562 "../src/game-view.vala"
								y = _tmp3_ + 1;
#line 3057 "game-view.c"
							}
#line 562 "../src/game-view.vala"
							_tmp2_ = FALSE;
#line 562 "../src/game-view.vala"
							if (!(y < self->priv->game_size)) {
#line 562 "../src/game-view.vala"
								break;
#line 3065 "game-view.c"
							}
#line 563 "../src/game-view.vala"
							_tmp4_ = self->priv->pixmaps;
#line 563 "../src/game-view.vala"
							_tmp4__length1 = self->priv->pixmaps_length1;
#line 563 "../src/game-view.vala"
							_tmp4__length2 = self->priv->pixmaps_length2;
#line 563 "../src/game-view.vala"
							_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
#line 563 "../src/game-view.vala"
							_tmp6_ = self->priv->tile_xs;
#line 563 "../src/game-view.vala"
							_tmp6__length1 = self->priv->tile_xs_length1;
#line 563 "../src/game-view.vala"
							_tmp6__length2 = self->priv->tile_xs_length2;
#line 563 "../src/game-view.vala"
							_tmp7_ = _tmp6_[(x * _tmp6__length2) + y];
#line 563 "../src/game-view.vala"
							_tmp8_ = self->priv->tile_ys;
#line 563 "../src/game-view.vala"
							_tmp8__length1 = self->priv->tile_ys_length1;
#line 563 "../src/game-view.vala"
							_tmp8__length2 = self->priv->tile_ys_length2;
#line 563 "../src/game-view.vala"
							_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
#line 563 "../src/game-view.vala"
							game_view_draw_playable (self, cr, _tmp5_, _tmp7_, _tmp9_);
#line 3093 "game-view.c"
						}
					}
				}
			}
		}
	}
}

static inline void
game_view_draw_playable (GameView* self,
                         cairo_t* cr,
                         gint pixmap,
                         gint tile_x,
                         gint tile_y)
{
	cairo_matrix_t matrix = {0};
	cairo_pattern_t* _tmp0_;
	cairo_matrix_t _tmp1_;
	cairo_pattern_t* _tmp2_;
#line 565 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 565 "../src/game-view.vala"
	g_return_if_fail (cr != NULL);
#line 567 "../src/game-view.vala"
	if (pixmap == 0) {
#line 568 "../src/game-view.vala"
		return;
#line 3121 "game-view.c"
	}
#line 570 "../src/game-view.vala"
	cairo_matrix_init_identity (&matrix);
#line 571 "../src/game-view.vala"
	cairo_matrix_translate (&matrix, (gdouble) (((pixmap % 8) * self->priv->tile_size) - tile_x), (gdouble) (((pixmap / 8) * self->priv->tile_size) - tile_y));
#line 573 "../src/game-view.vala"
	_tmp0_ = self->priv->tiles_pattern;
#line 573 "../src/game-view.vala"
	_tmp1_ = matrix;
#line 573 "../src/game-view.vala"
	cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp0_, &_tmp1_);
#line 574 "../src/game-view.vala"
	_tmp2_ = self->priv->tiles_pattern;
#line 574 "../src/game-view.vala"
	cairo_set_source (cr, (cairo_pattern_t*) _tmp2_);
#line 575 "../src/game-view.vala"
	cairo_rectangle (cr, (gdouble) tile_x, (gdouble) tile_y, (gdouble) self->priv->tile_size, (gdouble) self->priv->tile_size);
#line 576 "../src/game-view.vala"
	cairo_fill (cr);
#line 3141 "game-view.c"
}

static void
game_view_rounded_square (GameView* self,
                          cairo_t* cr,
                          gdouble x,
                          gdouble y,
                          gint size,
                          gdouble width,
                          gdouble radius_percent)
{
	gdouble radius_border = 0.0;
	gdouble radius_arc = 0.0;
	gdouble x1 = 0.0;
	gdouble y1 = 0.0;
	gdouble x2 = 0.0;
	gdouble y2 = 0.0;
#line 584 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 584 "../src/game-view.vala"
	g_return_if_fail (cr != NULL);
#line 586 "../src/game-view.vala"
	if (radius_percent <= ((gdouble) 0)) {
#line 588 "../src/game-view.vala"
		cairo_rectangle (cr, x + (width / 2.0), y + (width / 2.0), size + width, size + width);
#line 589 "../src/game-view.vala"
		return;
#line 3169 "game-view.c"
	}
#line 592 "../src/game-view.vala"
	if (radius_percent > ((gdouble) 50)) {
#line 593 "../src/game-view.vala"
		radius_percent = (gdouble) 50;
#line 3175 "game-view.c"
	}
#line 594 "../src/game-view.vala"
	radius_border = (radius_percent * size) / 100.0;
#line 595 "../src/game-view.vala"
	radius_arc = radius_border - (width / 2.0);
#line 596 "../src/game-view.vala"
	x1 = x + radius_border;
#line 597 "../src/game-view.vala"
	y1 = y + radius_border;
#line 598 "../src/game-view.vala"
	x2 = (x + size) - radius_border;
#line 599 "../src/game-view.vala"
	y2 = (y + size) - radius_border;
#line 601 "../src/game-view.vala"
	cairo_arc (cr, x1, y1, radius_arc, G_PI, -GAME_VIEW_HALF_PI);
#line 602 "../src/game-view.vala"
	cairo_arc (cr, x2, y1, radius_arc, -GAME_VIEW_HALF_PI, (gdouble) 0);
#line 603 "../src/game-view.vala"
	cairo_arc (cr, x2, y2, radius_arc, (gdouble) 0, GAME_VIEW_HALF_PI);
#line 604 "../src/game-view.vala"
	cairo_arc (cr, x1, y2, radius_arc, GAME_VIEW_HALF_PI, G_PI);
#line 605 "../src/game-view.vala"
	cairo_arc (cr, x1, y1, radius_arc, G_PI, -GAME_VIEW_HALF_PI);
#line 3199 "game-view.c"
}

static void
game_view_load_image (GameView* self,
                      cairo_t* c,
                      gint width,
                      gint height)
{
	GError * _inner_error_ = NULL;
#line 608 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 608 "../src/game-view.vala"
	g_return_if_fail (c != NULL);
#line 3213 "game-view.c"
	{
		RsvgHandle* h = NULL;
		const gchar* _tmp0_;
		RsvgHandle* _tmp1_;
		cairo_matrix_t m = {0};
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		cairo_matrix_t _tmp6_;
#line 612 "../src/game-view.vala"
		_tmp0_ = self->priv->pieces_file;
#line 612 "../src/game-view.vala"
		_tmp1_ = rsvg_handle_new_from_file (_tmp0_, &_inner_error_);
#line 612 "../src/game-view.vala"
		h = _tmp1_;
#line 612 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3232 "game-view.c"
			goto __catch3_g_error;
		}
#line 614 "../src/game-view.vala"
		cairo_matrix_init_identity (&m);
#line 615 "../src/game-view.vala"
		g_object_get (h, "width", &_tmp2_, NULL);
#line 615 "../src/game-view.vala"
		_tmp3_ = _tmp2_;
#line 615 "../src/game-view.vala"
		g_object_get (h, "height", &_tmp4_, NULL);
#line 615 "../src/game-view.vala"
		_tmp5_ = _tmp4_;
#line 615 "../src/game-view.vala"
		cairo_matrix_scale (&m, ((gdouble) width) / _tmp3_, ((gdouble) height) / _tmp5_);
#line 616 "../src/game-view.vala"
		_tmp6_ = m;
#line 616 "../src/game-view.vala"
		cairo_set_matrix (c, &_tmp6_);
#line 617 "../src/game-view.vala"
		rsvg_handle_render_cairo (h, c);
#line 619 "../src/game-view.vala"
		_g_object_unref0 (h);
#line 619 "../src/game-view.vala"
		return;
#line 3257 "game-view.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
#line 610 "../src/game-view.vala"
		e = _inner_error_;
#line 610 "../src/game-view.vala"
		_inner_error_ = NULL;
#line 610 "../src/game-view.vala"
		_g_error_free0 (e);
#line 3269 "game-view.c"
	}
	__finally3:
#line 610 "../src/game-view.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 610 "../src/game-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 610 "../src/game-view.vala"
		g_clear_error (&_inner_error_);
#line 610 "../src/game-view.vala"
		return;
#line 3280 "game-view.c"
	}
	{
		GdkPixbuf* p = NULL;
		const gchar* _tmp7_;
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
#line 628 "../src/game-view.vala"
		_tmp7_ = self->priv->pieces_file;
#line 628 "../src/game-view.vala"
		_tmp8_ = gdk_pixbuf_new_from_file_at_scale (_tmp7_, width, height, FALSE, &_inner_error_);
#line 628 "../src/game-view.vala"
		p = _tmp8_;
#line 628 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3295 "game-view.c"
			goto __catch4_g_error;
		}
#line 629 "../src/game-view.vala"
		_tmp9_ = p;
#line 629 "../src/game-view.vala"
		gdk_cairo_set_source_pixbuf (c, _tmp9_, (gdouble) 0, (gdouble) 0);
#line 630 "../src/game-view.vala"
		cairo_paint (c);
#line 626 "../src/game-view.vala"
		_g_object_unref0 (p);
#line 3306 "game-view.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 626 "../src/game-view.vala"
		e = _inner_error_;
#line 626 "../src/game-view.vala"
		_inner_error_ = NULL;
#line 634 "../src/game-view.vala"
		_tmp10_ = self->priv->pieces_file;
#line 634 "../src/game-view.vala"
		_tmp11_ = e;
#line 634 "../src/game-view.vala"
		_tmp12_ = _tmp11_->message;
#line 634 "../src/game-view.vala"
		g_warning ("game-view.vala:634: Failed to load theme image %s: %s", _tmp10_, _tmp12_);
#line 626 "../src/game-view.vala"
		_g_error_free0 (e);
#line 3329 "game-view.c"
	}
	__finally4:
#line 626 "../src/game-view.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 626 "../src/game-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 626 "../src/game-view.vala"
		g_clear_error (&_inner_error_);
#line 626 "../src/game-view.vala"
		return;
#line 3340 "game-view.c"
	}
}

static void
game_view_highlight_tile (GameView* self,
                          cairo_t* cr,
                          guint8 x,
                          guint8 y,
                          guint8 intensity,
                          gboolean soft_highlight)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint _tmp3_;
#line 638 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 638 "../src/game-view.vala"
	g_return_if_fail (cr != NULL);
#line 640 "../src/game-view.vala"
	if (soft_highlight) {
#line 641 "../src/game-view.vala"
		cairo_set_source_rgba (cr, self->priv->highlight_soft_red, self->priv->highlight_soft_green, self->priv->highlight_soft_blue, self->priv->highlight_soft_alpha);
#line 3368 "game-view.c"
	} else {
#line 643 "../src/game-view.vala"
		cairo_set_source_rgba (cr, self->priv->highlight_hard_red, self->priv->highlight_hard_green, self->priv->highlight_hard_blue, self->priv->highlight_hard_alpha);
#line 3372 "game-view.c"
	}
#line 644 "../src/game-view.vala"
	_tmp0_ = self->priv->tile_xs;
#line 644 "../src/game-view.vala"
	_tmp0__length1 = self->priv->tile_xs_length1;
#line 644 "../src/game-view.vala"
	_tmp0__length2 = self->priv->tile_xs_length2;
#line 644 "../src/game-view.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 644 "../src/game-view.vala"
	_tmp2_ = self->priv->tile_ys;
#line 644 "../src/game-view.vala"
	_tmp2__length1 = self->priv->tile_ys_length1;
#line 644 "../src/game-view.vala"
	_tmp2__length2 = self->priv->tile_ys_length2;
#line 644 "../src/game-view.vala"
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
#line 644 "../src/game-view.vala"
	game_view_rounded_square (self, cr, (gdouble) (_tmp1_ + ((self->priv->tile_size * (GAME_VIEW_HIGHLIGHT_MAX - intensity)) / (2 * GAME_VIEW_HIGHLIGHT_MAX))), (gdouble) (_tmp3_ + ((self->priv->tile_size * (GAME_VIEW_HIGHLIGHT_MAX - intensity)) / (2 * GAME_VIEW_HIGHLIGHT_MAX))), (self->priv->tile_size * intensity) / GAME_VIEW_HIGHLIGHT_MAX, (gdouble) 0, (gdouble) self->priv->background_radius);
#line 651 "../src/game-view.vala"
	cairo_fill (cr);
#line 3394 "game-view.c"
}

static void
game_view_queue_draw_tile (GameView* self,
                           guint8 x,
                           guint8 y)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint _tmp3_;
#line 654 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 654 "../src/game-view.vala"
	_vala_return_if_fail (x < self->priv->game_size, "x < game_size");
#line 654 "../src/game-view.vala"
	_vala_return_if_fail (y < self->priv->game_size, "y < game_size");
#line 658 "../src/game-view.vala"
	_tmp0_ = self->priv->tile_xs;
#line 658 "../src/game-view.vala"
	_tmp0__length1 = self->priv->tile_xs_length1;
#line 658 "../src/game-view.vala"
	_tmp0__length2 = self->priv->tile_xs_length2;
#line 658 "../src/game-view.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 658 "../src/game-view.vala"
	_tmp2_ = self->priv->tile_ys;
#line 658 "../src/game-view.vala"
	_tmp2__length1 = self->priv->tile_ys_length1;
#line 658 "../src/game-view.vala"
	_tmp2__length2 = self->priv->tile_ys_length2;
#line 658 "../src/game-view.vala"
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
#line 658 "../src/game-view.vala"
	gtk_widget_queue_draw_area ((GtkWidget*) self, self->priv->board_x + _tmp1_, self->priv->board_y + _tmp3_, self->priv->tile_size, self->priv->tile_size);
#line 3434 "game-view.c"
}

static inline void
game_view_update_highlight_after_undo (GameView* self)
{
	guint8 x = 0U;
	guint8 y = 0U;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 671 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 671 "../src/game-view.vala"
	_vala_return_if_fail (self->priv->last_state_set, "last_state_set");
#line 677 "../src/game-view.vala"
	game_view_get_missing_tile (self, &_tmp0_, &_tmp1_);
#line 677 "../src/game-view.vala"
	x = _tmp0_;
#line 677 "../src/game-view.vala"
	y = _tmp1_;
#line 680 "../src/game-view.vala"
	if (self->priv->show_highlight) {
#line 680 "../src/game-view.vala"
		_tmp3_ = TRUE;
#line 3460 "game-view.c"
	} else {
#line 680 "../src/game-view.vala"
		_tmp3_ = self->priv->show_mouse_highlight;
#line 3464 "game-view.c"
	}
#line 680 "../src/game-view.vala"
	if (_tmp3_) {
#line 680 "../src/game-view.vala"
		_tmp2_ = TRUE;
#line 3470 "game-view.c"
	} else {
#line 680 "../src/game-view.vala"
		_tmp2_ = ((gint) self->priv->highlight_state) != 0;
#line 3474 "game-view.c"
	}
#line 680 "../src/game-view.vala"
	if (_tmp2_) {
#line 3478 "game-view.c"
		Game* _tmp8_;
		Game* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 682 "../src/game-view.vala"
		self->priv->highlight_state = (guint8) 0;
#line 683 "../src/game-view.vala"
		if (self->priv->show_highlight) {
#line 3487 "game-view.c"
			Game* _tmp4_;
			Game* _tmp5_;
#line 684 "../src/game-view.vala"
			_tmp4_ = game_view_get_game (self);
#line 684 "../src/game-view.vala"
			_tmp5_ = _tmp4_;
#line 684 "../src/game-view.vala"
			game_view_set_square (self, self->priv->highlight_x, self->priv->highlight_y, game_view_get_pixmap (game_get_owner (_tmp5_, self->priv->highlight_x, self->priv->highlight_y)), FALSE, TRUE);
#line 3496 "game-view.c"
		}
#line 689 "../src/game-view.vala"
		if (self->priv->show_mouse_highlight) {
#line 3500 "game-view.c"
			Game* _tmp6_;
			Game* _tmp7_;
#line 690 "../src/game-view.vala"
			_tmp6_ = game_view_get_game (self);
#line 690 "../src/game-view.vala"
			_tmp7_ = _tmp6_;
#line 690 "../src/game-view.vala"
			game_view_set_square (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y, game_view_get_pixmap (game_get_owner (_tmp7_, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y)), FALSE, TRUE);
#line 3509 "game-view.c"
		}
#line 696 "../src/game-view.vala"
		_tmp8_ = game_view_get_game (self);
#line 696 "../src/game-view.vala"
		_tmp9_ = _tmp8_;
#line 696 "../src/game-view.vala"
		_tmp10_ = game_get_is_complete (_tmp9_);
#line 696 "../src/game-view.vala"
		_tmp11_ = _tmp10_;
#line 696 "../src/game-view.vala"
		if (!_tmp11_) {
#line 3521 "game-view.c"
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
#line 698 "../src/game-view.vala"
			if (self->priv->show_highlight) {
#line 699 "../src/game-view.vala"
				_tmp13_ = x == self->priv->highlight_x;
#line 3528 "game-view.c"
			} else {
#line 698 "../src/game-view.vala"
				_tmp13_ = FALSE;
#line 3532 "game-view.c"
			}
#line 698 "../src/game-view.vala"
			if (_tmp13_) {
#line 700 "../src/game-view.vala"
				_tmp12_ = y == self->priv->highlight_y;
#line 3538 "game-view.c"
			} else {
#line 698 "../src/game-view.vala"
				_tmp12_ = FALSE;
#line 3542 "game-view.c"
			}
#line 698 "../src/game-view.vala"
			if (_tmp12_) {
#line 701 "../src/game-view.vala"
				self->priv->highlight_state = GAME_VIEW_HIGHLIGHT_MAX;
#line 3548 "game-view.c"
			} else {
				gboolean _tmp14_ = FALSE;
				gboolean _tmp15_ = FALSE;
#line 702 "../src/game-view.vala"
				if (self->priv->show_mouse_highlight) {
#line 703 "../src/game-view.vala"
					_tmp15_ = x == self->priv->mouse_highlight_x;
#line 3556 "game-view.c"
				} else {
#line 702 "../src/game-view.vala"
					_tmp15_ = FALSE;
#line 3560 "game-view.c"
				}
#line 702 "../src/game-view.vala"
				if (_tmp15_) {
#line 704 "../src/game-view.vala"
					_tmp14_ = y == self->priv->mouse_highlight_y;
#line 3566 "game-view.c"
				} else {
#line 702 "../src/game-view.vala"
					_tmp14_ = FALSE;
#line 3570 "game-view.c"
				}
#line 702 "../src/game-view.vala"
				if (_tmp14_) {
#line 705 "../src/game-view.vala"
					self->priv->highlight_state = GAME_VIEW_HIGHLIGHT_MAX;
#line 3576 "game-view.c"
				} else {
#line 707 "../src/game-view.vala"
					self->priv->highlight_state = (guint8) 1;
#line 3580 "game-view.c"
				}
			}
		}
	}
#line 712 "../src/game-view.vala"
	self->priv->highlight_set = TRUE;
#line 713 "../src/game-view.vala"
	self->priv->highlight_x = x;
#line 714 "../src/game-view.vala"
	self->priv->highlight_y = y;
#line 715 "../src/game-view.vala"
	self->priv->mouse_highlight_x = x;
#line 716 "../src/game-view.vala"
	self->priv->mouse_highlight_y = y;
#line 717 "../src/game-view.vala"
	if (!self->priv->mouse_is_in) {
#line 718 "../src/game-view.vala"
		self->priv->show_highlight = TRUE;
#line 3599 "game-view.c"
	} else {
#line 719 "../src/game-view.vala"
		if (!self->priv->show_highlight) {
#line 720 "../src/game-view.vala"
			self->priv->show_mouse_highlight = TRUE;
#line 3605 "game-view.c"
		}
	}
}

static void
game_view_get_missing_tile (GameView* self,
                            guint8* x,
                            guint8* y)
{
	guint8 _vala_x = 0U;
	guint8 _vala_y = 0U;
#line 722 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 724 "../src/game-view.vala"
	_vala_y = (guint8) 0;
#line 3621 "game-view.c"
	{
		gboolean _tmp0_ = FALSE;
#line 726 "../src/game-view.vala"
		_vala_x = (guint8) 0;
#line 726 "../src/game-view.vala"
		_tmp0_ = TRUE;
#line 726 "../src/game-view.vala"
		while (TRUE) {
#line 726 "../src/game-view.vala"
			if (!_tmp0_) {
#line 3632 "game-view.c"
				guint8 _tmp1_;
#line 726 "../src/game-view.vala"
				_tmp1_ = _vala_x;
#line 726 "../src/game-view.vala"
				_vala_x = _tmp1_ + 1;
#line 3638 "game-view.c"
			}
#line 726 "../src/game-view.vala"
			_tmp0_ = FALSE;
#line 726 "../src/game-view.vala"
			if (!(_vala_x < self->priv->game_size)) {
#line 726 "../src/game-view.vala"
				break;
#line 3646 "game-view.c"
			}
			{
				gboolean _tmp2_ = FALSE;
#line 728 "../src/game-view.vala"
				_vala_y = (guint8) 0;
#line 728 "../src/game-view.vala"
				_tmp2_ = TRUE;
#line 728 "../src/game-view.vala"
				while (TRUE) {
#line 3656 "game-view.c"
					Game* _tmp4_;
					Game* _tmp5_;
					GameStateObject* _tmp6_;
					Game* _tmp7_;
					Game* _tmp8_;
					Player _tmp9_;
					Player _tmp10_;
#line 728 "../src/game-view.vala"
					if (!_tmp2_) {
#line 3666 "game-view.c"
						guint8 _tmp3_;
#line 728 "../src/game-view.vala"
						_tmp3_ = _vala_y;
#line 728 "../src/game-view.vala"
						_vala_y = _tmp3_ + 1;
#line 3672 "game-view.c"
					}
#line 728 "../src/game-view.vala"
					_tmp2_ = FALSE;
#line 728 "../src/game-view.vala"
					if (!(_vala_y < self->priv->game_size)) {
#line 728 "../src/game-view.vala"
						break;
#line 3680 "game-view.c"
					}
#line 730 "../src/game-view.vala"
					_tmp4_ = game_view_get_game (self);
#line 730 "../src/game-view.vala"
					_tmp5_ = _tmp4_;
#line 730 "../src/game-view.vala"
					if (game_get_owner (_tmp5_, _vala_x, _vala_y) != PLAYER_NONE) {
#line 731 "../src/game-view.vala"
						continue;
#line 3690 "game-view.c"
					}
#line 732 "../src/game-view.vala"
					_tmp6_ = self->priv->last_state;
#line 732 "../src/game-view.vala"
					_tmp7_ = game_view_get_game (self);
#line 732 "../src/game-view.vala"
					_tmp8_ = _tmp7_;
#line 732 "../src/game-view.vala"
					_tmp9_ = game_get_current_color (_tmp8_);
#line 732 "../src/game-view.vala"
					_tmp10_ = _tmp9_;
#line 732 "../src/game-view.vala"
					if (game_state_object_get_owner (_tmp6_, _vala_x, _vala_y) == _tmp10_) {
#line 733 "../src/game-view.vala"
						if (x) {
#line 733 "../src/game-view.vala"
							*x = _vala_x;
#line 3708 "game-view.c"
						}
#line 733 "../src/game-view.vala"
						if (y) {
#line 733 "../src/game-view.vala"
							*y = _vala_y;
#line 3714 "game-view.c"
						}
#line 733 "../src/game-view.vala"
						return;
#line 3718 "game-view.c"
					}
				}
			}
		}
	}
#line 736 "../src/game-view.vala"
	g_assert_not_reached ();
#line 722 "../src/game-view.vala"
	if (x) {
#line 722 "../src/game-view.vala"
		*x = _vala_x;
#line 3730 "game-view.c"
	}
#line 722 "../src/game-view.vala"
	if (y) {
#line 722 "../src/game-view.vala"
		*y = _vala_y;
#line 3736 "game-view.c"
	}
}

static void
game_view_turn_ended_cb (GameView* self,
                         gboolean undoing,
                         gboolean no_draw)
{
	Game* _tmp0_;
	Game* _tmp1_;
	GameStateObject* _tmp2_;
	GameStateObject* _tmp3_;
	GameStateObject* _tmp4_;
#line 739 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 741 "../src/game-view.vala"
	if (!no_draw) {
#line 743 "../src/game-view.vala"
		game_view_update_squares (self);
#line 744 "../src/game-view.vala"
		if (undoing) {
#line 745 "../src/game-view.vala"
			game_view_update_highlight_after_undo (self);
#line 3760 "game-view.c"
		}
	}
#line 748 "../src/game-view.vala"
	_tmp0_ = game_view_get_game (self);
#line 748 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 748 "../src/game-view.vala"
	_tmp2_ = game_get_current_state (_tmp1_);
#line 748 "../src/game-view.vala"
	_tmp3_ = _tmp2_;
#line 748 "../src/game-view.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 748 "../src/game-view.vala"
	_g_object_unref0 (self->priv->last_state);
#line 748 "../src/game-view.vala"
	self->priv->last_state = _tmp4_;
#line 749 "../src/game-view.vala"
	self->priv->last_state_set = TRUE;
#line 3779 "game-view.c"
}

static inline void
game_view_update_squares (GameView* self)
{
#line 752 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 3787 "game-view.c"
	{
		guint8 x = 0U;
#line 754 "../src/game-view.vala"
		x = (guint8) 0;
#line 3792 "game-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 754 "../src/game-view.vala"
			_tmp0_ = TRUE;
#line 754 "../src/game-view.vala"
			while (TRUE) {
#line 754 "../src/game-view.vala"
				if (!_tmp0_) {
#line 3801 "game-view.c"
					guint8 _tmp1_;
#line 754 "../src/game-view.vala"
					_tmp1_ = x;
#line 754 "../src/game-view.vala"
					x = _tmp1_ + 1;
#line 3807 "game-view.c"
				}
#line 754 "../src/game-view.vala"
				_tmp0_ = FALSE;
#line 754 "../src/game-view.vala"
				if (!(x < self->priv->game_size)) {
#line 754 "../src/game-view.vala"
					break;
#line 3815 "game-view.c"
				}
				{
					guint8 y = 0U;
#line 755 "../src/game-view.vala"
					y = (guint8) 0;
#line 3821 "game-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 755 "../src/game-view.vala"
						_tmp2_ = TRUE;
#line 755 "../src/game-view.vala"
						while (TRUE) {
#line 755 "../src/game-view.vala"
							if (!_tmp2_) {
#line 3830 "game-view.c"
								guint8 _tmp3_;
#line 755 "../src/game-view.vala"
								_tmp3_ = y;
#line 755 "../src/game-view.vala"
								y = _tmp3_ + 1;
#line 3836 "game-view.c"
							}
#line 755 "../src/game-view.vala"
							_tmp2_ = FALSE;
#line 755 "../src/game-view.vala"
							if (!(y < self->priv->game_size)) {
#line 755 "../src/game-view.vala"
								break;
#line 3844 "game-view.c"
							}
#line 756 "../src/game-view.vala"
							game_view_update_square (self, x, y);
#line 3848 "game-view.c"
						}
					}
				}
			}
		}
	}
}

static inline void
game_view_update_square (GameView* self,
                         guint8 x,
                         guint8 y)
{
	Game* _tmp0_;
	Game* _tmp1_;
#line 759 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 759 "../src/game-view.vala"
	_vala_return_if_fail (self->priv->game_is_set, "game_is_set");
#line 762 "../src/game-view.vala"
	_tmp0_ = game_view_get_game (self);
#line 762 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 762 "../src/game-view.vala"
	game_view_set_square (self, x, y, game_view_get_pixmap (game_get_owner (_tmp1_, x, y)), FALSE, FALSE);
#line 3874 "game-view.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 765 "../src/game-view.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 765 "../src/game-view.vala"
	return _data2_;
#line 3884 "game-view.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 765 "../src/game-view.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 3894 "game-view.c"
		GameView* self;
#line 765 "../src/game-view.vala"
		self = _data2_->self;
#line 765 "../src/game-view.vala"
		_g_object_unref0 (self);
#line 765 "../src/game-view.vala"
		g_slice_free (Block2Data, _data2_);
#line 3902 "game-view.c"
	}
}

static gboolean
____lambda9_ (Block2Data* _data2_)
{
	GameView* self;
	gboolean result = FALSE;
	gboolean animating = FALSE;
#line 779 "../src/game-view.vala"
	self = _data2_->self;
#line 780 "../src/game-view.vala"
	animating = FALSE;
#line 3916 "game-view.c"
	{
		guint8 ix = 0U;
#line 782 "../src/game-view.vala"
		ix = (guint8) 0;
#line 3921 "game-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 782 "../src/game-view.vala"
			_tmp0_ = TRUE;
#line 782 "../src/game-view.vala"
			while (TRUE) {
#line 782 "../src/game-view.vala"
				if (!_tmp0_) {
#line 3930 "game-view.c"
					guint8 _tmp1_;
#line 782 "../src/game-view.vala"
					_tmp1_ = ix;
#line 782 "../src/game-view.vala"
					ix = _tmp1_ + 1;
#line 3936 "game-view.c"
				}
#line 782 "../src/game-view.vala"
				_tmp0_ = FALSE;
#line 782 "../src/game-view.vala"
				if (!(ix < self->priv->game_size)) {
#line 782 "../src/game-view.vala"
					break;
#line 3944 "game-view.c"
				}
				{
					guint8 iy = 0U;
#line 784 "../src/game-view.vala"
					iy = (guint8) 0;
#line 3950 "game-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 784 "../src/game-view.vala"
						_tmp2_ = TRUE;
#line 784 "../src/game-view.vala"
						while (TRUE) {
#line 3957 "game-view.c"
							gint old = 0;
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint _tmp5_;
							gboolean _tmp6_ = FALSE;
							gboolean _tmp7_ = FALSE;
							gint* _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							gint _tmp13_;
#line 784 "../src/game-view.vala"
							if (!_tmp2_) {
#line 3971 "game-view.c"
								guint8 _tmp3_;
#line 784 "../src/game-view.vala"
								_tmp3_ = iy;
#line 784 "../src/game-view.vala"
								iy = _tmp3_ + 1;
#line 3977 "game-view.c"
							}
#line 784 "../src/game-view.vala"
							_tmp2_ = FALSE;
#line 784 "../src/game-view.vala"
							if (!(iy < self->priv->game_size)) {
#line 784 "../src/game-view.vala"
								break;
#line 3985 "game-view.c"
							}
#line 786 "../src/game-view.vala"
							_tmp4_ = self->priv->pixmaps;
#line 786 "../src/game-view.vala"
							_tmp4__length1 = self->priv->pixmaps_length1;
#line 786 "../src/game-view.vala"
							_tmp4__length2 = self->priv->pixmaps_length2;
#line 786 "../src/game-view.vala"
							_tmp5_ = _tmp4_[(ix * _tmp4__length2) + iy];
#line 786 "../src/game-view.vala"
							old = _tmp5_;
#line 788 "../src/game-view.vala"
							if (_data2_->is_final_animation) {
#line 789 "../src/game-view.vala"
								_tmp7_ = self->priv->flip_final_result_now;
#line 4001 "game-view.c"
							} else {
#line 788 "../src/game-view.vala"
								_tmp7_ = FALSE;
#line 4005 "game-view.c"
							}
#line 788 "../src/game-view.vala"
							if (_tmp7_) {
#line 4009 "game-view.c"
								Game* _tmp8_;
								Game* _tmp9_;
								gboolean _tmp10_;
								gboolean _tmp11_;
#line 790 "../src/game-view.vala"
								_tmp8_ = game_view_get_game (self);
#line 790 "../src/game-view.vala"
								_tmp9_ = _tmp8_;
#line 790 "../src/game-view.vala"
								_tmp10_ = game_get_is_complete (_tmp9_);
#line 790 "../src/game-view.vala"
								_tmp11_ = _tmp10_;
#line 790 "../src/game-view.vala"
								_tmp6_ = _tmp11_;
#line 4024 "game-view.c"
							} else {
#line 788 "../src/game-view.vala"
								_tmp6_ = FALSE;
#line 4028 "game-view.c"
							}
#line 788 "../src/game-view.vala"
							if (_tmp6_) {
#line 791 "../src/game-view.vala"
								game_view_flip_final_result_tile (self, ix, iy);
#line 4034 "game-view.c"
							} else {
#line 793 "../src/game-view.vala"
								game_view_update_square (self, ix, iy);
#line 4038 "game-view.c"
							}
#line 795 "../src/game-view.vala"
							_tmp12_ = self->priv->pixmaps;
#line 795 "../src/game-view.vala"
							_tmp12__length1 = self->priv->pixmaps_length1;
#line 795 "../src/game-view.vala"
							_tmp12__length2 = self->priv->pixmaps_length2;
#line 795 "../src/game-view.vala"
							_tmp13_ = _tmp12_[(ix * _tmp12__length2) + iy];
#line 795 "../src/game-view.vala"
							if (_tmp13_ != old) {
#line 796 "../src/game-view.vala"
								animating = TRUE;
#line 4052 "game-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 800 "../src/game-view.vala"
	if (animating) {
#line 801 "../src/game-view.vala"
		result = G_SOURCE_CONTINUE;
#line 801 "../src/game-view.vala"
		return result;
#line 4066 "game-view.c"
	} else {
#line 804 "../src/game-view.vala"
		self->priv->animate_timeout = (guint) 0;
#line 805 "../src/game-view.vala"
		if (!self->priv->show_highlight) {
#line 806 "../src/game-view.vala"
			_game_view_on_motion (self, self->priv->mouse_position_x, self->priv->mouse_position_y, TRUE);
#line 4074 "game-view.c"
		}
#line 807 "../src/game-view.vala"
		result = G_SOURCE_REMOVE;
#line 807 "../src/game-view.vala"
		return result;
#line 4080 "game-view.c"
	}
}

static gboolean
_____lambda9__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda9_ (self);
#line 779 "../src/game-view.vala"
	return result;
#line 4091 "game-view.c"
}

static void
game_view_set_square (GameView* self,
                      guint8 x,
                      guint8 y,
                      gint pixmap,
                      gboolean is_final_animation,
                      gboolean force_redraw)
{
	Block2Data* _data2_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 765 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 765 "../src/game-view.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 765 "../src/game-view.vala"
	_data2_->_ref_count_ = 1;
#line 765 "../src/game-view.vala"
	_data2_->self = g_object_ref (self);
#line 765 "../src/game-view.vala"
	_data2_->is_final_animation = is_final_animation;
#line 767 "../src/game-view.vala"
	if (!force_redraw) {
#line 4117 "game-view.c"
		gint* _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		gint _tmp2_;
#line 767 "../src/game-view.vala"
		_tmp1_ = self->priv->pixmaps;
#line 767 "../src/game-view.vala"
		_tmp1__length1 = self->priv->pixmaps_length1;
#line 767 "../src/game-view.vala"
		_tmp1__length2 = self->priv->pixmaps_length2;
#line 767 "../src/game-view.vala"
		_tmp2_ = _tmp1_[(x * _tmp1__length2) + y];
#line 767 "../src/game-view.vala"
		_tmp0_ = _tmp2_ == pixmap;
#line 4132 "game-view.c"
	} else {
#line 767 "../src/game-view.vala"
		_tmp0_ = FALSE;
#line 4136 "game-view.c"
	}
#line 767 "../src/game-view.vala"
	if (_tmp0_) {
#line 768 "../src/game-view.vala"
		block2_data_unref (_data2_);
#line 768 "../src/game-view.vala"
		_data2_ = NULL;
#line 768 "../src/game-view.vala"
		return;
#line 4146 "game-view.c"
	}
#line 770 "../src/game-view.vala"
	if (pixmap == 0) {
#line 770 "../src/game-view.vala"
		_tmp3_ = TRUE;
#line 4152 "game-view.c"
	} else {
		gint* _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		gint _tmp5_;
#line 770 "../src/game-view.vala"
		_tmp4_ = self->priv->pixmaps;
#line 770 "../src/game-view.vala"
		_tmp4__length1 = self->priv->pixmaps_length1;
#line 770 "../src/game-view.vala"
		_tmp4__length2 = self->priv->pixmaps_length2;
#line 770 "../src/game-view.vala"
		_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
#line 770 "../src/game-view.vala"
		_tmp3_ = _tmp5_ == 0;
#line 4168 "game-view.c"
	}
#line 770 "../src/game-view.vala"
	if (_tmp3_) {
#line 4172 "game-view.c"
		gint* _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
#line 771 "../src/game-view.vala"
		_tmp6_ = self->priv->pixmaps;
#line 771 "../src/game-view.vala"
		_tmp6__length1 = self->priv->pixmaps_length1;
#line 771 "../src/game-view.vala"
		_tmp6__length2 = self->priv->pixmaps_length2;
#line 771 "../src/game-view.vala"
		_tmp6_[(x * _tmp6__length2) + y] = pixmap;
#line 4184 "game-view.c"
	} else {
		gint* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		gint _tmp8_;
#line 774 "../src/game-view.vala"
		_tmp7_ = self->priv->pixmaps;
#line 774 "../src/game-view.vala"
		_tmp7__length1 = self->priv->pixmaps_length1;
#line 774 "../src/game-view.vala"
		_tmp7__length2 = self->priv->pixmaps_length2;
#line 774 "../src/game-view.vala"
		_tmp8_ = _tmp7_[(x * _tmp7__length2) + y];
#line 774 "../src/game-view.vala"
		if (pixmap > _tmp8_) {
#line 4200 "game-view.c"
			gint* _tmp9_;
			gint _tmp9__length1;
			gint _tmp9__length2;
			gint _tmp10_;
#line 775 "../src/game-view.vala"
			_tmp9_ = self->priv->pixmaps;
#line 775 "../src/game-view.vala"
			_tmp9__length1 = self->priv->pixmaps_length1;
#line 775 "../src/game-view.vala"
			_tmp9__length2 = self->priv->pixmaps_length2;
#line 775 "../src/game-view.vala"
			_tmp10_ = _tmp9_[(x * _tmp9__length2) + y];
#line 775 "../src/game-view.vala"
			_tmp9_[(x * _tmp9__length2) + y] = _tmp10_ + 1;
#line 4215 "game-view.c"
		} else {
			gint* _tmp11_;
			gint _tmp11__length1;
			gint _tmp11__length2;
			gint _tmp12_;
#line 777 "../src/game-view.vala"
			_tmp11_ = self->priv->pixmaps;
#line 777 "../src/game-view.vala"
			_tmp11__length1 = self->priv->pixmaps_length1;
#line 777 "../src/game-view.vala"
			_tmp11__length2 = self->priv->pixmaps_length2;
#line 777 "../src/game-view.vala"
			_tmp12_ = _tmp11_[(x * _tmp11__length2) + y];
#line 777 "../src/game-view.vala"
			_tmp11_[(x * _tmp11__length2) + y] = _tmp12_ - 1;
#line 4231 "game-view.c"
		}
#line 778 "../src/game-view.vala"
		if (self->priv->animate_timeout == ((guint) 0)) {
#line 779 "../src/game-view.vala"
			self->priv->animate_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) GAME_VIEW_PIXMAP_FLIP_DELAY, _____lambda9__gsource_func, block2_data_ref (_data2_), block2_data_unref);
#line 4237 "game-view.c"
		}
	}
#line 811 "../src/game-view.vala"
	game_view_queue_draw_tile (self, x, y);
#line 765 "../src/game-view.vala"
	block2_data_unref (_data2_);
#line 765 "../src/game-view.vala"
	_data2_ = NULL;
#line 4246 "game-view.c"
}

static gint
game_view_get_pixmap (Player color)
{
	gint result = 0;
#line 816 "../src/game-view.vala"
	switch (color) {
#line 4255 "game-view.c"
		default:
#line 816 "../src/game-view.vala"
		case PLAYER_NONE:
#line 4259 "game-view.c"
		{
#line 820 "../src/game-view.vala"
			result = 0;
#line 820 "../src/game-view.vala"
			return result;
#line 4265 "game-view.c"
		}
#line 816 "../src/game-view.vala"
		case PLAYER_DARK:
#line 4269 "game-view.c"
		{
#line 822 "../src/game-view.vala"
			result = 1;
#line 822 "../src/game-view.vala"
			return result;
#line 4275 "game-view.c"
		}
#line 816 "../src/game-view.vala"
		case PLAYER_LIGHT:
#line 4279 "game-view.c"
		{
#line 824 "../src/game-view.vala"
			result = 31;
#line 824 "../src/game-view.vala"
			return result;
#line 4285 "game-view.c"
		}
	}
}

static gboolean
___lambda8_ (GameView* self)
{
	gboolean result = FALSE;
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 854 "../src/game-view.vala"
	_tmp0_ = game_view_get_game (self);
#line 854 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 854 "../src/game-view.vala"
	_tmp2_ = game_get_is_complete (_tmp1_);
#line 854 "../src/game-view.vala"
	_tmp3_ = _tmp2_;
#line 854 "../src/game-view.vala"
	if (!_tmp3_) {
#line 855 "../src/game-view.vala"
		result = G_SOURCE_REMOVE;
#line 855 "../src/game-view.vala"
		return result;
#line 4312 "game-view.c"
	}
#line 857 "../src/game-view.vala"
	game_view_set_winner_and_loser_variables (self);
#line 858 "../src/game-view.vala"
	self->priv->flip_final_result_now = TRUE;
#line 4318 "game-view.c"
	{
		guint8 x = 0U;
#line 859 "../src/game-view.vala"
		x = (guint8) 0;
#line 4323 "game-view.c"
		{
			gboolean _tmp4_ = FALSE;
#line 859 "../src/game-view.vala"
			_tmp4_ = TRUE;
#line 859 "../src/game-view.vala"
			while (TRUE) {
#line 859 "../src/game-view.vala"
				if (!_tmp4_) {
#line 4332 "game-view.c"
					guint8 _tmp5_;
#line 859 "../src/game-view.vala"
					_tmp5_ = x;
#line 859 "../src/game-view.vala"
					x = _tmp5_ + 1;
#line 4338 "game-view.c"
				}
#line 859 "../src/game-view.vala"
				_tmp4_ = FALSE;
#line 859 "../src/game-view.vala"
				if (!(x < self->priv->game_size)) {
#line 859 "../src/game-view.vala"
					break;
#line 4346 "game-view.c"
				}
				{
					guint8 y = 0U;
#line 860 "../src/game-view.vala"
					y = (guint8) 0;
#line 4352 "game-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 860 "../src/game-view.vala"
						_tmp6_ = TRUE;
#line 860 "../src/game-view.vala"
						while (TRUE) {
#line 860 "../src/game-view.vala"
							if (!_tmp6_) {
#line 4361 "game-view.c"
								guint8 _tmp7_;
#line 860 "../src/game-view.vala"
								_tmp7_ = y;
#line 860 "../src/game-view.vala"
								y = _tmp7_ + 1;
#line 4367 "game-view.c"
							}
#line 860 "../src/game-view.vala"
							_tmp6_ = FALSE;
#line 860 "../src/game-view.vala"
							if (!(y < self->priv->game_size)) {
#line 860 "../src/game-view.vala"
								break;
#line 4375 "game-view.c"
							}
#line 861 "../src/game-view.vala"
							game_view_flip_final_result_tile (self, x, y);
#line 4379 "game-view.c"
						}
					}
				}
			}
		}
	}
#line 863 "../src/game-view.vala"
	result = G_SOURCE_REMOVE;
#line 863 "../src/game-view.vala"
	return result;
#line 4390 "game-view.c"
}

static gboolean
____lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda8_ ((GameView*) self);
#line 853 "../src/game-view.vala"
	return result;
#line 4400 "game-view.c"
}

static void
game_view_game_is_complete_cb (GameView* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	Game* _tmp5_;
	Game* _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
#line 840 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 842 "../src/game-view.vala"
	_tmp0_ = game_view_get_game (self);
#line 842 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 842 "../src/game-view.vala"
	_tmp2_ = game_get_is_complete (_tmp1_);
#line 842 "../src/game-view.vala"
	_tmp3_ = _tmp2_;
#line 842 "../src/game-view.vala"
	if (!_tmp3_) {
#line 843 "../src/game-view.vala"
		return;
#line 4429 "game-view.c"
	}
#line 845 "../src/game-view.vala"
	_tmp5_ = game_view_get_game (self);
#line 845 "../src/game-view.vala"
	_tmp6_ = _tmp5_;
#line 845 "../src/game-view.vala"
	_tmp7_ = game_get_n_light_tiles (_tmp6_);
#line 845 "../src/game-view.vala"
	_tmp8_ = _tmp7_;
#line 845 "../src/game-view.vala"
	if (((gint) _tmp8_) == 0) {
#line 845 "../src/game-view.vala"
		_tmp4_ = TRUE;
#line 4443 "game-view.c"
	} else {
		Game* _tmp9_;
		Game* _tmp10_;
		guint8 _tmp11_;
		guint8 _tmp12_;
#line 845 "../src/game-view.vala"
		_tmp9_ = game_view_get_game (self);
#line 845 "../src/game-view.vala"
		_tmp10_ = _tmp9_;
#line 845 "../src/game-view.vala"
		_tmp11_ = game_get_n_dark_tiles (_tmp10_);
#line 845 "../src/game-view.vala"
		_tmp12_ = _tmp11_;
#line 845 "../src/game-view.vala"
		_tmp4_ = ((gint) _tmp12_) == 0;
#line 4459 "game-view.c"
	}
#line 845 "../src/game-view.vala"
	if (_tmp4_) {
#line 846 "../src/game-view.vala"
		return;
#line 4465 "game-view.c"
	}
#line 852 "../src/game-view.vala"
	if (((gint) self->priv->game_size) >= 6) {
#line 853 "../src/game-view.vala"
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, ____lambda8__gsource_func, g_object_ref (self), g_object_unref);
#line 4471 "game-view.c"
	}
}

static void
game_view_flip_final_result_tile (GameView* self,
                                  guint8 x,
                                  guint8 y)
{
	gint pixmap = 0;
	guint8 n = 0U;
#line 867 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 870 "../src/game-view.vala"
	n = (y * self->priv->game_size) + x;
#line 871 "../src/game-view.vala"
	if (((gint) n) < self->priv->n_winning_tiles) {
#line 4488 "game-view.c"
		Player _tmp0_;
#line 872 "../src/game-view.vala"
		_tmp0_ = self->priv->winning_color;
#line 872 "../src/game-view.vala"
		pixmap = game_view_get_pixmap (_tmp0_);
#line 4494 "game-view.c"
	} else {
#line 873 "../src/game-view.vala"
		if (((gint) n) < (self->priv->n_winning_tiles + self->priv->n_losing_tiles)) {
#line 4498 "game-view.c"
			Player _tmp1_;
#line 874 "../src/game-view.vala"
			_tmp1_ = self->priv->losing_color;
#line 874 "../src/game-view.vala"
			pixmap = game_view_get_pixmap (_tmp1_);
#line 4504 "game-view.c"
		} else {
#line 876 "../src/game-view.vala"
			pixmap = game_view_get_pixmap (PLAYER_NONE);
#line 4508 "game-view.c"
		}
	}
#line 877 "../src/game-view.vala"
	game_view_set_square (self, x, y, pixmap, TRUE, FALSE);
#line 4513 "game-view.c"
}

static void
game_view_set_winner_and_loser_variables (GameView* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	Game* _tmp4_;
	Game* _tmp5_;
	guint8 _tmp6_;
	guint8 _tmp7_;
#line 880 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 882 "../src/game-view.vala"
	_tmp0_ = game_view_get_game (self);
#line 882 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 882 "../src/game-view.vala"
	_tmp2_ = game_get_n_light_tiles (_tmp1_);
#line 882 "../src/game-view.vala"
	_tmp3_ = _tmp2_;
#line 882 "../src/game-view.vala"
	self->priv->n_winning_tiles = (gint) _tmp3_;
#line 883 "../src/game-view.vala"
	_tmp4_ = game_view_get_game (self);
#line 883 "../src/game-view.vala"
	_tmp5_ = _tmp4_;
#line 883 "../src/game-view.vala"
	_tmp6_ = game_get_n_dark_tiles (_tmp5_);
#line 883 "../src/game-view.vala"
	_tmp7_ = _tmp6_;
#line 883 "../src/game-view.vala"
	self->priv->n_losing_tiles = (gint) _tmp7_;
#line 884 "../src/game-view.vala"
	if (self->priv->n_losing_tiles > self->priv->n_winning_tiles) {
#line 4551 "game-view.c"
		gint t = 0;
#line 886 "../src/game-view.vala"
		self->priv->winning_color = PLAYER_DARK;
#line 887 "../src/game-view.vala"
		self->priv->losing_color = PLAYER_LIGHT;
#line 888 "../src/game-view.vala"
		t = self->priv->n_winning_tiles;
#line 889 "../src/game-view.vala"
		self->priv->n_winning_tiles = self->priv->n_losing_tiles;
#line 890 "../src/game-view.vala"
		self->priv->n_losing_tiles = t;
#line 4563 "game-view.c"
	} else {
#line 894 "../src/game-view.vala"
		self->priv->winning_color = PLAYER_LIGHT;
#line 895 "../src/game-view.vala"
		self->priv->losing_color = PLAYER_DARK;
#line 4569 "game-view.c"
	}
}

gboolean
game_view_undo_final_animation (GameView* self)
{
	gboolean result = FALSE;
#line 899 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 901 "../src/game-view.vala"
	if (!self->priv->flip_final_result_now) {
#line 902 "../src/game-view.vala"
		result = FALSE;
#line 902 "../src/game-view.vala"
		return result;
#line 4585 "game-view.c"
	}
#line 904 "../src/game-view.vala"
	self->priv->flip_final_result_now = FALSE;
#line 905 "../src/game-view.vala"
	game_view_update_squares (self);
#line 907 "../src/game-view.vala"
	result = TRUE;
#line 907 "../src/game-view.vala"
	return result;
#line 4595 "game-view.c"
}

static void
_game_view_on_motion_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                         gdouble x,
                                                         gdouble y,
                                                         gpointer self)
{
#line 920 "../src/game-view.vala"
	game_view_on_motion ((GameView*) self, _sender, x, y);
#line 4606 "game-view.c"
}

static void
game_view_init_mouse (GameView* self)
{
	GtkEventControllerMotion* _tmp0_;
	GtkEventControllerMotion* _tmp1_;
#line 917 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 919 "../src/game-view.vala"
	_tmp0_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ((GtkWidget*) self);
#line 919 "../src/game-view.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 919 "../src/game-view.vala"
	self->priv->motion_controller = _tmp0_;
#line 920 "../src/game-view.vala"
	_tmp1_ = self->priv->motion_controller;
#line 920 "../src/game-view.vala"
	g_signal_connect_object (_tmp1_, "motion", (GCallback) _game_view_on_motion_gtk_event_controller_motion_motion, self, 0);
#line 4626 "game-view.c"
}

static gboolean
game_view_real_enter_notify_event (GtkWidget* base,
                                   GdkEventCrossing* event)
{
	GameView * self;
	gboolean result = FALSE;
	guint8 x = 0U;
	guint8 y = 0U;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
	gboolean _tmp2_;
#line 926 "../src/game-view.vala"
	self = (GameView*) base;
#line 926 "../src/game-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 930 "../src/game-view.vala"
	_tmp2_ = game_view_pointer_is_in_board (self, event->x, event->y, &_tmp0_, &_tmp1_);
#line 930 "../src/game-view.vala"
	x = _tmp0_;
#line 930 "../src/game-view.vala"
	y = _tmp1_;
#line 930 "../src/game-view.vala"
	if (_tmp2_) {
#line 932 "../src/game-view.vala"
		game_view_on_cursor_moving_in (self, x, y);
#line 4654 "game-view.c"
	} else {
#line 933 "../src/game-view.vala"
		if (self->priv->mouse_is_in) {
#line 934 "../src/game-view.vala"
			g_assert_not_reached ();
#line 4660 "game-view.c"
		}
	}
#line 935 "../src/game-view.vala"
	result = FALSE;
#line 935 "../src/game-view.vala"
	return result;
#line 4667 "game-view.c"
}

static void
game_view_on_cursor_moving_in (GameView* self,
                               guint8 x,
                               guint8 y)
{
#line 938 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 940 "../src/game-view.vala"
	self->priv->mouse_position_x = x;
#line 941 "../src/game-view.vala"
	self->priv->mouse_position_y = y;
#line 942 "../src/game-view.vala"
	self->priv->mouse_position_set = TRUE;
#line 943 "../src/game-view.vala"
	self->priv->mouse_is_in = TRUE;
#line 944 "../src/game-view.vala"
	_game_view_on_motion (self, x, y, TRUE);
#line 4687 "game-view.c"
}

static gboolean
game_view_real_leave_notify_event (GtkWidget* base,
                                   GdkEventCrossing* event)
{
	GameView * self;
	gboolean result = FALSE;
#line 948 "../src/game-view.vala"
	self = (GameView*) base;
#line 948 "../src/game-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 950 "../src/game-view.vala"
	self->priv->mouse_is_in = FALSE;
#line 951 "../src/game-view.vala"
	if (self->priv->mouse_position_set) {
#line 952 "../src/game-view.vala"
		game_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 4706 "game-view.c"
	}
#line 953 "../src/game-view.vala"
	result = FALSE;
#line 953 "../src/game-view.vala"
	return result;
#line 4712 "game-view.c"
}

static gboolean
game_view_pointer_is_in_board (GameView* self,
                               gdouble pos_x,
                               gdouble pos_y,
                               guint8* x,
                               guint8* y)
{
	guint8 _vala_x = 0U;
	guint8 _vala_y = 0U;
	gboolean result = FALSE;
	gint _x = 0;
	gint _y = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 956 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 958 "../src/game-view.vala"
	_x = (gint) floor ((pos_x - ((gdouble) self->priv->board_x)) / ((gdouble) self->priv->paving_size));
#line 959 "../src/game-view.vala"
	_y = (gint) floor ((pos_y - ((gdouble) self->priv->board_y)) / ((gdouble) self->priv->paving_size));
#line 960 "../src/game-view.vala"
	if (_x >= 0) {
#line 960 "../src/game-view.vala"
		_tmp2_ = _x < ((gint) self->priv->game_size);
#line 4740 "game-view.c"
	} else {
#line 960 "../src/game-view.vala"
		_tmp2_ = FALSE;
#line 4744 "game-view.c"
	}
#line 960 "../src/game-view.vala"
	if (_tmp2_) {
#line 961 "../src/game-view.vala"
		_tmp1_ = _y >= 0;
#line 4750 "game-view.c"
	} else {
#line 960 "../src/game-view.vala"
		_tmp1_ = FALSE;
#line 4754 "game-view.c"
	}
#line 960 "../src/game-view.vala"
	if (_tmp1_) {
#line 961 "../src/game-view.vala"
		_tmp0_ = _y < ((gint) self->priv->game_size);
#line 4760 "game-view.c"
	} else {
#line 960 "../src/game-view.vala"
		_tmp0_ = FALSE;
#line 4764 "game-view.c"
	}
#line 960 "../src/game-view.vala"
	if (_tmp0_) {
#line 963 "../src/game-view.vala"
		_vala_x = (guint8) _x;
#line 964 "../src/game-view.vala"
		_vala_y = (guint8) _y;
#line 965 "../src/game-view.vala"
		result = TRUE;
#line 965 "../src/game-view.vala"
		if (x) {
#line 965 "../src/game-view.vala"
			*x = _vala_x;
#line 4778 "game-view.c"
		}
#line 965 "../src/game-view.vala"
		if (y) {
#line 965 "../src/game-view.vala"
			*y = _vala_y;
#line 4784 "game-view.c"
		}
#line 965 "../src/game-view.vala"
		return result;
#line 4788 "game-view.c"
	} else {
#line 969 "../src/game-view.vala"
		_vala_x = G_MAXUINT8;
#line 970 "../src/game-view.vala"
		_vala_y = G_MAXUINT8;
#line 971 "../src/game-view.vala"
		result = FALSE;
#line 971 "../src/game-view.vala"
		if (x) {
#line 971 "../src/game-view.vala"
			*x = _vala_x;
#line 4800 "game-view.c"
		}
#line 971 "../src/game-view.vala"
		if (y) {
#line 971 "../src/game-view.vala"
			*y = _vala_y;
#line 4806 "game-view.c"
		}
#line 971 "../src/game-view.vala"
		return result;
#line 4810 "game-view.c"
	}
#line 956 "../src/game-view.vala"
	if (x) {
#line 956 "../src/game-view.vala"
		*x = _vala_x;
#line 4816 "game-view.c"
	}
#line 956 "../src/game-view.vala"
	if (y) {
#line 956 "../src/game-view.vala"
		*y = _vala_y;
#line 4822 "game-view.c"
	}
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 976 "../src/game-view.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 976 "../src/game-view.vala"
	return _data3_;
#line 4833 "game-view.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 976 "../src/game-view.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 4843 "game-view.c"
		GameView* self;
#line 976 "../src/game-view.vala"
		self = _data3_->self;
#line 976 "../src/game-view.vala"
		_g_object_unref0 (self);
#line 976 "../src/game-view.vala"
		g_slice_free (Block3Data, _data3_);
#line 4851 "game-view.c"
	}
}

static gboolean
______lambda11_ (Block3Data* _data3_)
{
	GameView* self;
	gboolean result = FALSE;
#line 998 "../src/game-view.vala"
	self = _data3_->self;
#line 999 "../src/game-view.vala"
	if (self->priv->mouse_is_in) {
#line 1000 "../src/game-view.vala"
		_game_view_on_motion (self, _data3_->x, _data3_->y, FALSE);
#line 4866 "game-view.c"
	}
#line 1001 "../src/game-view.vala"
	self->priv->timeout_id = (guint) 0;
#line 1002 "../src/game-view.vala"
	result = G_SOURCE_REMOVE;
#line 1002 "../src/game-view.vala"
	return result;
#line 4874 "game-view.c"
}

static gboolean
_______lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = ______lambda11_ (self);
#line 998 "../src/game-view.vala"
	return result;
#line 4884 "game-view.c"
}

static void
game_view_on_motion (GameView* self,
                     GtkEventControllerMotion* _motion_controller,
                     gdouble event_x,
                     gdouble event_y)
{
	Block3Data* _data3_;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
	gboolean _tmp2_;
#line 976 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 976 "../src/game-view.vala"
	g_return_if_fail (_motion_controller != NULL);
#line 976 "../src/game-view.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 976 "../src/game-view.vala"
	_data3_->_ref_count_ = 1;
#line 976 "../src/game-view.vala"
	_data3_->self = g_object_ref (self);
#line 980 "../src/game-view.vala"
	_tmp2_ = game_view_pointer_is_in_board (self, event_x, event_y, &_tmp0_, &_tmp1_);
#line 980 "../src/game-view.vala"
	_data3_->x = _tmp0_;
#line 980 "../src/game-view.vala"
	_data3_->y = _tmp1_;
#line 980 "../src/game-view.vala"
	if (_tmp2_) {
#line 982 "../src/game-view.vala"
		if (!self->priv->mouse_is_in) {
#line 983 "../src/game-view.vala"
			game_view_on_cursor_moving_in (self, _data3_->x, _data3_->y);
#line 4919 "game-view.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 984 "../src/game-view.vala"
			if (_data3_->x != self->priv->mouse_position_x) {
#line 984 "../src/game-view.vala"
				_tmp3_ = TRUE;
#line 4926 "game-view.c"
			} else {
#line 984 "../src/game-view.vala"
				_tmp3_ = _data3_->y != self->priv->mouse_position_y;
#line 4930 "game-view.c"
			}
#line 984 "../src/game-view.vala"
			if (_tmp3_) {
#line 4934 "game-view.c"
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
#line 986 "../src/game-view.vala"
				self->priv->mouse_position_x = _data3_->x;
#line 987 "../src/game-view.vala"
				self->priv->mouse_position_y = _data3_->y;
#line 988 "../src/game-view.vala"
				self->priv->mouse_position_set = TRUE;
#line 989 "../src/game-view.vala"
				if (self->priv->show_highlight) {
#line 989 "../src/game-view.vala"
					_tmp5_ = TRUE;
#line 4947 "game-view.c"
				} else {
#line 990 "../src/game-view.vala"
					_tmp5_ = _data3_->x != self->priv->mouse_highlight_x;
#line 4951 "game-view.c"
				}
#line 989 "../src/game-view.vala"
				if (_tmp5_) {
#line 989 "../src/game-view.vala"
					_tmp4_ = TRUE;
#line 4957 "game-view.c"
				} else {
#line 991 "../src/game-view.vala"
					_tmp4_ = _data3_->y != self->priv->mouse_highlight_y;
#line 4961 "game-view.c"
				}
#line 989 "../src/game-view.vala"
				if (_tmp4_) {
#line 993 "../src/game-view.vala"
					if (self->priv->timeout_id != ((guint) 0)) {
#line 995 "../src/game-view.vala"
						g_source_remove (self->priv->timeout_id);
#line 996 "../src/game-view.vala"
						self->priv->timeout_id = (guint) 0;
#line 4971 "game-view.c"
					}
#line 998 "../src/game-view.vala"
					self->priv->timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _______lambda11__gsource_func, block3_data_ref (_data3_), block3_data_unref);
#line 4975 "game-view.c"
				}
			}
		}
	} else {
#line 1009 "../src/game-view.vala"
		self->priv->mouse_is_in = FALSE;
#line 1010 "../src/game-view.vala"
		self->priv->show_mouse_highlight = FALSE;
#line 1011 "../src/game-view.vala"
		if (self->priv->mouse_position_set) {
#line 1012 "../src/game-view.vala"
			game_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 4988 "game-view.c"
		}
	}
#line 976 "../src/game-view.vala"
	block3_data_unref (_data3_);
#line 976 "../src/game-view.vala"
	_data3_ = NULL;
#line 4995 "game-view.c"
}

static void
_game_view_on_motion (GameView* self,
                      guint8 x,
                      guint8 y,
                      gboolean force_redraw)
{
	gboolean _tmp0_ = FALSE;
	gboolean old_show_mouse_highlight = FALSE;
	PossibleMove move = {0};
	gboolean _tmp2_ = FALSE;
	gboolean _tmp7_ = FALSE;
	guint8 old_mouse_highlight_x = 0U;
	guint8 old_mouse_highlight_y = 0U;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
#line 1015 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 1017 "../src/game-view.vala"
	if (!force_redraw) {
#line 5019 "game-view.c"
		gboolean _tmp1_ = FALSE;
#line 1018 "../src/game-view.vala"
		if (x != self->priv->mouse_position_x) {
#line 1018 "../src/game-view.vala"
			_tmp1_ = TRUE;
#line 5025 "game-view.c"
		} else {
#line 1019 "../src/game-view.vala"
			_tmp1_ = y != self->priv->mouse_position_y;
#line 5029 "game-view.c"
		}
#line 1018 "../src/game-view.vala"
		_tmp0_ = _tmp1_;
#line 5033 "game-view.c"
	} else {
#line 1017 "../src/game-view.vala"
		_tmp0_ = FALSE;
#line 5037 "game-view.c"
	}
#line 1017 "../src/game-view.vala"
	if (_tmp0_) {
#line 1020 "../src/game-view.vala"
		return;
#line 5043 "game-view.c"
	}
#line 1022 "../src/game-view.vala"
	old_show_mouse_highlight = self->priv->show_mouse_highlight;
#line 1024 "../src/game-view.vala"
	if (self->priv->mouse_is_in) {
#line 5049 "game-view.c"
		Game* _tmp3_;
		Game* _tmp4_;
		PossibleMove _tmp5_ = {0};
		gboolean _tmp6_;
#line 1024 "../src/game-view.vala"
		_tmp3_ = game_view_get_game (self);
#line 1024 "../src/game-view.vala"
		_tmp4_ = _tmp3_;
#line 1024 "../src/game-view.vala"
		_tmp6_ = game_test_placing_tile (_tmp4_, x, y, &_tmp5_);
#line 1024 "../src/game-view.vala"
		move = _tmp5_;
#line 1024 "../src/game-view.vala"
		_tmp2_ = _tmp6_;
#line 5064 "game-view.c"
	} else {
#line 1024 "../src/game-view.vala"
		_tmp2_ = FALSE;
#line 5068 "game-view.c"
	}
#line 1024 "../src/game-view.vala"
	self->priv->show_mouse_highlight = _tmp2_;
#line 1026 "../src/game-view.vala"
	if (self->priv->show_mouse_highlight) {
#line 1027 "../src/game-view.vala"
		g_signal_emit (self, game_view_signals[GAME_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL], 0);
#line 5076 "game-view.c"
	}
#line 1029 "../src/game-view.vala"
	if (old_show_mouse_highlight) {
#line 1029 "../src/game-view.vala"
		_tmp7_ = !self->priv->show_mouse_highlight;
#line 5082 "game-view.c"
	} else {
#line 1029 "../src/game-view.vala"
		_tmp7_ = FALSE;
#line 5086 "game-view.c"
	}
#line 1029 "../src/game-view.vala"
	if (_tmp7_) {
#line 1031 "../src/game-view.vala"
		self->priv->old_highlight_x = G_MAXUINT8;
#line 1032 "../src/game-view.vala"
		self->priv->old_highlight_y = G_MAXUINT8;
#line 5094 "game-view.c"
	}
#line 1035 "../src/game-view.vala"
	old_mouse_highlight_x = self->priv->mouse_highlight_x;
#line 1036 "../src/game-view.vala"
	old_mouse_highlight_y = self->priv->mouse_highlight_y;
#line 1038 "../src/game-view.vala"
	self->priv->mouse_highlight_x = x;
#line 1039 "../src/game-view.vala"
	self->priv->mouse_highlight_y = y;
#line 1041 "../src/game-view.vala"
	if (old_mouse_highlight_x != G_MAXUINT8) {
#line 1041 "../src/game-view.vala"
		_tmp8_ = old_mouse_highlight_y != G_MAXUINT8;
#line 5108 "game-view.c"
	} else {
#line 1041 "../src/game-view.vala"
		_tmp8_ = FALSE;
#line 5112 "game-view.c"
	}
#line 1041 "../src/game-view.vala"
	if (_tmp8_) {
#line 1042 "../src/game-view.vala"
		game_view_queue_draw_tile (self, old_mouse_highlight_x, old_mouse_highlight_y);
#line 5118 "game-view.c"
	}
#line 1043 "../src/game-view.vala"
	if (self->priv->show_mouse_highlight) {
#line 1043 "../src/game-view.vala"
		_tmp9_ = self->priv->show_highlight;
#line 5124 "game-view.c"
	} else {
#line 1043 "../src/game-view.vala"
		_tmp9_ = FALSE;
#line 5128 "game-view.c"
	}
#line 1043 "../src/game-view.vala"
	if (_tmp9_) {
#line 5132 "game-view.c"
		gboolean _tmp10_ = FALSE;
#line 1045 "../src/game-view.vala"
		self->priv->show_highlight = FALSE;
#line 1046 "../src/game-view.vala"
		if (self->priv->highlight_x != x) {
#line 1046 "../src/game-view.vala"
			_tmp10_ = TRUE;
#line 5140 "game-view.c"
		} else {
#line 1046 "../src/game-view.vala"
			_tmp10_ = self->priv->highlight_y != y;
#line 5144 "game-view.c"
		}
#line 1046 "../src/game-view.vala"
		if (_tmp10_) {
#line 1047 "../src/game-view.vala"
			game_view_queue_draw_tile (self, self->priv->highlight_x, self->priv->highlight_y);
#line 5150 "game-view.c"
		}
	}
#line 1049 "../src/game-view.vala"
	if (self->priv->show_mouse_highlight) {
#line 1049 "../src/game-view.vala"
		_tmp12_ = TRUE;
#line 5157 "game-view.c"
	} else {
#line 1049 "../src/game-view.vala"
		_tmp12_ = force_redraw;
#line 5161 "game-view.c"
	}
#line 1049 "../src/game-view.vala"
	if (_tmp12_) {
#line 5165 "game-view.c"
		gboolean _tmp13_ = FALSE;
#line 1051 "../src/game-view.vala"
		if (self->priv->mouse_highlight_x != G_MAXUINT8) {
#line 1051 "../src/game-view.vala"
			_tmp13_ = self->priv->mouse_highlight_y != G_MAXUINT8;
#line 5171 "game-view.c"
		} else {
#line 1051 "../src/game-view.vala"
			_tmp13_ = FALSE;
#line 5175 "game-view.c"
		}
#line 1051 "../src/game-view.vala"
		_tmp11_ = _tmp13_;
#line 5179 "game-view.c"
	} else {
#line 1049 "../src/game-view.vala"
		_tmp11_ = FALSE;
#line 5183 "game-view.c"
	}
#line 1049 "../src/game-view.vala"
	if (_tmp11_) {
#line 1053 "../src/game-view.vala"
		game_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 5189 "game-view.c"
	}
}

static gboolean
game_view_real_button_press_event (GtkWidget* base,
                                   GdkEventButton* event)
{
	GameView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 1057 "../src/game-view.vala"
	self = (GameView*) base;
#line 1057 "../src/game-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1059 "../src/game-view.vala"
	if (!self->priv->game_is_set) {
#line 1060 "../src/game-view.vala"
		result = FALSE;
#line 1060 "../src/game-view.vala"
		return result;
#line 5210 "game-view.c"
	}
#line 1062 "../src/game-view.vala"
	if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
#line 1062 "../src/game-view.vala"
		_tmp0_ = TRUE;
#line 5216 "game-view.c"
	} else {
#line 1062 "../src/game-view.vala"
		_tmp0_ = event->button == ((guint) GDK_BUTTON_SECONDARY);
#line 5220 "game-view.c"
	}
#line 1062 "../src/game-view.vala"
	if (_tmp0_) {
#line 5224 "game-view.c"
		guint8 x = 0U;
		guint8 y = 0U;
		guint8 _tmp1_ = 0U;
		guint8 _tmp2_ = 0U;
		gboolean _tmp3_;
#line 1066 "../src/game-view.vala"
		_tmp3_ = game_view_pointer_is_in_board (self, event->x, event->y, &_tmp1_, &_tmp2_);
#line 1066 "../src/game-view.vala"
		x = _tmp1_;
#line 1066 "../src/game-view.vala"
		y = _tmp2_;
#line 1066 "../src/game-view.vala"
		if (_tmp3_) {
#line 1068 "../src/game-view.vala"
			self->priv->mouse_is_in = TRUE;
#line 1069 "../src/game-view.vala"
			self->priv->show_highlight = FALSE;
#line 1070 "../src/game-view.vala"
			self->priv->old_highlight_x = self->priv->highlight_x;
#line 1071 "../src/game-view.vala"
			self->priv->old_highlight_y = self->priv->highlight_y;
#line 1072 "../src/game-view.vala"
			gtk_widget_queue_draw ((GtkWidget*) self);
#line 1073 "../src/game-view.vala"
			self->priv->highlight_set = TRUE;
#line 1074 "../src/game-view.vala"
			self->priv->highlight_x = x;
#line 1075 "../src/game-view.vala"
			self->priv->highlight_y = y;
#line 1076 "../src/game-view.vala"
			game_view_move_if_possible (self, self->priv->highlight_x, self->priv->highlight_y);
#line 5256 "game-view.c"
		}
	}
#line 1080 "../src/game-view.vala"
	result = TRUE;
#line 1080 "../src/game-view.vala"
	return result;
#line 5263 "game-view.c"
}

static gboolean
game_view_real_key_press_event (GtkWidget* base,
                                GdkEventKey* event)
{
	GameView * self;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* key = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	GQuark _tmp65_ = 0U;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label0 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label1 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label2 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label3 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label4 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label5 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label6 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label7 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label8 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label9 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label10 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label11 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label12 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label13 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label14 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label15 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label16 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label17 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label18 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label19 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label20 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label21 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label22 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label23 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label24 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label25 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label26 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label27 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label28 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label29 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label30 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label31 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label32 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label33 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label34 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label35 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label36 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label37 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label38 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label39 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label40 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label41 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label42 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label43 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label44 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label45 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label46 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label47 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label48 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label49 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label50 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label51 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label52 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label53 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label54 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label55 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label56 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label57 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label58 = 0;
#line 1106 "../src/game-view.vala"
	static GQuark _tmp64_label59 = 0;
#line 5406 "game-view.c"
	gboolean _tmp92_ = FALSE;
	gboolean _tmp93_ = FALSE;
	const gchar* _tmp94_;
	const gchar* _tmp97_;
	gboolean _tmp98_ = FALSE;
	const gchar* _tmp99_;
#line 1083 "../src/game-view.vala"
	self = (GameView*) base;
#line 1083 "../src/game-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1085 "../src/game-view.vala"
	if (!self->priv->game_is_set) {
#line 1086 "../src/game-view.vala"
		result = FALSE;
#line 1086 "../src/game-view.vala"
		return result;
#line 5423 "game-view.c"
	}
#line 1088 "../src/game-view.vala"
	_tmp1_ = gdk_keyval_name (event->keyval);
#line 1088 "../src/game-view.vala"
	_tmp0_ = _tmp1_;
#line 1088 "../src/game-view.vala"
	if (_tmp0_ == NULL) {
#line 1088 "../src/game-view.vala"
		_tmp0_ = "";
#line 5433 "game-view.c"
	}
#line 1088 "../src/game-view.vala"
	_tmp2_ = g_strdup ((const gchar*) _tmp0_);
#line 1088 "../src/game-view.vala"
	key = _tmp2_;
#line 1090 "../src/game-view.vala"
	if (self->priv->show_highlight) {
#line 5441 "game-view.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
#line 1090 "../src/game-view.vala"
		_tmp6_ = key;
#line 1090 "../src/game-view.vala"
		if (g_strcmp0 (_tmp6_, "space") == 0) {
#line 1090 "../src/game-view.vala"
			_tmp5_ = TRUE;
#line 5451 "game-view.c"
		} else {
			const gchar* _tmp7_;
#line 1090 "../src/game-view.vala"
			_tmp7_ = key;
#line 1090 "../src/game-view.vala"
			_tmp5_ = g_strcmp0 (_tmp7_, "Return") == 0;
#line 5458 "game-view.c"
		}
#line 1090 "../src/game-view.vala"
		if (_tmp5_) {
#line 1090 "../src/game-view.vala"
			_tmp4_ = TRUE;
#line 5464 "game-view.c"
		} else {
			const gchar* _tmp8_;
#line 1090 "../src/game-view.vala"
			_tmp8_ = key;
#line 1090 "../src/game-view.vala"
			_tmp4_ = g_strcmp0 (_tmp8_, "KP_Enter") == 0;
#line 5471 "game-view.c"
		}
#line 1090 "../src/game-view.vala"
		_tmp3_ = _tmp4_;
#line 5475 "game-view.c"
	} else {
#line 1090 "../src/game-view.vala"
		_tmp3_ = FALSE;
#line 5479 "game-view.c"
	}
#line 1090 "../src/game-view.vala"
	if (_tmp3_) {
#line 1092 "../src/game-view.vala"
		game_view_move_if_possible (self, self->priv->highlight_x, self->priv->highlight_y);
#line 1093 "../src/game-view.vala"
		result = TRUE;
#line 1093 "../src/game-view.vala"
		_g_free0 (key);
#line 1093 "../src/game-view.vala"
		return result;
#line 5491 "game-view.c"
	}
#line 1096 "../src/game-view.vala"
	if (((gint) self->priv->game_size) <= 4) {
#line 5495 "game-view.c"
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		const gchar* _tmp18_;
#line 1096 "../src/game-view.vala"
		_tmp18_ = key;
#line 1096 "../src/game-view.vala"
		if (g_strcmp0 (_tmp18_, "e") == 0) {
#line 1096 "../src/game-view.vala"
			_tmp17_ = TRUE;
#line 5506 "game-view.c"
		} else {
			const gchar* _tmp19_;
#line 1096 "../src/game-view.vala"
			_tmp19_ = key;
#line 1096 "../src/game-view.vala"
			_tmp17_ = g_strcmp0 (_tmp19_, "E") == 0;
#line 5513 "game-view.c"
		}
#line 1096 "../src/game-view.vala"
		if (_tmp17_) {
#line 1096 "../src/game-view.vala"
			_tmp16_ = TRUE;
#line 5519 "game-view.c"
		} else {
			const gchar* _tmp20_;
#line 1096 "../src/game-view.vala"
			_tmp20_ = key;
#line 1096 "../src/game-view.vala"
			_tmp16_ = g_strcmp0 (_tmp20_, "5") == 0;
#line 5526 "game-view.c"
		}
#line 1096 "../src/game-view.vala"
		if (_tmp16_) {
#line 1096 "../src/game-view.vala"
			_tmp15_ = TRUE;
#line 5532 "game-view.c"
		} else {
			const gchar* _tmp21_;
#line 1096 "../src/game-view.vala"
			_tmp21_ = key;
#line 1096 "../src/game-view.vala"
			_tmp15_ = g_strcmp0 (_tmp21_, "KP_5") == 0;
#line 5539 "game-view.c"
		}
#line 1096 "../src/game-view.vala"
		_tmp14_ = _tmp15_;
#line 5543 "game-view.c"
	} else {
#line 1096 "../src/game-view.vala"
		_tmp14_ = FALSE;
#line 5547 "game-view.c"
	}
#line 1096 "../src/game-view.vala"
	if (_tmp14_) {
#line 1096 "../src/game-view.vala"
		_tmp13_ = TRUE;
#line 5553 "game-view.c"
	} else {
		gboolean _tmp22_ = FALSE;
#line 1097 "../src/game-view.vala"
		if (((gint) self->priv->game_size) <= 5) {
#line 5558 "game-view.c"
			gboolean _tmp23_ = FALSE;
			gboolean _tmp24_ = FALSE;
			gboolean _tmp25_ = FALSE;
			const gchar* _tmp26_;
#line 1097 "../src/game-view.vala"
			_tmp26_ = key;
#line 1097 "../src/game-view.vala"
			if (g_strcmp0 (_tmp26_, "f") == 0) {
#line 1097 "../src/game-view.vala"
				_tmp25_ = TRUE;
#line 5569 "game-view.c"
			} else {
				const gchar* _tmp27_;
#line 1097 "../src/game-view.vala"
				_tmp27_ = key;
#line 1097 "../src/game-view.vala"
				_tmp25_ = g_strcmp0 (_tmp27_, "F") == 0;
#line 5576 "game-view.c"
			}
#line 1097 "../src/game-view.vala"
			if (_tmp25_) {
#line 1097 "../src/game-view.vala"
				_tmp24_ = TRUE;
#line 5582 "game-view.c"
			} else {
				const gchar* _tmp28_;
#line 1097 "../src/game-view.vala"
				_tmp28_ = key;
#line 1097 "../src/game-view.vala"
				_tmp24_ = g_strcmp0 (_tmp28_, "6") == 0;
#line 5589 "game-view.c"
			}
#line 1097 "../src/game-view.vala"
			if (_tmp24_) {
#line 1097 "../src/game-view.vala"
				_tmp23_ = TRUE;
#line 5595 "game-view.c"
			} else {
				const gchar* _tmp29_;
#line 1097 "../src/game-view.vala"
				_tmp29_ = key;
#line 1097 "../src/game-view.vala"
				_tmp23_ = g_strcmp0 (_tmp29_, "KP_6") == 0;
#line 5602 "game-view.c"
			}
#line 1097 "../src/game-view.vala"
			_tmp22_ = _tmp23_;
#line 5606 "game-view.c"
		} else {
#line 1097 "../src/game-view.vala"
			_tmp22_ = FALSE;
#line 5610 "game-view.c"
		}
#line 1097 "../src/game-view.vala"
		_tmp13_ = _tmp22_;
#line 5614 "game-view.c"
	}
#line 1096 "../src/game-view.vala"
	if (_tmp13_) {
#line 1096 "../src/game-view.vala"
		_tmp12_ = TRUE;
#line 5620 "game-view.c"
	} else {
		gboolean _tmp30_ = FALSE;
#line 1098 "../src/game-view.vala"
		if (((gint) self->priv->game_size) <= 6) {
#line 5625 "game-view.c"
			gboolean _tmp31_ = FALSE;
			gboolean _tmp32_ = FALSE;
			gboolean _tmp33_ = FALSE;
			const gchar* _tmp34_;
#line 1098 "../src/game-view.vala"
			_tmp34_ = key;
#line 1098 "../src/game-view.vala"
			if (g_strcmp0 (_tmp34_, "g") == 0) {
#line 1098 "../src/game-view.vala"
				_tmp33_ = TRUE;
#line 5636 "game-view.c"
			} else {
				const gchar* _tmp35_;
#line 1098 "../src/game-view.vala"
				_tmp35_ = key;
#line 1098 "../src/game-view.vala"
				_tmp33_ = g_strcmp0 (_tmp35_, "G") == 0;
#line 5643 "game-view.c"
			}
#line 1098 "../src/game-view.vala"
			if (_tmp33_) {
#line 1098 "../src/game-view.vala"
				_tmp32_ = TRUE;
#line 5649 "game-view.c"
			} else {
				const gchar* _tmp36_;
#line 1098 "../src/game-view.vala"
				_tmp36_ = key;
#line 1098 "../src/game-view.vala"
				_tmp32_ = g_strcmp0 (_tmp36_, "7") == 0;
#line 5656 "game-view.c"
			}
#line 1098 "../src/game-view.vala"
			if (_tmp32_) {
#line 1098 "../src/game-view.vala"
				_tmp31_ = TRUE;
#line 5662 "game-view.c"
			} else {
				const gchar* _tmp37_;
#line 1098 "../src/game-view.vala"
				_tmp37_ = key;
#line 1098 "../src/game-view.vala"
				_tmp31_ = g_strcmp0 (_tmp37_, "KP_7") == 0;
#line 5669 "game-view.c"
			}
#line 1098 "../src/game-view.vala"
			_tmp30_ = _tmp31_;
#line 5673 "game-view.c"
		} else {
#line 1098 "../src/game-view.vala"
			_tmp30_ = FALSE;
#line 5677 "game-view.c"
		}
#line 1098 "../src/game-view.vala"
		_tmp12_ = _tmp30_;
#line 5681 "game-view.c"
	}
#line 1096 "../src/game-view.vala"
	if (_tmp12_) {
#line 1096 "../src/game-view.vala"
		_tmp11_ = TRUE;
#line 5687 "game-view.c"
	} else {
		gboolean _tmp38_ = FALSE;
#line 1099 "../src/game-view.vala"
		if (((gint) self->priv->game_size) <= 7) {
#line 5692 "game-view.c"
			gboolean _tmp39_ = FALSE;
			gboolean _tmp40_ = FALSE;
			gboolean _tmp41_ = FALSE;
			const gchar* _tmp42_;
#line 1099 "../src/game-view.vala"
			_tmp42_ = key;
#line 1099 "../src/game-view.vala"
			if (g_strcmp0 (_tmp42_, "h") == 0) {
#line 1099 "../src/game-view.vala"
				_tmp41_ = TRUE;
#line 5703 "game-view.c"
			} else {
				const gchar* _tmp43_;
#line 1099 "../src/game-view.vala"
				_tmp43_ = key;
#line 1099 "../src/game-view.vala"
				_tmp41_ = g_strcmp0 (_tmp43_, "H") == 0;
#line 5710 "game-view.c"
			}
#line 1099 "../src/game-view.vala"
			if (_tmp41_) {
#line 1099 "../src/game-view.vala"
				_tmp40_ = TRUE;
#line 5716 "game-view.c"
			} else {
				const gchar* _tmp44_;
#line 1099 "../src/game-view.vala"
				_tmp44_ = key;
#line 1099 "../src/game-view.vala"
				_tmp40_ = g_strcmp0 (_tmp44_, "8") == 0;
#line 5723 "game-view.c"
			}
#line 1099 "../src/game-view.vala"
			if (_tmp40_) {
#line 1099 "../src/game-view.vala"
				_tmp39_ = TRUE;
#line 5729 "game-view.c"
			} else {
				const gchar* _tmp45_;
#line 1099 "../src/game-view.vala"
				_tmp45_ = key;
#line 1099 "../src/game-view.vala"
				_tmp39_ = g_strcmp0 (_tmp45_, "KP_8") == 0;
#line 5736 "game-view.c"
			}
#line 1099 "../src/game-view.vala"
			_tmp38_ = _tmp39_;
#line 5740 "game-view.c"
		} else {
#line 1099 "../src/game-view.vala"
			_tmp38_ = FALSE;
#line 5744 "game-view.c"
		}
#line 1099 "../src/game-view.vala"
		_tmp11_ = _tmp38_;
#line 5748 "game-view.c"
	}
#line 1096 "../src/game-view.vala"
	if (_tmp11_) {
#line 1096 "../src/game-view.vala"
		_tmp10_ = TRUE;
#line 5754 "game-view.c"
	} else {
		gboolean _tmp46_ = FALSE;
#line 1100 "../src/game-view.vala"
		if (((gint) self->priv->game_size) <= 8) {
#line 5759 "game-view.c"
			gboolean _tmp47_ = FALSE;
			gboolean _tmp48_ = FALSE;
			gboolean _tmp49_ = FALSE;
			const gchar* _tmp50_;
#line 1100 "../src/game-view.vala"
			_tmp50_ = key;
#line 1100 "../src/game-view.vala"
			if (g_strcmp0 (_tmp50_, "i") == 0) {
#line 1100 "../src/game-view.vala"
				_tmp49_ = TRUE;
#line 5770 "game-view.c"
			} else {
				const gchar* _tmp51_;
#line 1100 "../src/game-view.vala"
				_tmp51_ = key;
#line 1100 "../src/game-view.vala"
				_tmp49_ = g_strcmp0 (_tmp51_, "I") == 0;
#line 5777 "game-view.c"
			}
#line 1100 "../src/game-view.vala"
			if (_tmp49_) {
#line 1100 "../src/game-view.vala"
				_tmp48_ = TRUE;
#line 5783 "game-view.c"
			} else {
				const gchar* _tmp52_;
#line 1100 "../src/game-view.vala"
				_tmp52_ = key;
#line 1100 "../src/game-view.vala"
				_tmp48_ = g_strcmp0 (_tmp52_, "9") == 0;
#line 5790 "game-view.c"
			}
#line 1100 "../src/game-view.vala"
			if (_tmp48_) {
#line 1100 "../src/game-view.vala"
				_tmp47_ = TRUE;
#line 5796 "game-view.c"
			} else {
				const gchar* _tmp53_;
#line 1100 "../src/game-view.vala"
				_tmp53_ = key;
#line 1100 "../src/game-view.vala"
				_tmp47_ = g_strcmp0 (_tmp53_, "KP_9") == 0;
#line 5803 "game-view.c"
			}
#line 1100 "../src/game-view.vala"
			_tmp46_ = _tmp47_;
#line 5807 "game-view.c"
		} else {
#line 1100 "../src/game-view.vala"
			_tmp46_ = FALSE;
#line 5811 "game-view.c"
		}
#line 1100 "../src/game-view.vala"
		_tmp10_ = _tmp46_;
#line 5815 "game-view.c"
	}
#line 1096 "../src/game-view.vala"
	if (_tmp10_) {
#line 1096 "../src/game-view.vala"
		_tmp9_ = TRUE;
#line 5821 "game-view.c"
	} else {
		gboolean _tmp54_ = FALSE;
#line 1101 "../src/game-view.vala"
		if (((gint) self->priv->game_size) <= 9) {
#line 5826 "game-view.c"
			gboolean _tmp55_ = FALSE;
			gboolean _tmp56_ = FALSE;
			gboolean _tmp57_ = FALSE;
			const gchar* _tmp58_;
#line 1101 "../src/game-view.vala"
			_tmp58_ = key;
#line 1101 "../src/game-view.vala"
			if (g_strcmp0 (_tmp58_, "j") == 0) {
#line 1101 "../src/game-view.vala"
				_tmp57_ = TRUE;
#line 5837 "game-view.c"
			} else {
				const gchar* _tmp59_;
#line 1101 "../src/game-view.vala"
				_tmp59_ = key;
#line 1101 "../src/game-view.vala"
				_tmp57_ = g_strcmp0 (_tmp59_, "J") == 0;
#line 5844 "game-view.c"
			}
#line 1101 "../src/game-view.vala"
			if (_tmp57_) {
#line 1101 "../src/game-view.vala"
				_tmp56_ = TRUE;
#line 5850 "game-view.c"
			} else {
				const gchar* _tmp60_;
#line 1101 "../src/game-view.vala"
				_tmp60_ = key;
#line 1101 "../src/game-view.vala"
				_tmp56_ = g_strcmp0 (_tmp60_, "0") == 0;
#line 5857 "game-view.c"
			}
#line 1101 "../src/game-view.vala"
			if (_tmp56_) {
#line 1101 "../src/game-view.vala"
				_tmp55_ = TRUE;
#line 5863 "game-view.c"
			} else {
				const gchar* _tmp61_;
#line 1101 "../src/game-view.vala"
				_tmp61_ = key;
#line 1101 "../src/game-view.vala"
				_tmp55_ = g_strcmp0 (_tmp61_, "KP_0") == 0;
#line 5870 "game-view.c"
			}
#line 1101 "../src/game-view.vala"
			_tmp54_ = _tmp55_;
#line 5874 "game-view.c"
		} else {
#line 1101 "../src/game-view.vala"
			_tmp54_ = FALSE;
#line 5878 "game-view.c"
		}
#line 1101 "../src/game-view.vala"
		_tmp9_ = _tmp54_;
#line 5882 "game-view.c"
	}
#line 1096 "../src/game-view.vala"
	if (_tmp9_) {
#line 1102 "../src/game-view.vala"
		result = FALSE;
#line 1102 "../src/game-view.vala"
		_g_free0 (key);
#line 1102 "../src/game-view.vala"
		return result;
#line 5892 "game-view.c"
	}
#line 1104 "../src/game-view.vala"
	self->priv->old_highlight_x = self->priv->highlight_x;
#line 1105 "../src/game-view.vala"
	self->priv->old_highlight_y = self->priv->highlight_y;
#line 1106 "../src/game-view.vala"
	_tmp62_ = key;
#line 1106 "../src/game-view.vala"
	_tmp63_ = _tmp62_;
#line 1106 "../src/game-view.vala"
	_tmp65_ = (NULL == _tmp63_) ? 0 : g_quark_from_string (_tmp63_);
#line 1106 "../src/game-view.vala"
	if ((_tmp65_ == ((0 != _tmp64_label0) ? _tmp64_label0 : (_tmp64_label0 = g_quark_from_static_string ("Left")))) || (_tmp65_ == ((0 != _tmp64_label1) ? _tmp64_label1 : (_tmp64_label1 = g_quark_from_static_string ("KP_Left"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 5908 "game-view.c"
			default:
			{
				gboolean _tmp66_ = FALSE;
#line 1110 "../src/game-view.vala"
				if (self->priv->mouse_position_set) {
#line 1110 "../src/game-view.vala"
					_tmp66_ = self->priv->show_mouse_highlight;
#line 5916 "game-view.c"
				} else {
#line 1110 "../src/game-view.vala"
					_tmp66_ = FALSE;
#line 5920 "game-view.c"
				}
#line 1110 "../src/game-view.vala"
				if (_tmp66_) {
#line 1110 "../src/game-view.vala"
					self->priv->highlight_x = self->priv->mouse_highlight_x;
#line 1110 "../src/game-view.vala"
					self->priv->highlight_y = self->priv->mouse_highlight_y;
#line 5928 "game-view.c"
				} else {
					gboolean _tmp67_ = FALSE;
#line 1111 "../src/game-view.vala"
					if (!self->priv->highlight_set) {
#line 5933 "game-view.c"
						Game* _tmp68_;
						Game* _tmp69_;
						Player _tmp70_;
						Player _tmp71_;
#line 1111 "../src/game-view.vala"
						_tmp68_ = game_view_get_game (self);
#line 1111 "../src/game-view.vala"
						_tmp69_ = _tmp68_;
#line 1111 "../src/game-view.vala"
						_tmp70_ = game_get_current_color (_tmp69_);
#line 1111 "../src/game-view.vala"
						_tmp71_ = _tmp70_;
#line 1111 "../src/game-view.vala"
						_tmp67_ = _tmp71_ == PLAYER_LIGHT;
#line 5948 "game-view.c"
					} else {
#line 1111 "../src/game-view.vala"
						_tmp67_ = FALSE;
#line 5952 "game-view.c"
					}
#line 1111 "../src/game-view.vala"
					if (_tmp67_) {
#line 1111 "../src/game-view.vala"
						self->priv->highlight_y = (guint8) (self->priv->game_size / 2);
#line 5958 "game-view.c"
					}
				}
#line 1112 "../src/game-view.vala"
				if (((gint) self->priv->highlight_x) > 0) {
#line 5963 "game-view.c"
					guint8 _tmp72_;
#line 1112 "../src/game-view.vala"
					_tmp72_ = self->priv->highlight_x;
#line 1112 "../src/game-view.vala"
					self->priv->highlight_x = _tmp72_ - 1;
#line 5969 "game-view.c"
				}
#line 1113 "../src/game-view.vala"
				break;
#line 5973 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label2) ? _tmp64_label2 : (_tmp64_label2 = g_quark_from_static_string ("Right")))) || (_tmp65_ == ((0 != _tmp64_label3) ? _tmp64_label3 : (_tmp64_label3 = g_quark_from_static_string ("KP_Right"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 5979 "game-view.c"
			default:
			{
				gboolean _tmp73_ = FALSE;
#line 1116 "../src/game-view.vala"
				if (self->priv->mouse_position_set) {
#line 1116 "../src/game-view.vala"
					_tmp73_ = self->priv->show_mouse_highlight;
#line 5987 "game-view.c"
				} else {
#line 1116 "../src/game-view.vala"
					_tmp73_ = FALSE;
#line 5991 "game-view.c"
				}
#line 1116 "../src/game-view.vala"
				if (_tmp73_) {
#line 1116 "../src/game-view.vala"
					self->priv->highlight_x = self->priv->mouse_highlight_x;
#line 1116 "../src/game-view.vala"
					self->priv->highlight_y = self->priv->mouse_highlight_y;
#line 5999 "game-view.c"
				} else {
#line 1117 "../src/game-view.vala"
					if (!self->priv->highlight_set) {
#line 6003 "game-view.c"
						Game* _tmp74_;
						Game* _tmp75_;
						Player _tmp76_;
						Player _tmp77_;
#line 1119 "../src/game-view.vala"
						self->priv->highlight_x = (guint8) (self->priv->game_size / 2);
#line 1120 "../src/game-view.vala"
						_tmp74_ = game_view_get_game (self);
#line 1120 "../src/game-view.vala"
						_tmp75_ = _tmp74_;
#line 1120 "../src/game-view.vala"
						_tmp76_ = game_get_current_color (_tmp75_);
#line 1120 "../src/game-view.vala"
						_tmp77_ = _tmp76_;
#line 1120 "../src/game-view.vala"
						if (_tmp77_ == PLAYER_DARK) {
#line 1120 "../src/game-view.vala"
							self->priv->highlight_y = self->priv->highlight_x;
#line 6022 "game-view.c"
						}
					}
				}
#line 1122 "../src/game-view.vala"
				if (((gint) self->priv->highlight_x) < (self->priv->game_size - 1)) {
#line 6028 "game-view.c"
					guint8 _tmp78_;
#line 1122 "../src/game-view.vala"
					_tmp78_ = self->priv->highlight_x;
#line 1122 "../src/game-view.vala"
					self->priv->highlight_x = _tmp78_ + 1;
#line 6034 "game-view.c"
				}
#line 1123 "../src/game-view.vala"
				break;
#line 6038 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label4) ? _tmp64_label4 : (_tmp64_label4 = g_quark_from_static_string ("Up")))) || (_tmp65_ == ((0 != _tmp64_label5) ? _tmp64_label5 : (_tmp64_label5 = g_quark_from_static_string ("KP_Up"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6044 "game-view.c"
			default:
			{
				gboolean _tmp79_ = FALSE;
#line 1126 "../src/game-view.vala"
				if (self->priv->mouse_position_set) {
#line 1126 "../src/game-view.vala"
					_tmp79_ = self->priv->show_mouse_highlight;
#line 6052 "game-view.c"
				} else {
#line 1126 "../src/game-view.vala"
					_tmp79_ = FALSE;
#line 6056 "game-view.c"
				}
#line 1126 "../src/game-view.vala"
				if (_tmp79_) {
#line 1126 "../src/game-view.vala"
					self->priv->highlight_x = self->priv->mouse_highlight_x;
#line 1126 "../src/game-view.vala"
					self->priv->highlight_y = self->priv->mouse_highlight_y;
#line 6064 "game-view.c"
				} else {
					gboolean _tmp80_ = FALSE;
#line 1127 "../src/game-view.vala"
					if (!self->priv->highlight_set) {
#line 6069 "game-view.c"
						Game* _tmp81_;
						Game* _tmp82_;
						Player _tmp83_;
						Player _tmp84_;
#line 1127 "../src/game-view.vala"
						_tmp81_ = game_view_get_game (self);
#line 1127 "../src/game-view.vala"
						_tmp82_ = _tmp81_;
#line 1127 "../src/game-view.vala"
						_tmp83_ = game_get_current_color (_tmp82_);
#line 1127 "../src/game-view.vala"
						_tmp84_ = _tmp83_;
#line 1127 "../src/game-view.vala"
						_tmp80_ = _tmp84_ == PLAYER_LIGHT;
#line 6084 "game-view.c"
					} else {
#line 1127 "../src/game-view.vala"
						_tmp80_ = FALSE;
#line 6088 "game-view.c"
					}
#line 1127 "../src/game-view.vala"
					if (_tmp80_) {
#line 1127 "../src/game-view.vala"
						self->priv->highlight_x = (guint8) (self->priv->game_size / 2);
#line 6094 "game-view.c"
					}
				}
#line 1128 "../src/game-view.vala"
				if (((gint) self->priv->highlight_y) > 0) {
#line 6099 "game-view.c"
					guint8 _tmp85_;
#line 1128 "../src/game-view.vala"
					_tmp85_ = self->priv->highlight_y;
#line 1128 "../src/game-view.vala"
					self->priv->highlight_y = _tmp85_ - 1;
#line 6105 "game-view.c"
				}
#line 1129 "../src/game-view.vala"
				break;
#line 6109 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label6) ? _tmp64_label6 : (_tmp64_label6 = g_quark_from_static_string ("Down")))) || (_tmp65_ == ((0 != _tmp64_label7) ? _tmp64_label7 : (_tmp64_label7 = g_quark_from_static_string ("KP_Down"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6115 "game-view.c"
			default:
			{
				gboolean _tmp86_ = FALSE;
#line 1132 "../src/game-view.vala"
				if (self->priv->mouse_position_set) {
#line 1132 "../src/game-view.vala"
					_tmp86_ = self->priv->show_mouse_highlight;
#line 6123 "game-view.c"
				} else {
#line 1132 "../src/game-view.vala"
					_tmp86_ = FALSE;
#line 6127 "game-view.c"
				}
#line 1132 "../src/game-view.vala"
				if (_tmp86_) {
#line 1132 "../src/game-view.vala"
					self->priv->highlight_x = self->priv->mouse_highlight_x;
#line 1132 "../src/game-view.vala"
					self->priv->highlight_y = self->priv->mouse_highlight_y;
#line 6135 "game-view.c"
				} else {
#line 1133 "../src/game-view.vala"
					if (!self->priv->highlight_set) {
#line 6139 "game-view.c"
						Game* _tmp87_;
						Game* _tmp88_;
						Player _tmp89_;
						Player _tmp90_;
#line 1135 "../src/game-view.vala"
						self->priv->highlight_y = (guint8) (self->priv->game_size / 2);
#line 1136 "../src/game-view.vala"
						_tmp87_ = game_view_get_game (self);
#line 1136 "../src/game-view.vala"
						_tmp88_ = _tmp87_;
#line 1136 "../src/game-view.vala"
						_tmp89_ = game_get_current_color (_tmp88_);
#line 1136 "../src/game-view.vala"
						_tmp90_ = _tmp89_;
#line 1136 "../src/game-view.vala"
						if (_tmp90_ == PLAYER_DARK) {
#line 1136 "../src/game-view.vala"
							self->priv->highlight_x = self->priv->highlight_y;
#line 6158 "game-view.c"
						}
					}
				}
#line 1138 "../src/game-view.vala"
				if (((gint) self->priv->highlight_y) < (self->priv->game_size - 1)) {
#line 6164 "game-view.c"
					guint8 _tmp91_;
#line 1138 "../src/game-view.vala"
					_tmp91_ = self->priv->highlight_y;
#line 1138 "../src/game-view.vala"
					self->priv->highlight_y = _tmp91_ + 1;
#line 6170 "game-view.c"
				}
#line 1139 "../src/game-view.vala"
				break;
#line 6174 "game-view.c"
			}
		}
	} else if (((_tmp65_ == ((0 != _tmp64_label8) ? _tmp64_label8 : (_tmp64_label8 = g_quark_from_static_string ("space")))) || (_tmp65_ == ((0 != _tmp64_label9) ? _tmp64_label9 : (_tmp64_label9 = g_quark_from_static_string ("Return"))))) || (_tmp65_ == ((0 != _tmp64_label10) ? _tmp64_label10 : (_tmp64_label10 = g_quark_from_static_string ("KP_Enter"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6180 "game-view.c"
			default:
			{
#line 1144 "../src/game-view.vala"
				if (self->priv->show_mouse_highlight) {
#line 1146 "../src/game-view.vala"
					game_view_move_if_possible (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 1147 "../src/game-view.vala"
					result = TRUE;
#line 1147 "../src/game-view.vala"
					_g_free0 (key);
#line 1147 "../src/game-view.vala"
					return result;
#line 6193 "game-view.c"
				} else {
#line 1149 "../src/game-view.vala"
					if (self->priv->mouse_position_set) {
#line 1151 "../src/game-view.vala"
						self->priv->highlight_x = self->priv->mouse_position_x;
#line 1152 "../src/game-view.vala"
						self->priv->highlight_y = self->priv->mouse_position_y;
#line 6201 "game-view.c"
					}
				}
#line 1154 "../src/game-view.vala"
				break;
#line 6206 "game-view.c"
			}
		}
	} else if (_tmp65_ == ((0 != _tmp64_label11) ? _tmp64_label11 : (_tmp64_label11 = g_quark_from_static_string ("Escape")))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6212 "game-view.c"
			default:
			{
#line 1156 "../src/game-view.vala"
				break;
#line 6217 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label12) ? _tmp64_label12 : (_tmp64_label12 = g_quark_from_static_string ("a")))) || (_tmp65_ == ((0 != _tmp64_label13) ? _tmp64_label13 : (_tmp64_label13 = g_quark_from_static_string ("A"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6223 "game-view.c"
			default:
			{
#line 1158 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 0;
#line 1158 "../src/game-view.vala"
				break;
#line 6230 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label14) ? _tmp64_label14 : (_tmp64_label14 = g_quark_from_static_string ("b")))) || (_tmp65_ == ((0 != _tmp64_label15) ? _tmp64_label15 : (_tmp64_label15 = g_quark_from_static_string ("B"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6236 "game-view.c"
			default:
			{
#line 1159 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 1;
#line 1159 "../src/game-view.vala"
				break;
#line 6243 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label16) ? _tmp64_label16 : (_tmp64_label16 = g_quark_from_static_string ("c")))) || (_tmp65_ == ((0 != _tmp64_label17) ? _tmp64_label17 : (_tmp64_label17 = g_quark_from_static_string ("C"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6249 "game-view.c"
			default:
			{
#line 1160 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 2;
#line 1160 "../src/game-view.vala"
				break;
#line 6256 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label18) ? _tmp64_label18 : (_tmp64_label18 = g_quark_from_static_string ("d")))) || (_tmp65_ == ((0 != _tmp64_label19) ? _tmp64_label19 : (_tmp64_label19 = g_quark_from_static_string ("D"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6262 "game-view.c"
			default:
			{
#line 1161 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 3;
#line 1161 "../src/game-view.vala"
				break;
#line 6269 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label20) ? _tmp64_label20 : (_tmp64_label20 = g_quark_from_static_string ("e")))) || (_tmp65_ == ((0 != _tmp64_label21) ? _tmp64_label21 : (_tmp64_label21 = g_quark_from_static_string ("E"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6275 "game-view.c"
			default:
			{
#line 1162 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 4;
#line 1162 "../src/game-view.vala"
				break;
#line 6282 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label22) ? _tmp64_label22 : (_tmp64_label22 = g_quark_from_static_string ("f")))) || (_tmp65_ == ((0 != _tmp64_label23) ? _tmp64_label23 : (_tmp64_label23 = g_quark_from_static_string ("F"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6288 "game-view.c"
			default:
			{
#line 1163 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 5;
#line 1163 "../src/game-view.vala"
				break;
#line 6295 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label24) ? _tmp64_label24 : (_tmp64_label24 = g_quark_from_static_string ("g")))) || (_tmp65_ == ((0 != _tmp64_label25) ? _tmp64_label25 : (_tmp64_label25 = g_quark_from_static_string ("G"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6301 "game-view.c"
			default:
			{
#line 1164 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 6;
#line 1164 "../src/game-view.vala"
				break;
#line 6308 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label26) ? _tmp64_label26 : (_tmp64_label26 = g_quark_from_static_string ("h")))) || (_tmp65_ == ((0 != _tmp64_label27) ? _tmp64_label27 : (_tmp64_label27 = g_quark_from_static_string ("H"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6314 "game-view.c"
			default:
			{
#line 1165 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 7;
#line 1165 "../src/game-view.vala"
				break;
#line 6321 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label28) ? _tmp64_label28 : (_tmp64_label28 = g_quark_from_static_string ("i")))) || (_tmp65_ == ((0 != _tmp64_label29) ? _tmp64_label29 : (_tmp64_label29 = g_quark_from_static_string ("I"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6327 "game-view.c"
			default:
			{
#line 1166 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 8;
#line 1166 "../src/game-view.vala"
				break;
#line 6334 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label30) ? _tmp64_label30 : (_tmp64_label30 = g_quark_from_static_string ("j")))) || (_tmp65_ == ((0 != _tmp64_label31) ? _tmp64_label31 : (_tmp64_label31 = g_quark_from_static_string ("J"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6340 "game-view.c"
			default:
			{
#line 1167 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 9;
#line 1167 "../src/game-view.vala"
				break;
#line 6347 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label32) ? _tmp64_label32 : (_tmp64_label32 = g_quark_from_static_string ("1")))) || (_tmp65_ == ((0 != _tmp64_label33) ? _tmp64_label33 : (_tmp64_label33 = g_quark_from_static_string ("KP_1"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6353 "game-view.c"
			default:
			{
#line 1169 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 0;
#line 1169 "../src/game-view.vala"
				break;
#line 6360 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label34) ? _tmp64_label34 : (_tmp64_label34 = g_quark_from_static_string ("2")))) || (_tmp65_ == ((0 != _tmp64_label35) ? _tmp64_label35 : (_tmp64_label35 = g_quark_from_static_string ("KP_2"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6366 "game-view.c"
			default:
			{
#line 1170 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 1;
#line 1170 "../src/game-view.vala"
				break;
#line 6373 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label36) ? _tmp64_label36 : (_tmp64_label36 = g_quark_from_static_string ("3")))) || (_tmp65_ == ((0 != _tmp64_label37) ? _tmp64_label37 : (_tmp64_label37 = g_quark_from_static_string ("KP_3"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6379 "game-view.c"
			default:
			{
#line 1171 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 2;
#line 1171 "../src/game-view.vala"
				break;
#line 6386 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label38) ? _tmp64_label38 : (_tmp64_label38 = g_quark_from_static_string ("4")))) || (_tmp65_ == ((0 != _tmp64_label39) ? _tmp64_label39 : (_tmp64_label39 = g_quark_from_static_string ("KP_4"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6392 "game-view.c"
			default:
			{
#line 1172 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 3;
#line 1172 "../src/game-view.vala"
				break;
#line 6399 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label40) ? _tmp64_label40 : (_tmp64_label40 = g_quark_from_static_string ("5")))) || (_tmp65_ == ((0 != _tmp64_label41) ? _tmp64_label41 : (_tmp64_label41 = g_quark_from_static_string ("KP_5"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6405 "game-view.c"
			default:
			{
#line 1173 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 4;
#line 1173 "../src/game-view.vala"
				break;
#line 6412 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label42) ? _tmp64_label42 : (_tmp64_label42 = g_quark_from_static_string ("6")))) || (_tmp65_ == ((0 != _tmp64_label43) ? _tmp64_label43 : (_tmp64_label43 = g_quark_from_static_string ("KP_6"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6418 "game-view.c"
			default:
			{
#line 1174 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 5;
#line 1174 "../src/game-view.vala"
				break;
#line 6425 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label44) ? _tmp64_label44 : (_tmp64_label44 = g_quark_from_static_string ("7")))) || (_tmp65_ == ((0 != _tmp64_label45) ? _tmp64_label45 : (_tmp64_label45 = g_quark_from_static_string ("KP_7"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6431 "game-view.c"
			default:
			{
#line 1175 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 6;
#line 1175 "../src/game-view.vala"
				break;
#line 6438 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label46) ? _tmp64_label46 : (_tmp64_label46 = g_quark_from_static_string ("8")))) || (_tmp65_ == ((0 != _tmp64_label47) ? _tmp64_label47 : (_tmp64_label47 = g_quark_from_static_string ("KP_8"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6444 "game-view.c"
			default:
			{
#line 1176 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 7;
#line 1176 "../src/game-view.vala"
				break;
#line 6451 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label48) ? _tmp64_label48 : (_tmp64_label48 = g_quark_from_static_string ("9")))) || (_tmp65_ == ((0 != _tmp64_label49) ? _tmp64_label49 : (_tmp64_label49 = g_quark_from_static_string ("KP_9"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6457 "game-view.c"
			default:
			{
#line 1177 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 8;
#line 1177 "../src/game-view.vala"
				break;
#line 6464 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label50) ? _tmp64_label50 : (_tmp64_label50 = g_quark_from_static_string ("0")))) || (_tmp65_ == ((0 != _tmp64_label51) ? _tmp64_label51 : (_tmp64_label51 = g_quark_from_static_string ("KP_0"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6470 "game-view.c"
			default:
			{
#line 1178 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 9;
#line 1178 "../src/game-view.vala"
				break;
#line 6477 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label52) ? _tmp64_label52 : (_tmp64_label52 = g_quark_from_static_string ("Home")))) || (_tmp65_ == ((0 != _tmp64_label53) ? _tmp64_label53 : (_tmp64_label53 = g_quark_from_static_string ("KP_Home"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6483 "game-view.c"
			default:
			{
#line 1182 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 0;
#line 1183 "../src/game-view.vala"
				break;
#line 6490 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label54) ? _tmp64_label54 : (_tmp64_label54 = g_quark_from_static_string ("End")))) || (_tmp65_ == ((0 != _tmp64_label55) ? _tmp64_label55 : (_tmp64_label55 = g_quark_from_static_string ("KP_End"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6496 "game-view.c"
			default:
			{
#line 1186 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) (self->priv->game_size - 1);
#line 1187 "../src/game-view.vala"
				break;
#line 6503 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label56) ? _tmp64_label56 : (_tmp64_label56 = g_quark_from_static_string ("Page_Up")))) || (_tmp65_ == ((0 != _tmp64_label57) ? _tmp64_label57 : (_tmp64_label57 = g_quark_from_static_string ("KP_Page_Up"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6509 "game-view.c"
			default:
			{
#line 1190 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 0;
#line 1191 "../src/game-view.vala"
				break;
#line 6516 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label58) ? _tmp64_label58 : (_tmp64_label58 = g_quark_from_static_string ("Page_Down")))) || (_tmp65_ == ((0 != _tmp64_label59) ? _tmp64_label59 : (_tmp64_label59 = g_quark_from_static_string ("KP_Next"))))) {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6522 "game-view.c"
			default:
			{
#line 1194 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) (self->priv->game_size - 1);
#line 1195 "../src/game-view.vala"
				break;
#line 6529 "game-view.c"
			}
		}
	} else {
#line 1106 "../src/game-view.vala"
		switch (0) {
#line 6535 "game-view.c"
			default:
			{
#line 1199 "../src/game-view.vala"
				result = FALSE;
#line 1199 "../src/game-view.vala"
				_g_free0 (key);
#line 1199 "../src/game-view.vala"
				return result;
#line 6544 "game-view.c"
			}
		}
	}
#line 1202 "../src/game-view.vala"
	self->priv->highlight_set = TRUE;
#line 1204 "../src/game-view.vala"
	_tmp94_ = key;
#line 1204 "../src/game-view.vala"
	if (g_strcmp0 (_tmp94_, "space") != 0) {
#line 6554 "game-view.c"
		const gchar* _tmp95_;
#line 1204 "../src/game-view.vala"
		_tmp95_ = key;
#line 1204 "../src/game-view.vala"
		_tmp93_ = g_strcmp0 (_tmp95_, "Return") != 0;
#line 6560 "game-view.c"
	} else {
#line 1204 "../src/game-view.vala"
		_tmp93_ = FALSE;
#line 6564 "game-view.c"
	}
#line 1204 "../src/game-view.vala"
	if (_tmp93_) {
#line 6568 "game-view.c"
		const gchar* _tmp96_;
#line 1204 "../src/game-view.vala"
		_tmp96_ = key;
#line 1204 "../src/game-view.vala"
		_tmp92_ = g_strcmp0 (_tmp96_, "KP_Enter") != 0;
#line 6574 "game-view.c"
	} else {
#line 1204 "../src/game-view.vala"
		_tmp92_ = FALSE;
#line 6578 "game-view.c"
	}
#line 1204 "../src/game-view.vala"
	if (_tmp92_) {
#line 1205 "../src/game-view.vala"
		g_signal_emit (self, game_view_signals[GAME_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL], 0);
#line 6584 "game-view.c"
	}
#line 1207 "../src/game-view.vala"
	_tmp97_ = key;
#line 1207 "../src/game-view.vala"
	if (g_strcmp0 (_tmp97_, "Escape") == 0) {
#line 1208 "../src/game-view.vala"
		self->priv->show_highlight = FALSE;
#line 6592 "game-view.c"
	} else {
#line 1209 "../src/game-view.vala"
		if (self->priv->show_highlight) {
#line 1210 "../src/game-view.vala"
			self->priv->highlight_state = GAME_VIEW_HIGHLIGHT_MAX;
#line 6598 "game-view.c"
		} else {
#line 1212 "../src/game-view.vala"
			self->priv->show_highlight = TRUE;
#line 6602 "game-view.c"
		}
	}
#line 1214 "../src/game-view.vala"
	game_view_queue_draw_tile (self, self->priv->old_highlight_x, self->priv->old_highlight_y);
#line 1215 "../src/game-view.vala"
	if (self->priv->old_highlight_x != self->priv->highlight_x) {
#line 1215 "../src/game-view.vala"
		_tmp98_ = TRUE;
#line 6611 "game-view.c"
	} else {
#line 1216 "../src/game-view.vala"
		_tmp98_ = self->priv->old_highlight_y != self->priv->highlight_y;
#line 6615 "game-view.c"
	}
#line 1215 "../src/game-view.vala"
	if (_tmp98_) {
#line 1217 "../src/game-view.vala"
		game_view_queue_draw_tile (self, self->priv->highlight_x, self->priv->highlight_y);
#line 6621 "game-view.c"
	}
#line 1218 "../src/game-view.vala"
	_tmp99_ = key;
#line 1218 "../src/game-view.vala"
	if (g_strcmp0 (_tmp99_, "Escape") != 0) {
#line 1220 "../src/game-view.vala"
		self->priv->show_mouse_highlight = FALSE;
#line 1221 "../src/game-view.vala"
		if (self->priv->mouse_position_set) {
#line 1222 "../src/game-view.vala"
			game_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 6633 "game-view.c"
		}
	} else {
		gboolean _tmp100_ = FALSE;
#line 1224 "../src/game-view.vala"
		if (self->priv->mouse_position_set) {
#line 1224 "../src/game-view.vala"
			_tmp100_ = self->priv->mouse_is_in;
#line 6641 "game-view.c"
		} else {
#line 1224 "../src/game-view.vala"
			_tmp100_ = FALSE;
#line 6645 "game-view.c"
		}
#line 1224 "../src/game-view.vala"
		if (_tmp100_) {
#line 1226 "../src/game-view.vala"
			self->priv->highlight_x = self->priv->mouse_position_x;
#line 1227 "../src/game-view.vala"
			self->priv->highlight_y = self->priv->mouse_position_y;
#line 1228 "../src/game-view.vala"
			_game_view_on_motion (self, self->priv->highlight_x, self->priv->highlight_y, TRUE);
#line 6655 "game-view.c"
		}
	}
#line 1230 "../src/game-view.vala"
	result = TRUE;
#line 1230 "../src/game-view.vala"
	_g_free0 (key);
#line 1230 "../src/game-view.vala"
	return result;
#line 6664 "game-view.c"
}

static void
game_view_init_possible_moves (GameView* self)
{
	gboolean* _tmp0_;
#line 1240 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 1242 "../src/game-view.vala"
	self->priv->playable_tiles_highlight_state = (guint8) 0;
#line 1243 "../src/game-view.vala"
	_tmp0_ = g_new0 (gboolean, self->priv->game_size * self->priv->game_size);
#line 1243 "../src/game-view.vala"
	self->priv->possible_moves = (g_free (self->priv->possible_moves), NULL);
#line 1243 "../src/game-view.vala"
	self->priv->possible_moves = _tmp0_;
#line 1243 "../src/game-view.vala"
	self->priv->possible_moves_length1 = self->priv->game_size;
#line 1243 "../src/game-view.vala"
	self->priv->possible_moves_length2 = self->priv->game_size;
#line 6685 "game-view.c"
	{
		guint8 x = 0U;
#line 1245 "../src/game-view.vala"
		x = (guint8) 0;
#line 6690 "game-view.c"
		{
			gboolean _tmp1_ = FALSE;
#line 1245 "../src/game-view.vala"
			_tmp1_ = TRUE;
#line 1245 "../src/game-view.vala"
			while (TRUE) {
#line 1245 "../src/game-view.vala"
				if (!_tmp1_) {
#line 6699 "game-view.c"
					guint8 _tmp2_;
#line 1245 "../src/game-view.vala"
					_tmp2_ = x;
#line 1245 "../src/game-view.vala"
					x = _tmp2_ + 1;
#line 6705 "game-view.c"
				}
#line 1245 "../src/game-view.vala"
				_tmp1_ = FALSE;
#line 1245 "../src/game-view.vala"
				if (!(x < self->priv->game_size)) {
#line 1245 "../src/game-view.vala"
					break;
#line 6713 "game-view.c"
				}
				{
					guint8 y = 0U;
#line 1246 "../src/game-view.vala"
					y = (guint8) 0;
#line 6719 "game-view.c"
					{
						gboolean _tmp3_ = FALSE;
#line 1246 "../src/game-view.vala"
						_tmp3_ = TRUE;
#line 1246 "../src/game-view.vala"
						while (TRUE) {
#line 6726 "game-view.c"
							gboolean* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
#line 1246 "../src/game-view.vala"
							if (!_tmp3_) {
#line 6732 "game-view.c"
								guint8 _tmp4_;
#line 1246 "../src/game-view.vala"
								_tmp4_ = y;
#line 1246 "../src/game-view.vala"
								y = _tmp4_ + 1;
#line 6738 "game-view.c"
							}
#line 1246 "../src/game-view.vala"
							_tmp3_ = FALSE;
#line 1246 "../src/game-view.vala"
							if (!(y < self->priv->game_size)) {
#line 1246 "../src/game-view.vala"
								break;
#line 6746 "game-view.c"
							}
#line 1247 "../src/game-view.vala"
							_tmp5_ = self->priv->possible_moves;
#line 1247 "../src/game-view.vala"
							_tmp5__length1 = self->priv->possible_moves_length1;
#line 1247 "../src/game-view.vala"
							_tmp5__length2 = self->priv->possible_moves_length2;
#line 1247 "../src/game-view.vala"
							_tmp5_[(x * _tmp5__length2) + y] = FALSE;
#line 6756 "game-view.c"
						}
					}
				}
			}
		}
	}
}

static inline void
game_view_move_if_possible (GameView* self,
                            guint8 x,
                            guint8 y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	Iagno* _tmp2_;
	ComputerPlayer* _tmp3_;
	ComputerPlayer* _tmp4_;
#line 1250 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 1252 "../src/game-view.vala"
	_tmp2_ = self->priv->iagno_instance;
#line 1252 "../src/game-view.vala"
	_tmp3_ = iagno_get_computer (_tmp2_);
#line 1252 "../src/game-view.vala"
	_tmp4_ = _tmp3_;
#line 1252 "../src/game-view.vala"
	if (_tmp4_ == NULL) {
#line 1252 "../src/game-view.vala"
		_tmp1_ = TRUE;
#line 6787 "game-view.c"
	} else {
		Iagno* _tmp5_;
		Player _tmp6_;
		Player _tmp7_;
		Game* _tmp8_;
		Game* _tmp9_;
		Player _tmp10_;
		Player _tmp11_;
#line 1252 "../src/game-view.vala"
		_tmp5_ = self->priv->iagno_instance;
#line 1252 "../src/game-view.vala"
		_tmp6_ = iagno_get_player_one (_tmp5_);
#line 1252 "../src/game-view.vala"
		_tmp7_ = _tmp6_;
#line 1252 "../src/game-view.vala"
		_tmp8_ = game_view_get_game (self);
#line 1252 "../src/game-view.vala"
		_tmp9_ = _tmp8_;
#line 1252 "../src/game-view.vala"
		_tmp10_ = game_get_current_color (_tmp9_);
#line 1252 "../src/game-view.vala"
		_tmp11_ = _tmp10_;
#line 1252 "../src/game-view.vala"
		_tmp1_ = _tmp7_ == _tmp11_;
#line 6812 "game-view.c"
	}
#line 1252 "../src/game-view.vala"
	if (_tmp1_) {
#line 6816 "game-view.c"
		Game* _tmp12_;
		Game* _tmp13_;
#line 1253 "../src/game-view.vala"
		_tmp12_ = game_view_get_game (self);
#line 1253 "../src/game-view.vala"
		_tmp13_ = _tmp12_;
#line 1253 "../src/game-view.vala"
		_tmp0_ = game_get_owner (_tmp13_, x, y) != PLAYER_NONE;
#line 6825 "game-view.c"
	} else {
#line 1252 "../src/game-view.vala"
		_tmp0_ = FALSE;
#line 6829 "game-view.c"
	}
#line 1252 "../src/game-view.vala"
	if (_tmp0_) {
#line 1254 "../src/game-view.vala"
		game_view_highlight_playable_tiles (self);
#line 6835 "game-view.c"
	} else {
#line 1256 "../src/game-view.vala"
		g_signal_emit (self, game_view_signals[GAME_VIEW_MOVE_SIGNAL], 0, x, y);
#line 6839 "game-view.c"
	}
}

static void
_possible_move_free0_ (gpointer var)
{
#line 1265 "../src/game-view.vala"
	(var == NULL) ? NULL : (var = (possible_move_free (var), NULL));
#line 6848 "game-view.c"
}

static inline void
_g_slist_free__possible_move_free0_ (GSList* self)
{
#line 1265 "../src/game-view.vala"
	g_slist_free_full (self, (GDestroyNotify) _possible_move_free0_);
#line 6856 "game-view.c"
}

static void
__lambda12_ (GameView* self,
             PossibleMove* move)
{
	guint8 x = 0U;
	guint8 y = 0U;
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 1268 "../src/game-view.vala"
	x = ((PossibleMove) (*move)).x;
#line 1269 "../src/game-view.vala"
	y = ((PossibleMove) (*move)).y;
#line 1270 "../src/game-view.vala"
	_tmp0_ = self->priv->possible_moves;
#line 1270 "../src/game-view.vala"
	_tmp0__length1 = self->priv->possible_moves_length1;
#line 1270 "../src/game-view.vala"
	_tmp0__length2 = self->priv->possible_moves_length2;
#line 1270 "../src/game-view.vala"
	_tmp0_[(x * _tmp0__length2) + y] = TRUE;
#line 1271 "../src/game-view.vala"
	game_view_queue_draw_tile (self, x, y);
#line 6882 "game-view.c"
}

static void
___lambda12__gfunc (gconstpointer data,
                    gpointer self)
{
#line 1267 "../src/game-view.vala"
	__lambda12_ ((GameView*) self, (PossibleMove*) data);
#line 6891 "game-view.c"
}

static inline void
game_view_highlight_playable_tiles (GameView* self)
{
	GSList* moves = NULL;
	Game* _tmp0_;
	Game* _tmp1_;
	GSList* _tmp2_ = NULL;
	GSList* _tmp3_;
#line 1259 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 1261 "../src/game-view.vala"
	if (((gint) self->priv->playable_tiles_highlight_state) != 0) {
#line 1262 "../src/game-view.vala"
		return;
#line 6908 "game-view.c"
	}
#line 1265 "../src/game-view.vala"
	_tmp0_ = game_view_get_game (self);
#line 1265 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 1265 "../src/game-view.vala"
	game_get_possible_moves (_tmp1_, &_tmp2_);
#line 1265 "../src/game-view.vala"
	(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
#line 1265 "../src/game-view.vala"
	moves = _tmp2_;
#line 1266 "../src/game-view.vala"
	self->priv->playable_tiles_highlight_state = (guint8) 1;
#line 1267 "../src/game-view.vala"
	_tmp3_ = moves;
#line 1267 "../src/game-view.vala"
	g_slist_foreach (_tmp3_, ___lambda12__gfunc, self);
#line 1259 "../src/game-view.vala"
	(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
#line 6928 "game-view.c"
}

static gboolean
game_view_draw_scoreboard (GameView* self,
                           cairo_t* cr)
{
	gboolean result = FALSE;
	gint height = 0;
	GtkDrawingArea* _tmp0_;
	GtkDrawingArea* _tmp1_;
	gint width = 0;
	GtkDrawingArea* _tmp2_;
	GtkDrawingArea* _tmp3_;
	gdouble half_height = 0.0;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp4_;
	cairo_surface_t* _tmp5_;
	cairo_t* c = NULL;
	cairo_t* _tmp6_;
	cairo_pattern_t* _tmp7_;
	cairo_matrix_t matrix = {0};
	cairo_pattern_t* _tmp8_;
	cairo_matrix_t _tmp9_;
	cairo_pattern_t* _tmp10_;
	cairo_pattern_t* _tmp11_;
	cairo_matrix_t _tmp12_;
	cairo_pattern_t* _tmp13_;
#line 1279 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1279 "../src/game-view.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 1281 "../src/game-view.vala"
	_tmp0_ = game_view_get_scoreboard (self);
#line 1281 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 1281 "../src/game-view.vala"
	height = gtk_widget_get_allocated_height ((GtkWidget*) _tmp1_);
#line 1282 "../src/game-view.vala"
	_tmp2_ = game_view_get_scoreboard (self);
#line 1282 "../src/game-view.vala"
	_tmp3_ = _tmp2_;
#line 1282 "../src/game-view.vala"
	width = gtk_widget_get_allocated_width ((GtkWidget*) _tmp3_);
#line 1283 "../src/game-view.vala"
	half_height = height / 2.0;
#line 1285 "../src/game-view.vala"
	cairo_set_line_cap (cr, CAIRO_LINE_CAP_ROUND);
#line 1286 "../src/game-view.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_ROUND);
#line 1288 "../src/game-view.vala"
	cairo_save (cr);
#line 1290 "../src/game-view.vala"
	cairo_set_source_rgba (cr, self->priv->mark_red, self->priv->mark_green, self->priv->mark_blue, 1.0);
#line 1291 "../src/game-view.vala"
	cairo_set_line_width (cr, (gdouble) self->priv->mark_width);
#line 1293 "../src/game-view.vala"
	cairo_translate (cr, (gdouble) 0, self->priv->current_player_number * half_height);
#line 1294 "../src/game-view.vala"
	cairo_move_to (cr, height / 4.0, height / 8.0);
#line 1295 "../src/game-view.vala"
	cairo_line_to (cr, width - ((5.0 * height) / 8.0), height / 4.0);
#line 1296 "../src/game-view.vala"
	cairo_line_to (cr, height / 4.0, (3.0 * height) / 8.0);
#line 1297 "../src/game-view.vala"
	cairo_stroke (cr);
#line 1299 "../src/game-view.vala"
	cairo_restore (cr);
#line 1304 "../src/game-view.vala"
	_tmp4_ = cairo_get_target (cr);
#line 1304 "../src/game-view.vala"
	_tmp5_ = cairo_surface_create_similar (_tmp4_, CAIRO_CONTENT_COLOR_ALPHA, height * 4, height * 2);
#line 1304 "../src/game-view.vala"
	surface = _tmp5_;
#line 1305 "../src/game-view.vala"
	_tmp6_ = cairo_create (surface);
#line 1305 "../src/game-view.vala"
	c = _tmp6_;
#line 1306 "../src/game-view.vala"
	game_view_load_image (self, c, height * 4, height * 2);
#line 1307 "../src/game-view.vala"
	_tmp7_ = cairo_pattern_create_for_surface (surface);
#line 1307 "../src/game-view.vala"
	_cairo_pattern_destroy0 (self->priv->scoreboard_tiles_pattern);
#line 1307 "../src/game-view.vala"
	self->priv->scoreboard_tiles_pattern = _tmp7_;
#line 1309 "../src/game-view.vala"
	cairo_translate (cr, width - half_height, (gdouble) 0);
#line 1310 "../src/game-view.vala"
	cairo_matrix_init_identity (&matrix);
#line 1313 "../src/game-view.vala"
	cairo_matrix_translate (&matrix, half_height, (gdouble) 0);
#line 1314 "../src/game-view.vala"
	_tmp8_ = self->priv->scoreboard_tiles_pattern;
#line 1314 "../src/game-view.vala"
	_tmp9_ = matrix;
#line 1314 "../src/game-view.vala"
	cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp8_, &_tmp9_);
#line 1315 "../src/game-view.vala"
	_tmp10_ = self->priv->scoreboard_tiles_pattern;
#line 1315 "../src/game-view.vala"
	cairo_set_source (cr, (cairo_pattern_t*) _tmp10_);
#line 1316 "../src/game-view.vala"
	cairo_rectangle (cr, (gdouble) 0, (gdouble) 0, half_height, half_height);
#line 1317 "../src/game-view.vala"
	cairo_fill (cr);
#line 1320 "../src/game-view.vala"
	cairo_matrix_translate (&matrix, (gdouble) (3 * height), (gdouble) height);
#line 1321 "../src/game-view.vala"
	_tmp11_ = self->priv->scoreboard_tiles_pattern;
#line 1321 "../src/game-view.vala"
	_tmp12_ = matrix;
#line 1321 "../src/game-view.vala"
	cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp11_, &_tmp12_);
#line 1322 "../src/game-view.vala"
	_tmp13_ = self->priv->scoreboard_tiles_pattern;
#line 1322 "../src/game-view.vala"
	cairo_set_source (cr, (cairo_pattern_t*) _tmp13_);
#line 1323 "../src/game-view.vala"
	cairo_rectangle (cr, (gdouble) 0, half_height, half_height, half_height);
#line 1324 "../src/game-view.vala"
	cairo_fill (cr);
#line 1343 "../src/game-view.vala"
	result = TRUE;
#line 1343 "../src/game-view.vala"
	_cairo_destroy0 (c);
#line 1343 "../src/game-view.vala"
	_cairo_surface_destroy0 (surface);
#line 1343 "../src/game-view.vala"
	return result;
#line 7058 "game-view.c"
}

void
game_view_update_scoreboard (GameView* self)
{
	gint _tmp0_ = 0;
	Game* _tmp1_;
	Game* _tmp2_;
	Player _tmp3_;
	Player _tmp4_;
	GtkDrawingArea* _tmp5_;
	GtkDrawingArea* _tmp6_;
#line 1346 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 1346 "../src/game-view.vala"
	_vala_return_if_fail (self->priv->game_is_set, "game_is_set");
#line 1349 "../src/game-view.vala"
	_tmp1_ = game_view_get_game (self);
#line 1349 "../src/game-view.vala"
	_tmp2_ = _tmp1_;
#line 1349 "../src/game-view.vala"
	_tmp3_ = game_get_current_color (_tmp2_);
#line 1349 "../src/game-view.vala"
	_tmp4_ = _tmp3_;
#line 1349 "../src/game-view.vala"
	if (_tmp4_ == PLAYER_DARK) {
#line 1349 "../src/game-view.vala"
		_tmp0_ = 0;
#line 7087 "game-view.c"
	} else {
#line 1349 "../src/game-view.vala"
		_tmp0_ = 1;
#line 7091 "game-view.c"
	}
#line 1349 "../src/game-view.vala"
	self->priv->current_player_number = _tmp0_;
#line 1350 "../src/game-view.vala"
	_tmp5_ = game_view_get_scoreboard (self);
#line 1350 "../src/game-view.vala"
	_tmp6_ = _tmp5_;
#line 1350 "../src/game-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp6_);
#line 7101 "game-view.c"
}

static gboolean
game_view_get_show_turnable_tiles (GameView* self)
{
	gboolean result;
#line 25 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 25 "../src/game-view.vala"
	result = self->priv->_show_turnable_tiles;
#line 25 "../src/game-view.vala"
	return result;
#line 7114 "game-view.c"
}

void
game_view_set_show_turnable_tiles (GameView* self,
                                   gboolean value)
{
#line 25 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/game-view.vala"
	if (game_view_get_show_turnable_tiles (self) != value) {
#line 25 "../src/game-view.vala"
		self->priv->_show_turnable_tiles = value;
#line 25 "../src/game-view.vala"
		g_object_notify_by_pspec ((GObject *) self, game_view_properties[GAME_VIEW_SHOW_TURNABLE_TILES_PROPERTY]);
#line 7129 "game-view.c"
	}
}

static GtkDrawingArea*
game_view_get_scoreboard (GameView* self)
{
	GtkDrawingArea* result;
	GtkDrawingArea* _tmp0_;
#line 29 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/game-view.vala"
	_tmp0_ = self->priv->_scoreboard;
#line 29 "../src/game-view.vala"
	result = _tmp0_;
#line 29 "../src/game-view.vala"
	return result;
#line 7146 "game-view.c"
}

static gboolean
_game_view_draw_scoreboard_gtk_widget_draw (GtkWidget* _sender,
                                            cairo_t* cr,
                                            gpointer self)
{
	gboolean result;
	result = game_view_draw_scoreboard ((GameView*) self, cr);
#line 33 "../src/game-view.vala"
	return result;
#line 7158 "game-view.c"
}

void
game_view_set_scoreboard (GameView* self,
                          GtkDrawingArea* value)
{
	GtkDrawingArea* _tmp0_;
	GtkDrawingArea* _tmp1_;
#line 30 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/game-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 32 "../src/game-view.vala"
	_g_object_unref0 (self->priv->_scoreboard);
#line 32 "../src/game-view.vala"
	self->priv->_scoreboard = _tmp0_;
#line 33 "../src/game-view.vala"
	_tmp1_ = self->priv->_scoreboard;
#line 33 "../src/game-view.vala"
	g_signal_connect_object ((GtkWidget*) _tmp1_, "draw", (GCallback) _game_view_draw_scoreboard_gtk_widget_draw, self, 0);
#line 7179 "game-view.c"
}

const gchar*
game_view_get_sound_flip (GameView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 76 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "../src/game-view.vala"
	_tmp0_ = self->priv->_sound_flip;
#line 76 "../src/game-view.vala"
	result = _tmp0_;
#line 76 "../src/game-view.vala"
	return result;
#line 7195 "game-view.c"
}

static void
game_view_set_sound_flip (GameView* self,
                          const gchar* value)
{
	gchar* _tmp0_;
#line 76 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/game-view.vala"
	_tmp0_ = g_strdup (value);
#line 76 "../src/game-view.vala"
	_g_free0 (self->priv->_sound_flip);
#line 76 "../src/game-view.vala"
	self->priv->_sound_flip = _tmp0_;
#line 7211 "game-view.c"
}

const gchar*
game_view_get_sound_gameover (GameView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 77 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "../src/game-view.vala"
	_tmp0_ = self->priv->_sound_gameover;
#line 77 "../src/game-view.vala"
	result = _tmp0_;
#line 77 "../src/game-view.vala"
	return result;
#line 7227 "game-view.c"
}

static void
game_view_set_sound_gameover (GameView* self,
                              const gchar* value)
{
	gchar* _tmp0_;
#line 77 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/game-view.vala"
	_tmp0_ = g_strdup (value);
#line 77 "../src/game-view.vala"
	_g_free0 (self->priv->_sound_gameover);
#line 77 "../src/game-view.vala"
	self->priv->_sound_gameover = _tmp0_;
#line 7243 "game-view.c"
}

Game*
game_view_get_game (GameView* self)
{
	Game* result;
	Game* _tmp0_;
#line 128 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 130 "../src/game-view.vala"
	if (!self->priv->game_is_set) {
#line 131 "../src/game-view.vala"
		g_assert_not_reached ();
#line 7257 "game-view.c"
	}
#line 132 "../src/game-view.vala"
	_tmp0_ = self->priv->_game;
#line 132 "../src/game-view.vala"
	result = _tmp0_;
#line 132 "../src/game-view.vala"
	return result;
#line 7265 "game-view.c"
}

static void
_game_view_game_is_complete_cb_game_completeness_updated (Game* _sender,
                                                          gboolean completeness,
                                                          gpointer self)
{
#line 152 "../src/game-view.vala"
	game_view_game_is_complete_cb ((GameView*) self);
#line 7275 "game-view.c"
}

static void
_game_view_turn_ended_cb_game_turn_ended (Game* _sender,
                                          gboolean undoing,
                                          gboolean no_draw,
                                          gpointer self)
{
#line 153 "../src/game-view.vala"
	game_view_turn_ended_cb ((GameView*) self, undoing, no_draw);
#line 7286 "game-view.c"
}

void
game_view_set_game (GameView* self,
                    Game* value)
{
	Game* test = NULL;
	Game* _tmp0_;
	Game* _tmp2_;
	Game* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	gint* _tmp6_;
	gint* _tmp7_;
	gint* _tmp8_;
	Game* _tmp15_;
	Game* _tmp16_;
	gboolean odd_game = FALSE;
	gboolean _tmp17_ = FALSE;
	Game* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	guint8 _tmp21_ = 0U;
#line 134 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/game-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 136 "../src/game-view.vala"
	test = _tmp0_;
#line 137 "../src/game-view.vala"
	if (test == NULL) {
#line 138 "../src/game-view.vala"
		g_assert_not_reached ();
#line 7320 "game-view.c"
	}
#line 140 "../src/game-view.vala"
	if (self->priv->game_is_set) {
#line 7324 "game-view.c"
		Game* _tmp1_;
#line 141 "../src/game-view.vala"
		_tmp1_ = self->priv->_game;
#line 141 "../src/game-view.vala"
		g_signal_handlers_disconnect_by_func (_tmp1_, NULL, self);
#line 7330 "game-view.c"
	}
#line 142 "../src/game-view.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 142 "../src/game-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 142 "../src/game-view.vala"
	self->priv->_game = _tmp2_;
#line 143 "../src/game-view.vala"
	self->priv->game_is_set = TRUE;
#line 144 "../src/game-view.vala"
	_tmp3_ = self->priv->_game;
#line 144 "../src/game-view.vala"
	_tmp4_ = game_get_size (_tmp3_);
#line 144 "../src/game-view.vala"
	_tmp5_ = _tmp4_;
#line 144 "../src/game-view.vala"
	self->priv->game_size = _tmp5_;
#line 145 "../src/game-view.vala"
	_tmp6_ = g_new0 (gint, self->priv->game_size * self->priv->game_size);
#line 145 "../src/game-view.vala"
	self->priv->pixmaps = (g_free (self->priv->pixmaps), NULL);
#line 145 "../src/game-view.vala"
	self->priv->pixmaps = _tmp6_;
#line 145 "../src/game-view.vala"
	self->priv->pixmaps_length1 = self->priv->game_size;
#line 145 "../src/game-view.vala"
	self->priv->pixmaps_length2 = self->priv->game_size;
#line 146 "../src/game-view.vala"
	_tmp7_ = g_new0 (gint, self->priv->game_size * self->priv->game_size);
#line 146 "../src/game-view.vala"
	self->priv->tile_xs = (g_free (self->priv->tile_xs), NULL);
#line 146 "../src/game-view.vala"
	self->priv->tile_xs = _tmp7_;
#line 146 "../src/game-view.vala"
	self->priv->tile_xs_length1 = self->priv->game_size;
#line 146 "../src/game-view.vala"
	self->priv->tile_xs_length2 = self->priv->game_size;
#line 147 "../src/game-view.vala"
	_tmp8_ = g_new0 (gint, self->priv->game_size * self->priv->game_size);
#line 147 "../src/game-view.vala"
	self->priv->tile_ys = (g_free (self->priv->tile_ys), NULL);
#line 147 "../src/game-view.vala"
	self->priv->tile_ys = _tmp8_;
#line 147 "../src/game-view.vala"
	self->priv->tile_ys_length1 = self->priv->game_size;
#line 147 "../src/game-view.vala"
	self->priv->tile_ys_length2 = self->priv->game_size;
#line 148 "../src/game-view.vala"
	game_view_init_possible_moves (self);
#line 7380 "game-view.c"
	{
		guint8 x = 0U;
#line 149 "../src/game-view.vala"
		x = (guint8) 0;
#line 7385 "game-view.c"
		{
			gboolean _tmp9_ = FALSE;
#line 149 "../src/game-view.vala"
			_tmp9_ = TRUE;
#line 149 "../src/game-view.vala"
			while (TRUE) {
#line 149 "../src/game-view.vala"
				if (!_tmp9_) {
#line 7394 "game-view.c"
					guint8 _tmp10_;
#line 149 "../src/game-view.vala"
					_tmp10_ = x;
#line 149 "../src/game-view.vala"
					x = _tmp10_ + 1;
#line 7400 "game-view.c"
				}
#line 149 "../src/game-view.vala"
				_tmp9_ = FALSE;
#line 149 "../src/game-view.vala"
				if (!(x < self->priv->game_size)) {
#line 149 "../src/game-view.vala"
					break;
#line 7408 "game-view.c"
				}
				{
					guint8 y = 0U;
#line 150 "../src/game-view.vala"
					y = (guint8) 0;
#line 7414 "game-view.c"
					{
						gboolean _tmp11_ = FALSE;
#line 150 "../src/game-view.vala"
						_tmp11_ = TRUE;
#line 150 "../src/game-view.vala"
						while (TRUE) {
#line 7421 "game-view.c"
							gint* _tmp13_;
							gint _tmp13__length1;
							gint _tmp13__length2;
							Game* _tmp14_;
#line 150 "../src/game-view.vala"
							if (!_tmp11_) {
#line 7428 "game-view.c"
								guint8 _tmp12_;
#line 150 "../src/game-view.vala"
								_tmp12_ = y;
#line 150 "../src/game-view.vala"
								y = _tmp12_ + 1;
#line 7434 "game-view.c"
							}
#line 150 "../src/game-view.vala"
							_tmp11_ = FALSE;
#line 150 "../src/game-view.vala"
							if (!(y < self->priv->game_size)) {
#line 150 "../src/game-view.vala"
								break;
#line 7442 "game-view.c"
							}
#line 151 "../src/game-view.vala"
							_tmp13_ = self->priv->pixmaps;
#line 151 "../src/game-view.vala"
							_tmp13__length1 = self->priv->pixmaps_length1;
#line 151 "../src/game-view.vala"
							_tmp13__length2 = self->priv->pixmaps_length2;
#line 151 "../src/game-view.vala"
							_tmp14_ = self->priv->_game;
#line 151 "../src/game-view.vala"
							_tmp13_[(x * _tmp13__length2) + y] = game_view_get_pixmap (game_get_owner (_tmp14_, x, y));
#line 7454 "game-view.c"
						}
					}
				}
			}
		}
	}
#line 152 "../src/game-view.vala"
	_tmp15_ = self->priv->_game;
#line 152 "../src/game-view.vala"
	g_signal_connect_object (_tmp15_, "completeness-updated", (GCallback) _game_view_game_is_complete_cb_game_completeness_updated, self, 0);
#line 153 "../src/game-view.vala"
	_tmp16_ = self->priv->_game;
#line 153 "../src/game-view.vala"
	g_signal_connect_object (_tmp16_, "turn-ended", (GCallback) _game_view_turn_ended_cb_game_turn_ended, self, 0);
#line 155 "../src/game-view.vala"
	self->priv->show_highlight = FALSE;
#line 156 "../src/game-view.vala"
	odd_game = (self->priv->game_size % 2) != 0;
#line 157 "../src/game-view.vala"
	_tmp18_ = self->priv->_game;
#line 157 "../src/game-view.vala"
	_tmp19_ = game_get_alternative_start (_tmp18_);
#line 157 "../src/game-view.vala"
	_tmp20_ = _tmp19_;
#line 157 "../src/game-view.vala"
	if (_tmp20_) {
#line 157 "../src/game-view.vala"
		_tmp17_ = TRUE;
#line 7483 "game-view.c"
	} else {
#line 157 "../src/game-view.vala"
		_tmp17_ = odd_game;
#line 7487 "game-view.c"
	}
#line 157 "../src/game-view.vala"
	self->priv->highlight_set = _tmp17_;
#line 158 "../src/game-view.vala"
	if (odd_game) {
#line 158 "../src/game-view.vala"
		_tmp21_ = (guint8) (self->priv->game_size / 2);
#line 7495 "game-view.c"
	} else {
#line 158 "../src/game-view.vala"
		_tmp21_ = (guint8) ((self->priv->game_size / 2) - 1);
#line 7499 "game-view.c"
	}
#line 158 "../src/game-view.vala"
	self->priv->highlight_x = _tmp21_;
#line 159 "../src/game-view.vala"
	self->priv->highlight_y = self->priv->highlight_x;
#line 160 "../src/game-view.vala"
	self->priv->highlight_state = (guint8) 0;
#line 162 "../src/game-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 134 "../src/game-view.vala"
	_g_object_unref0 (test);
#line 7511 "game-view.c"
}

const gchar*
game_view_get_theme (GameView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 192 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 192 "../src/game-view.vala"
	_tmp0_ = self->priv->_theme;
#line 192 "../src/game-view.vala"
	result = _tmp0_;
#line 192 "../src/game-view.vala"
	return result;
#line 7527 "game-view.c"
}

void
game_view_set_theme (GameView* self,
                     const gchar* value)
{
	GKeyFile* key = NULL;
	GKeyFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GKeyFile* _tmp15_;
	gchar* _tmp16_;
	GtkDrawingArea* _tmp17_;
	GtkDrawingArea* _tmp18_;
	GError * _inner_error_ = NULL;
#line 193 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/game-view.vala"
	_tmp0_ = g_key_file_new ();
#line 194 "../src/game-view.vala"
	key = _tmp0_;
#line 195 "../src/game-view.vala"
	if (value == NULL) {
#line 195 "../src/game-view.vala"
		_tmp1_ = TRUE;
#line 7552 "game-view.c"
	} else {
#line 195 "../src/game-view.vala"
		_tmp1_ = g_strcmp0 ((const gchar*) value, "default") == 0;
#line 7556 "game-view.c"
	}
#line 195 "../src/game-view.vala"
	if (_tmp1_) {
#line 196 "../src/game-view.vala"
		game_view_set_default_theme (self, &key);
#line 7562 "game-view.c"
	} else {
		{
			gchar* key_path = NULL;
			gchar* _tmp2_;
			gchar* filepath = NULL;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
			gboolean _tmp9_;
			GKeyFile* _tmp11_;
			const gchar* _tmp12_;
#line 200 "../src/game-view.vala"
			_tmp2_ = g_build_filename (DATA_DIRECTORY, "themes", "key", NULL);
#line 200 "../src/game-view.vala"
			key_path = _tmp2_;
#line 201 "../src/game-view.vala"
			_tmp3_ = key_path;
#line 201 "../src/game-view.vala"
			_tmp4_ = g_build_filename (_tmp3_, (const gchar*) value, NULL);
#line 201 "../src/game-view.vala"
			filepath = _tmp4_;
#line 202 "../src/game-view.vala"
			_tmp5_ = filepath;
#line 202 "../src/game-view.vala"
			_tmp6_ = g_path_get_dirname (_tmp5_);
#line 202 "../src/game-view.vala"
			_tmp7_ = _tmp6_;
#line 202 "../src/game-view.vala"
			_tmp8_ = key_path;
#line 202 "../src/game-view.vala"
			_tmp9_ = g_strcmp0 (_tmp7_, _tmp8_) != 0;
#line 202 "../src/game-view.vala"
			_g_free0 (_tmp7_);
#line 202 "../src/game-view.vala"
			if (_tmp9_) {
#line 7601 "game-view.c"
				GError* _tmp10_;
#line 203 "../src/game-view.vala"
				_tmp10_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, "Theme file is not in the \"key\" directory.");
#line 203 "../src/game-view.vala"
				_inner_error_ = _tmp10_;
#line 203 "../src/game-view.vala"
				_g_free0 (filepath);
#line 203 "../src/game-view.vala"
				_g_free0 (key_path);
#line 7611 "game-view.c"
				goto __catch5_g_error;
			}
#line 205 "../src/game-view.vala"
			_tmp11_ = key;
#line 205 "../src/game-view.vala"
			_tmp12_ = filepath;
#line 205 "../src/game-view.vala"
			g_key_file_load_from_file (_tmp11_, _tmp12_, G_KEY_FILE_NONE, &_inner_error_);
#line 205 "../src/game-view.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 205 "../src/game-view.vala"
				_g_free0 (filepath);
#line 205 "../src/game-view.vala"
				_g_free0 (key_path);
#line 7626 "game-view.c"
				goto __catch5_g_error;
			}
#line 198 "../src/game-view.vala"
			_g_free0 (filepath);
#line 198 "../src/game-view.vala"
			_g_free0 (key_path);
#line 7633 "game-view.c"
		}
		goto __finally5;
		__catch5_g_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
#line 198 "../src/game-view.vala"
			e = _inner_error_;
#line 198 "../src/game-view.vala"
			_inner_error_ = NULL;
#line 209 "../src/game-view.vala"
			_tmp13_ = e;
#line 209 "../src/game-view.vala"
			_tmp14_ = _tmp13_->message;
#line 209 "../src/game-view.vala"
			g_warning ("game-view.vala:209: Failed to load theme: %s", _tmp14_);
#line 210 "../src/game-view.vala"
			game_view_set_default_theme (self, &key);
#line 211 "../src/game-view.vala"
			value = "default";
#line 198 "../src/game-view.vala"
			_g_error_free0 (e);
#line 7657 "game-view.c"
		}
		__finally5:
#line 198 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 198 "../src/game-view.vala"
			_g_key_file_unref0 (key);
#line 198 "../src/game-view.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 198 "../src/game-view.vala"
			g_clear_error (&_inner_error_);
#line 198 "../src/game-view.vala"
			return;
#line 7670 "game-view.c"
		}
	}
#line 214 "../src/game-view.vala"
	_tmp15_ = key;
#line 214 "../src/game-view.vala"
	game_view_load_theme (self, _tmp15_);
#line 215 "../src/game-view.vala"
	_tmp16_ = g_strdup (value);
#line 215 "../src/game-view.vala"
	_g_free0 (self->priv->_theme);
#line 215 "../src/game-view.vala"
	self->priv->_theme = _tmp16_;
#line 218 "../src/game-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 218 "../src/game-view.vala"
	self->priv->tiles_pattern = NULL;
#line 220 "../src/game-view.vala"
	_tmp17_ = game_view_get_scoreboard (self);
#line 220 "../src/game-view.vala"
	_tmp18_ = _tmp17_;
#line 220 "../src/game-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp18_);
#line 221 "../src/game-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 193 "../src/game-view.vala"
	_g_key_file_unref0 (key);
#line 7697 "game-view.c"
}

static void
g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UCHAR_UCHAR) (gpointer data1, guint8 arg_1, guint8 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UCHAR_UCHAR callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 23 "../src/game-view.vala"
	g_return_if_fail (n_param_values == 3);
#line 23 "../src/game-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "../src/game-view.vala"
		data1 = closure->data;
#line 23 "../src/game-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 7722 "game-view.c"
	} else {
#line 23 "../src/game-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "../src/game-view.vala"
		data2 = closure->data;
#line 7728 "game-view.c"
	}
#line 23 "../src/game-view.vala"
	callback = (GMarshalFunc_VOID__UCHAR_UCHAR) (marshal_data ? marshal_data : cc->callback);
#line 23 "../src/game-view.vala"
	callback (data1, g_value_get_uchar (param_values + 1), g_value_get_uchar (param_values + 2), data2);
#line 7734 "game-view.c"
}

static GObject *
game_view_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GameView * self;
#line 166 "../src/game-view.vala"
	parent_class = G_OBJECT_CLASS (game_view_parent_class);
#line 166 "../src/game-view.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 166 "../src/game-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_VIEW, GameView);
#line 168 "../src/game-view.vala"
	gtk_widget_set_events ((GtkWidget*) self, (gint) (((((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_POINTER_MOTION_MASK) | GDK_ENTER_NOTIFY_MASK) | GDK_LEAVE_NOTIFY_MASK));
#line 174 "../src/game-view.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 350, 350);
#line 176 "../src/game-view.vala"
	game_view_init_mouse (self);
#line 166 "../src/game-view.vala"
	return obj;
#line 7759 "game-view.c"
}

static void
game_view_class_init (GameViewClass * klass,
                      gpointer klass_data)
{
#line 23 "../src/game-view.vala"
	game_view_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/game-view.vala"
	g_type_class_adjust_private_offset (klass, &GameView_private_offset);
#line 23 "../src/game-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) game_view_real_draw;
#line 23 "../src/game-view.vala"
	((GtkWidgetClass *) klass)->enter_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) game_view_real_enter_notify_event;
#line 23 "../src/game-view.vala"
	((GtkWidgetClass *) klass)->leave_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) game_view_real_leave_notify_event;
#line 23 "../src/game-view.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) game_view_real_button_press_event;
#line 23 "../src/game-view.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) game_view_real_key_press_event;
#line 23 "../src/game-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_view_get_property;
#line 23 "../src/game-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_view_set_property;
#line 23 "../src/game-view.vala"
	G_OBJECT_CLASS (klass)->constructor = game_view_constructor;
#line 23 "../src/game-view.vala"
	G_OBJECT_CLASS (klass)->finalize = game_view_finalize;
#line 23 "../src/game-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_SHOW_TURNABLE_TILES_PROPERTY, game_view_properties[GAME_VIEW_SHOW_TURNABLE_TILES_PROPERTY] = g_param_spec_boolean ("show-turnable-tiles", "show-turnable-tiles", "show-turnable-tiles", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 23 "../src/game-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_SCOREBOARD_PROPERTY, game_view_properties[GAME_VIEW_SCOREBOARD_PROPERTY] = g_param_spec_object ("scoreboard", "scoreboard", "scoreboard", gtk_drawing_area_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_SOUND_FLIP_PROPERTY, game_view_properties[GAME_VIEW_SOUND_FLIP_PROPERTY] = g_param_spec_string ("sound-flip", "sound-flip", "sound-flip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_SOUND_GAMEOVER_PROPERTY, game_view_properties[GAME_VIEW_SOUND_GAMEOVER_PROPERTY] = g_param_spec_string ("sound-gameover", "sound-gameover", "sound-gameover", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_GAME_PROPERTY, game_view_properties[GAME_VIEW_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_THEME_PROPERTY, game_view_properties[GAME_VIEW_THEME_PROPERTY] = g_param_spec_string ("theme", "theme", "theme", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game-view.vala"
	game_view_signals[GAME_VIEW_MOVE_SIGNAL] = g_signal_new ("move", TYPE_GAME_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UCHAR_UCHAR, G_TYPE_NONE, 2, G_TYPE_UCHAR, G_TYPE_UCHAR);
#line 23 "../src/game-view.vala"
	game_view_signals[GAME_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL] = g_signal_new ("clear-impossible-to-move-here-warning", TYPE_GAME_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 7804 "game-view.c"
}

static void
game_view_instance_init (GameView * self,
                         gpointer klass)
{
#line 23 "../src/game-view.vala"
	self->priv = game_view_get_instance_private (self);
#line 25 "../src/game-view.vala"
	self->priv->_show_turnable_tiles = FALSE;
#line 40 "../src/game-view.vala"
	self->priv->background_red = 0.2;
#line 41 "../src/game-view.vala"
	self->priv->background_green = 0.6;
#line 42 "../src/game-view.vala"
	self->priv->background_blue = 0.4;
#line 43 "../src/game-view.vala"
	self->priv->background_radius = 0;
#line 45 "../src/game-view.vala"
	self->priv->texture_alpha = 0.25;
#line 46 "../src/game-view.vala"
	self->priv->apply_texture = FALSE;
#line 48 "../src/game-view.vala"
	self->priv->mark_red = 0.2;
#line 49 "../src/game-view.vala"
	self->priv->mark_green = 0.6;
#line 50 "../src/game-view.vala"
	self->priv->mark_blue = 0.4;
#line 51 "../src/game-view.vala"
	self->priv->mark_width = 2;
#line 53 "../src/game-view.vala"
	self->priv->border_red = 0.1;
#line 54 "../src/game-view.vala"
	self->priv->border_green = 0.1;
#line 55 "../src/game-view.vala"
	self->priv->border_blue = 0.1;
#line 56 "../src/game-view.vala"
	self->priv->border_width = 3;
#line 57 "../src/game-view.vala"
	self->priv->half_border_width = 1.5;
#line 59 "../src/game-view.vala"
	self->priv->spacing_red = 0.1;
#line 60 "../src/game-view.vala"
	self->priv->spacing_green = 0.3;
#line 61 "../src/game-view.vala"
	self->priv->spacing_blue = 0.2;
#line 62 "../src/game-view.vala"
	self->priv->spacing_width = 2;
#line 64 "../src/game-view.vala"
	self->priv->highlight_hard_red = 0.1;
#line 65 "../src/game-view.vala"
	self->priv->highlight_hard_green = 0.3;
#line 66 "../src/game-view.vala"
	self->priv->highlight_hard_blue = 0.2;
#line 67 "../src/game-view.vala"
	self->priv->highlight_hard_alpha = 0.4;
#line 69 "../src/game-view.vala"
	self->priv->highlight_soft_red = 0.1;
#line 70 "../src/game-view.vala"
	self->priv->highlight_soft_green = 0.3;
#line 71 "../src/game-view.vala"
	self->priv->highlight_soft_blue = 0.2;
#line 72 "../src/game-view.vala"
	self->priv->highlight_soft_alpha = 0.2;
#line 83 "../src/game-view.vala"
	self->priv->show_highlight = FALSE;
#line 84 "../src/game-view.vala"
	self->priv->highlight_set = FALSE;
#line 85 "../src/game-view.vala"
	self->priv->highlight_x = G_MAXUINT8;
#line 86 "../src/game-view.vala"
	self->priv->highlight_y = G_MAXUINT8;
#line 87 "../src/game-view.vala"
	self->priv->old_highlight_x = G_MAXUINT8;
#line 88 "../src/game-view.vala"
	self->priv->old_highlight_y = G_MAXUINT8;
#line 89 "../src/game-view.vala"
	self->priv->highlight_state = (guint8) 0;
#line 93 "../src/game-view.vala"
	self->priv->show_mouse_highlight = FALSE;
#line 94 "../src/game-view.vala"
	self->priv->mouse_position_set = FALSE;
#line 95 "../src/game-view.vala"
	self->priv->mouse_highlight_x = G_MAXUINT8;
#line 96 "../src/game-view.vala"
	self->priv->mouse_highlight_y = G_MAXUINT8;
#line 97 "../src/game-view.vala"
	self->priv->mouse_position_x = G_MAXUINT8;
#line 98 "../src/game-view.vala"
	self->priv->mouse_position_y = G_MAXUINT8;
#line 104 "../src/game-view.vala"
	self->priv->render_size = (guint) 0;
#line 105 "../src/game-view.vala"
	self->priv->tiles_pattern = NULL;
#line 106 "../src/game-view.vala"
	self->priv->scoreboard_tiles_pattern = NULL;
#line 107 "../src/game-view.vala"
	self->priv->board_pattern = NULL;
#line 109 "../src/game-view.vala"
	self->priv->noise_pixbuf_loaded = FALSE;
#line 115 "../src/game-view.vala"
	self->priv->animate_timeout = (guint) 0;
#line 118 "../src/game-view.vala"
	self->priv->current_player_number = 0;
#line 123 "../src/game-view.vala"
	self->priv->game_is_set = FALSE;
#line 189 "../src/game-view.vala"
	self->priv->_theme = NULL;
#line 668 "../src/game-view.vala"
	self->priv->last_state_set = FALSE;
#line 832 "../src/game-view.vala"
	self->priv->flip_final_result_now = FALSE;
#line 915 "../src/game-view.vala"
	self->priv->mouse_is_in = FALSE;
#line 975 "../src/game-view.vala"
	self->priv->timeout_id = (guint) 0;
#line 7921 "game-view.c"
}

static void
game_view_finalize (GObject * obj)
{
	GameView * self;
#line 23 "../src/game-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_VIEW, GameView);
#line 27 "../src/game-view.vala"
	_g_object_unref0 (self->priv->_scoreboard);
#line 38 "../src/game-view.vala"
	_g_free0 (self->priv->pieces_file);
#line 76 "../src/game-view.vala"
	_g_free0 (self->priv->_sound_flip);
#line 77 "../src/game-view.vala"
	_g_free0 (self->priv->_sound_gameover);
#line 105 "../src/game-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 106 "../src/game-view.vala"
	_cairo_pattern_destroy0 (self->priv->scoreboard_tiles_pattern);
#line 107 "../src/game-view.vala"
	_cairo_pattern_destroy0 (self->priv->board_pattern);
#line 112 "../src/game-view.vala"
	self->priv->pixmaps = (g_free (self->priv->pixmaps), NULL);
#line 125 "../src/game-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 179 "../src/game-view.vala"
	_g_object_unref0 (self->priv->iagno_instance);
#line 189 "../src/game-view.vala"
	_g_free0 (self->priv->_theme);
#line 307 "../src/game-view.vala"
	self->priv->tile_xs = (g_free (self->priv->tile_xs), NULL);
#line 308 "../src/game-view.vala"
	self->priv->tile_ys = (g_free (self->priv->tile_ys), NULL);
#line 669 "../src/game-view.vala"
	_g_object_unref0 (self->priv->last_state);
#line 914 "../src/game-view.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 1238 "../src/game-view.vala"
	self->priv->possible_moves = (g_free (self->priv->possible_moves), NULL);
#line 23 "../src/game-view.vala"
	G_OBJECT_CLASS (game_view_parent_class)->finalize (obj);
#line 7964 "game-view.c"
}

GType
game_view_get_type (void)
{
	static volatile gsize game_view_type_id__volatile = 0;
	if (g_once_init_enter (&game_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameView), 0, (GInstanceInitFunc) game_view_instance_init, NULL };
		GType game_view_type_id;
		game_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "GameView", &g_define_type_info, 0);
		GameView_private_offset = g_type_add_instance_private (game_view_type_id, sizeof (GameViewPrivate));
		g_once_init_leave (&game_view_type_id__volatile, game_view_type_id);
	}
	return game_view_type_id__volatile;
}

static void
_vala_game_view_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	GameView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_VIEW, GameView);
#line 23 "../src/game-view.vala"
	switch (property_id) {
#line 23 "../src/game-view.vala"
		case GAME_VIEW_SHOW_TURNABLE_TILES_PROPERTY:
#line 23 "../src/game-view.vala"
		g_value_set_boolean (value, game_view_get_show_turnable_tiles (self));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_SCOREBOARD_PROPERTY:
#line 23 "../src/game-view.vala"
		g_value_set_object (value, game_view_get_scoreboard (self));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_SOUND_FLIP_PROPERTY:
#line 23 "../src/game-view.vala"
		g_value_set_string (value, game_view_get_sound_flip (self));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_SOUND_GAMEOVER_PROPERTY:
#line 23 "../src/game-view.vala"
		g_value_set_string (value, game_view_get_sound_gameover (self));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_GAME_PROPERTY:
#line 23 "../src/game-view.vala"
		g_value_set_object (value, game_view_get_game (self));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_THEME_PROPERTY:
#line 23 "../src/game-view.vala"
		g_value_set_string (value, game_view_get_theme (self));
#line 23 "../src/game-view.vala"
		break;
#line 8027 "game-view.c"
		default:
#line 23 "../src/game-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/game-view.vala"
		break;
#line 8033 "game-view.c"
	}
}

static void
_vala_game_view_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	GameView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_VIEW, GameView);
#line 23 "../src/game-view.vala"
	switch (property_id) {
#line 23 "../src/game-view.vala"
		case GAME_VIEW_SHOW_TURNABLE_TILES_PROPERTY:
#line 23 "../src/game-view.vala"
		game_view_set_show_turnable_tiles (self, g_value_get_boolean (value));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_SCOREBOARD_PROPERTY:
#line 23 "../src/game-view.vala"
		game_view_set_scoreboard (self, g_value_get_object (value));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_SOUND_FLIP_PROPERTY:
#line 23 "../src/game-view.vala"
		game_view_set_sound_flip (self, g_value_get_string (value));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_SOUND_GAMEOVER_PROPERTY:
#line 23 "../src/game-view.vala"
		game_view_set_sound_gameover (self, g_value_get_string (value));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_GAME_PROPERTY:
#line 23 "../src/game-view.vala"
		game_view_set_game (self, g_value_get_object (value));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_THEME_PROPERTY:
#line 23 "../src/game-view.vala"
		game_view_set_theme (self, g_value_get_string (value));
#line 23 "../src/game-view.vala"
		break;
#line 8083 "game-view.c"
		default:
#line 23 "../src/game-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/game-view.vala"
		break;
#line 8089 "game-view.c"
	}
}

