/* game.c generated by valac 0.43.4, the Vala compiler
 * generated from game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define TYPE_GAME_STATE_STRUCT (game_state_struct_get_type ())
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
typedef struct _GameStateStruct GameStateStruct;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_POSSIBLE_MOVE (possible_move_get_type ())
typedef struct _PossibleMove PossibleMove;

#define TYPE_GAME_STATE_OBJECT (game_state_object_get_type ())
#define GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_STATE_OBJECT, GameStateObject))
#define GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))
#define IS_GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_STATE_OBJECT))
#define IS_GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_STATE_OBJECT))
#define GAME_STATE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))

typedef struct _GameStateObject GameStateObject;
typedef struct _GameStateObjectClass GameStateObjectClass;
typedef struct _GameStateObjectPrivate GameStateObjectPrivate;
enum  {
	GAME_STATE_OBJECT_0_PROPERTY,
	GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY,
	GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY,
	GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY,
	GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY,
	GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY,
	GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY,
	GAME_STATE_OBJECT_NUM_PROPERTIES
};
static GParamSpec* game_state_object_properties[GAME_STATE_OBJECT_NUM_PROPERTIES];

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
enum  {
	GAME_0_PROPERTY,
	GAME_NUMBER_OF_MOVES_PROPERTY,
	GAME_SIZE_PROPERTY,
	GAME_CURRENT_STATE_PROPERTY,
	GAME_ALTERNATIVE_START_PROPERTY,
	GAME_INITIAL_NUMBER_OF_TILES_PROPERTY,
	GAME_IS_COMPLETE_PROPERTY,
	GAME_N_LIGHT_TILES_PROPERTY,
	GAME_N_DARK_TILES_PROPERTY,
	GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY,
	GAME_CURRENT_COLOR_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GAME_TURN_ENDED_SIGNAL,
	GAME_COMPLETENESS_UPDATED_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GameStateStruct {
	Player current_color;
	Player opponent_color;
	guint8 size;
	guint8 n_current_tiles;
	guint8 n_opponent_tiles;
	guint8 n_tiles;
	gboolean current_player_can_move;
	gboolean is_complete;
	Player* tiles;
	gint tiles_length1;
	gint tiles_length2;
	guint8* neighbor_tiles;
	gint neighbor_tiles_length1;
	gint neighbor_tiles_length2;
	guint8 x_saved;
	guint8 y_saved;
	guint8* empty_neighbors;
	gint empty_neighbors_length1;
	gint empty_neighbors_length2;
};

struct _PossibleMove {
	guint8 x;
	guint8 y;
	guint8 n_tiles;
	guint8 n_tiles_n;
	guint8 n_tiles_ne;
	guint8 n_tiles_e;
	guint8 n_tiles_se;
	guint8 n_tiles_s;
	guint8 n_tiles_so;
	guint8 n_tiles_o;
	guint8 n_tiles_no;
};

struct _GameStateObject {
	GObject parent_instance;
	GameStateObjectPrivate * priv;
};

struct _GameStateObjectClass {
	GObjectClass parent_class;
};

struct _GameStateObjectPrivate {
	GameStateStruct _game_state_struct;
};

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GamePrivate {
	GListStore* undo_stack;
	guint8 _size;
	GameStateObject* _current_state;
	gboolean _alternative_start;
	guint8 _initial_number_of_tiles;
	guint8* neighbor_tiles;
	gint neighbor_tiles_length1;
	gint neighbor_tiles_length2;
	GSList* possible_moves;
};

static gint GameStateObject_private_offset;
static gpointer game_state_object_parent_class = NULL;
static gint Game_private_offset;
static gpointer game_parent_class = NULL;

GType game_state_struct_get_type (void) G_GNUC_CONST;
GType player_get_type (void) G_GNUC_CONST;
GameStateStruct* game_state_struct_dup (const GameStateStruct* self);
void game_state_struct_free (GameStateStruct* self);
void game_state_struct_copy (const GameStateStruct* self,
                             GameStateStruct* dest);
void game_state_struct_destroy (GameStateStruct* self);
gchar* game_state_struct_to_string (GameStateStruct *self);
gchar* player_to_string (Player self);
void game_state_struct_init_copy_and_pass (GameStateStruct *self,
                                           GameStateStruct* game);
Player player_flip_color (Player p);
static Player* _vala_array_dup2 (Player* self,
                          int length);
static guint8* _vala_array_dup3 (guint8* self,
                          int length);
GType possible_move_get_type (void) G_GNUC_CONST;
PossibleMove* possible_move_dup (const PossibleMove* self);
void possible_move_free (PossibleMove* self);
void game_state_struct_init_copy_and_move (GameStateStruct *self,
                                           GameStateStruct* game,
                                           PossibleMove* move);
static Player* _vala_array_dup4 (Player* self,
                          int length);
static inline void game_state_struct_flip_tiles (Player** tiles,
                                   gint* tiles_length1,
                                   gint* tiles_length2,
                                   guint8 x,
                                   guint8 y,
                                   Player color,
                                   gint8 x_step,
                                   gint8 y_step,
                                   guint8 count);
static guint8* _vala_array_dup5 (guint8* self,
                          int length);
static inline void game_state_struct_update_empty_neighbors (GameStateStruct *self,
                                               guint8 x,
                                               guint8 y);
static void game_state_struct_update_who_can_move (GameStateStruct *self);
void game_state_struct_init_from_grid (GameStateStruct *self,
                                       guint8 _size,
                                       Player* _tiles,
                                       gint _tiles_length1,
                                       gint _tiles_length2,
                                       Player color,
                                       guint8* _neighbor_tiles,
                                       gint _neighbor_tiles_length1,
                                       gint _neighbor_tiles_length2);
static Player* _vala_array_dup6 (Player* self,
                          int length);
static inline void game_state_struct_add_tile_of_color (GameStateStruct *self,
                                          Player color);
static inline void game_state_struct_init_empty_neighbors (GameStateStruct *self);
gboolean game_state_struct_is_current_color (GameStateStruct *self,
                                             guint8 x,
                                             guint8 y);
gboolean game_state_struct_is_opponent_color (GameStateStruct *self,
                                              guint8 x,
                                              guint8 y);
static inline gboolean game_state_struct_is_valid_location_signed (GameStateStruct *self,
                                                     gint8 x,
                                                     gint8 y);
static inline gboolean game_state_struct_is_unplayable_basic (GameStateStruct *self,
                                                guint8 x,
                                                guint8 y);
static inline gboolean game_state_struct_can_place (GameStateStruct *self,
                                      guint8 x,
                                      guint8 y,
                                      Player color);
void game_state_struct_get_possible_moves (GameStateStruct *self,
                                           GSList* * moves);
static void _possible_move_free0_ (gpointer var);
static inline void _g_slist_free__possible_move_free0_ (GSList* self);
static inline gboolean game_state_struct_place_tile (GameStateStruct *self,
                                       guint8 x,
                                       guint8 y,
                                       Player color,
                                       PossibleMove* move);
gboolean game_state_struct_test_placing_tile (GameStateStruct *self,
                                              guint8 x,
                                              guint8 y,
                                              PossibleMove* move);
void possible_move_init (PossibleMove *self,
                         guint8 x,
                         guint8 y);
static inline guint8 game_state_struct_can_flip_tiles (GameStateStruct *self,
                                         guint8 x,
                                         guint8 y,
                                         Player color,
                                         gint8 x_step,
                                         gint8 y_step);
guint8 game_state_struct_get_empty_neighbors (GameStateStruct *self,
                                              guint8 x,
                                              guint8 y);
static inline guint8 game_state_struct_is_empty (GameStateStruct *self,
                                   gint8 x,
                                   gint8 y);
static Player* _vala_array_dup7 (Player* self,
                          int length);
static guint8* _vala_array_dup8 (guint8* self,
                          int length);
GType game_state_object_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameStateObject, g_object_unref)
gchar* game_state_object_to_string (GameStateObject* self);
void game_state_object_get_game_state_struct (GameStateObject* self,
                                              GameStateStruct * result);
GameStateObject* game_state_object_new_copy_and_pass (GameStateObject* game);
GameStateObject* game_state_object_construct_copy_and_pass (GType object_type,
                                                            GameStateObject* game);
GameStateObject* game_state_object_new_copy_and_move (GameStateObject* game,
                                                      PossibleMove* move);
GameStateObject* game_state_object_construct_copy_and_move (GType object_type,
                                                            GameStateObject* game,
                                                            PossibleMove* move);
GameStateObject* game_state_object_new_from_grid (guint8 size,
                                                  Player* tiles,
                                                  gint tiles_length1,
                                                  gint tiles_length2,
                                                  Player color,
                                                  guint8* neighbor_tiles,
                                                  gint neighbor_tiles_length1,
                                                  gint neighbor_tiles_length2);
GameStateObject* game_state_object_construct_from_grid (GType object_type,
                                                        guint8 size,
                                                        Player* tiles,
                                                        gint tiles_length1,
                                                        gint tiles_length2,
                                                        Player color,
                                                        guint8* neighbor_tiles,
                                                        gint neighbor_tiles_length1,
                                                        gint neighbor_tiles_length2);
Player game_state_object_get_owner (GameStateObject* self,
                                    guint8 x,
                                    guint8 y);
void game_state_object_get_possible_moves (GameStateObject* self,
                                           GSList* * moves);
gboolean game_state_object_test_placing_tile (GameStateObject* self,
                                              guint8 x,
                                              guint8 y,
                                              PossibleMove* move);
GameStateObject* game_state_object_new (void);
GameStateObject* game_state_object_construct (GType object_type);
Player game_state_object_get_current_color (GameStateObject* self);
guint8 game_state_object_get_n_light_tiles (GameStateObject* self);
guint8 game_state_object_get_n_dark_tiles (GameStateObject* self);
gboolean game_state_object_get_current_player_can_move (GameStateObject* self);
gboolean game_state_object_get_is_complete (GameStateObject* self);
static void game_state_object_finalize (GObject * obj);
static void _vala_game_state_object_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
GType game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
Game* game_new (gboolean _alternative_start,
                guint8 _size);
Game* game_construct (GType object_type,
                      gboolean _alternative_start,
                      guint8 _size);
static void game_init_neighbor_tiles (guint8 size,
                               guint8** neighbor_tiles,
                               gint* neighbor_tiles_length1,
                               gint* neighbor_tiles_length2);
Game* game_new_from_strings (gchar** setup,
                             gint setup_length1,
                             Player to_move,
                             guint8 _size);
Game* game_construct_from_strings (GType object_type,
                                   gchar** setup,
                                   gint setup_length1,
                                   Player to_move,
                                   guint8 _size);
Player player_from_char (gchar c);
gchar* game_to_string (Game* self);
Player game_get_owner (Game* self,
                       guint8 x,
                       guint8 y);
GameStateObject* game_get_current_state (Game* self);
gboolean game_place_tile (Game* self,
                          guint8 x,
                          guint8 y);
void game_set_current_state (Game* self,
                             GameStateObject* value);
static void game_end_of_turn (Game* self,
                       gboolean undoing,
                       gboolean no_draw);
gboolean game_pass (Game* self);
gboolean game_get_current_player_can_move (Game* self);
static inline void game_update_possible_moves (Game* self);
void game_undo (Game* self,
                guint8 count);
guint8 game_get_number_of_moves (Game* self);
guint8* game_copy_neighbor_tiles (Game* self,
                                  gint* result_length1,
                                  gint* result_length2);
static guint8* _vala_array_dup9 (guint8* self,
                          int length);
gboolean game_test_placing_tile (Game* self,
                                 guint8 x,
                                 guint8 y,
                                 PossibleMove* move);
void game_get_possible_moves (Game* self,
                              GSList* * moves);
static PossibleMove* __lambda6_ (Game* self,
                          PossibleMove* a);
static gpointer ___lambda6__gcopy_func (gconstpointer src,
                                 gpointer self);
guint8 game_get_size (Game* self);
static void game_set_size (Game* self,
                    guint8 value);
gboolean game_get_alternative_start (Game* self);
static void game_set_alternative_start (Game* self,
                                 gboolean value);
guint8 game_get_initial_number_of_tiles (Game* self);
static void game_set_initial_number_of_tiles (Game* self,
                                       guint8 value);
gboolean game_get_is_complete (Game* self);
guint8 game_get_n_light_tiles (Game* self);
guint8 game_get_n_dark_tiles (Game* self);
Player game_get_current_color (Game* self);
static void g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static GObject * game_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties);
static void game_finalize (GObject * obj);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);

gchar*
game_state_struct_to_string (GameStateStruct *self)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
#line 41 "../src/game.vala"
	_tmp0_ = g_strdup ("\n");
#line 41 "../src/game.vala"
	s = _tmp0_;
#line 430 "game.c"
	{
		guint8 y = 0U;
#line 43 "../src/game.vala"
		y = (guint8) 0;
#line 435 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 43 "../src/game.vala"
			_tmp1_ = TRUE;
#line 43 "../src/game.vala"
			while (TRUE) {
#line 442 "game.c"
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 43 "../src/game.vala"
				if (!_tmp1_) {
#line 447 "game.c"
					guint8 _tmp2_;
#line 43 "../src/game.vala"
					_tmp2_ = y;
#line 43 "../src/game.vala"
					y = _tmp2_ + 1;
#line 453 "game.c"
				}
#line 43 "../src/game.vala"
				_tmp1_ = FALSE;
#line 43 "../src/game.vala"
				if (!(y < (*self).size)) {
#line 43 "../src/game.vala"
					break;
#line 461 "game.c"
				}
				{
					guint8 x = 0U;
#line 45 "../src/game.vala"
					x = (guint8) 0;
#line 467 "game.c"
					{
						gboolean _tmp3_ = FALSE;
#line 45 "../src/game.vala"
						_tmp3_ = TRUE;
#line 45 "../src/game.vala"
						while (TRUE) {
#line 474 "game.c"
							const gchar* _tmp5_;
							Player* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							Player _tmp7_;
							gchar* _tmp8_;
							gchar* _tmp9_;
							gchar* _tmp10_;
							gchar* _tmp11_;
							gchar* _tmp12_;
#line 45 "../src/game.vala"
							if (!_tmp3_) {
#line 487 "game.c"
								guint8 _tmp4_;
#line 45 "../src/game.vala"
								_tmp4_ = x;
#line 45 "../src/game.vala"
								x = _tmp4_ + 1;
#line 493 "game.c"
							}
#line 45 "../src/game.vala"
							_tmp3_ = FALSE;
#line 45 "../src/game.vala"
							if (!(x < (*self).size)) {
#line 45 "../src/game.vala"
								break;
#line 501 "game.c"
							}
#line 46 "../src/game.vala"
							_tmp5_ = s;
#line 46 "../src/game.vala"
							_tmp6_ = (*self).tiles;
#line 46 "../src/game.vala"
							_tmp6__length1 = (*self).tiles_length1;
#line 46 "../src/game.vala"
							_tmp6__length2 = (*self).tiles_length2;
#line 46 "../src/game.vala"
							_tmp7_ = _tmp6_[(x * _tmp6__length2) + y];
#line 46 "../src/game.vala"
							_tmp8_ = player_to_string (_tmp7_);
#line 46 "../src/game.vala"
							_tmp9_ = _tmp8_;
#line 46 "../src/game.vala"
							_tmp10_ = g_strconcat (" ", _tmp9_, NULL);
#line 46 "../src/game.vala"
							_tmp11_ = _tmp10_;
#line 46 "../src/game.vala"
							_tmp12_ = g_strconcat (_tmp5_, _tmp11_, NULL);
#line 46 "../src/game.vala"
							_g_free0 (s);
#line 46 "../src/game.vala"
							s = _tmp12_;
#line 46 "../src/game.vala"
							_g_free0 (_tmp11_);
#line 46 "../src/game.vala"
							_g_free0 (_tmp9_);
#line 531 "game.c"
						}
					}
				}
#line 47 "../src/game.vala"
				_tmp13_ = s;
#line 47 "../src/game.vala"
				_tmp14_ = g_strconcat (_tmp13_, "\n", NULL);
#line 47 "../src/game.vala"
				_g_free0 (s);
#line 47 "../src/game.vala"
				s = _tmp14_;
#line 543 "game.c"
			}
		}
	}
#line 50 "../src/game.vala"
	result = s;
#line 50 "../src/game.vala"
	return result;
#line 551 "game.c"
}

static Player*
_vala_array_dup2 (Player* self,
                  int length)
{
#line 66 "../src/game.vala"
	return g_memdup (self, length * sizeof (Player));
#line 560 "game.c"
}

static guint8*
_vala_array_dup3 (guint8* self,
                  int length)
{
#line 74 "../src/game.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 569 "game.c"
}

void
game_state_struct_init_copy_and_pass (GameStateStruct *self,
                                      GameStateStruct* game)
{
	GameStateStruct _tmp0_;
	Player _tmp1_;
	Player _tmp2_;
	GameStateStruct _tmp3_;
	GameStateStruct _tmp4_;
	guint8* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	GameStateStruct _tmp6_;
	Player* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	Player* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	GameStateStruct _tmp9_;
	GameStateStruct _tmp10_;
	GameStateStruct _tmp11_;
	guint8* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	guint8* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
#line 53 "../src/game.vala"
	g_return_if_fail (game != NULL);
#line 53 "../src/game.vala"
	memset (self, 0, sizeof (GameStateStruct));
#line 58 "../src/game.vala"
	_tmp0_ = *game;
#line 58 "../src/game.vala"
	_tmp1_ = _tmp0_.current_color;
#line 58 "../src/game.vala"
	(*self).opponent_color = _tmp1_;
#line 59 "../src/game.vala"
	_tmp2_ = (*self).opponent_color;
#line 59 "../src/game.vala"
	(*self).current_color = player_flip_color (_tmp2_);
#line 62 "../src/game.vala"
	_tmp3_ = *game;
#line 62 "../src/game.vala"
	(*self).size = _tmp3_.size;
#line 63 "../src/game.vala"
	_tmp4_ = *game;
#line 63 "../src/game.vala"
	_tmp5_ = _tmp4_.neighbor_tiles;
#line 63 "../src/game.vala"
	_tmp5__length1 = _tmp4_.neighbor_tiles_length1;
#line 63 "../src/game.vala"
	_tmp5__length2 = _tmp4_.neighbor_tiles_length2;
#line 63 "../src/game.vala"
	(*self).neighbor_tiles = _tmp5_;
#line 63 "../src/game.vala"
	(*self).neighbor_tiles_length1 = _tmp5__length1;
#line 63 "../src/game.vala"
	(*self).neighbor_tiles_length2 = _tmp5__length2;
#line 66 "../src/game.vala"
	_tmp6_ = *game;
#line 66 "../src/game.vala"
	_tmp7_ = _tmp6_.tiles;
#line 66 "../src/game.vala"
	_tmp7__length1 = _tmp6_.tiles_length1;
#line 66 "../src/game.vala"
	_tmp7__length2 = _tmp6_.tiles_length2;
#line 66 "../src/game.vala"
	_tmp8_ = (_tmp7_ != NULL) ? _vala_array_dup2 (_tmp7_, _tmp7__length1 * _tmp7__length2) : ((gpointer) _tmp7_);
#line 66 "../src/game.vala"
	_tmp8__length1 = _tmp7__length1;
#line 66 "../src/game.vala"
	_tmp8__length2 = _tmp7__length2;
#line 66 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 66 "../src/game.vala"
	(*self).tiles = _tmp8_;
#line 66 "../src/game.vala"
	(*self).tiles_length1 = _tmp8__length1;
#line 66 "../src/game.vala"
	(*self).tiles_length2 = _tmp8__length2;
#line 69 "../src/game.vala"
	_tmp9_ = *game;
#line 69 "../src/game.vala"
	(*self).n_current_tiles = _tmp9_.n_opponent_tiles;
#line 70 "../src/game.vala"
	_tmp10_ = *game;
#line 70 "../src/game.vala"
	(*self).n_opponent_tiles = _tmp10_.n_current_tiles;
#line 71 "../src/game.vala"
	(*self).n_tiles = (*self).n_current_tiles + (*self).n_opponent_tiles;
#line 74 "../src/game.vala"
	_tmp11_ = *game;
#line 74 "../src/game.vala"
	_tmp12_ = _tmp11_.empty_neighbors;
#line 74 "../src/game.vala"
	_tmp12__length1 = _tmp11_.empty_neighbors_length1;
#line 74 "../src/game.vala"
	_tmp12__length2 = _tmp11_.empty_neighbors_length2;
#line 74 "../src/game.vala"
	_tmp13_ = (_tmp12_ != NULL) ? _vala_array_dup3 (_tmp12_, _tmp12__length1 * _tmp12__length2) : ((gpointer) _tmp12_);
#line 74 "../src/game.vala"
	_tmp13__length1 = _tmp12__length1;
#line 74 "../src/game.vala"
	_tmp13__length2 = _tmp12__length2;
#line 74 "../src/game.vala"
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
#line 74 "../src/game.vala"
	(*self).empty_neighbors = _tmp13_;
#line 74 "../src/game.vala"
	(*self).empty_neighbors_length1 = _tmp13__length1;
#line 74 "../src/game.vala"
	(*self).empty_neighbors_length2 = _tmp13__length2;
#line 77 "../src/game.vala"
	(*self).current_player_can_move = TRUE;
#line 78 "../src/game.vala"
	(*self).is_complete = FALSE;
#line 79 "../src/game.vala"
	(*self).x_saved = (guint8) 0;
#line 80 "../src/game.vala"
	(*self).y_saved = (guint8) 0;
#line 694 "game.c"
}

static Player*
_vala_array_dup4 (Player* self,
                  int length)
{
#line 94 "../src/game.vala"
	return g_memdup (self, length * sizeof (Player));
#line 703 "game.c"
}

static guint8*
_vala_array_dup5 (guint8* self,
                  int length)
{
#line 111 "../src/game.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 712 "game.c"
}

void
game_state_struct_init_copy_and_move (GameStateStruct *self,
                                      GameStateStruct* game,
                                      PossibleMove* move)
{
	GameStateStruct _tmp0_;
	Player _tmp1_;
	Player _tmp2_;
	GameStateStruct _tmp3_;
	GameStateStruct _tmp4_;
	guint8* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	GameStateStruct _tmp6_;
	Player* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	Player* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	PossibleMove _tmp9_;
	PossibleMove _tmp10_;
	Player _tmp11_;
	PossibleMove _tmp12_;
	PossibleMove _tmp13_;
	PossibleMove _tmp14_;
	Player _tmp15_;
	PossibleMove _tmp16_;
	PossibleMove _tmp17_;
	PossibleMove _tmp18_;
	Player _tmp19_;
	PossibleMove _tmp20_;
	PossibleMove _tmp21_;
	PossibleMove _tmp22_;
	Player _tmp23_;
	PossibleMove _tmp24_;
	PossibleMove _tmp25_;
	PossibleMove _tmp26_;
	Player _tmp27_;
	PossibleMove _tmp28_;
	PossibleMove _tmp29_;
	PossibleMove _tmp30_;
	Player _tmp31_;
	PossibleMove _tmp32_;
	PossibleMove _tmp33_;
	PossibleMove _tmp34_;
	Player _tmp35_;
	PossibleMove _tmp36_;
	PossibleMove _tmp37_;
	PossibleMove _tmp38_;
	Player _tmp39_;
	PossibleMove _tmp40_;
	PossibleMove _tmp41_;
	PossibleMove _tmp42_;
	Player _tmp43_;
	GameStateStruct _tmp44_;
	PossibleMove _tmp45_;
	GameStateStruct _tmp46_;
	PossibleMove _tmp47_;
	GameStateStruct _tmp48_;
	guint8* _tmp49_;
	gint _tmp49__length1;
	gint _tmp49__length2;
	guint8* _tmp50_;
	gint _tmp50__length1;
	gint _tmp50__length2;
	PossibleMove _tmp51_;
	PossibleMove _tmp52_;
#line 83 "../src/game.vala"
	g_return_if_fail (game != NULL);
#line 83 "../src/game.vala"
	g_return_if_fail (move != NULL);
#line 83 "../src/game.vala"
	memset (self, 0, sizeof (GameStateStruct));
#line 86 "../src/game.vala"
	_tmp0_ = *game;
#line 86 "../src/game.vala"
	_tmp1_ = _tmp0_.current_color;
#line 86 "../src/game.vala"
	(*self).opponent_color = _tmp1_;
#line 87 "../src/game.vala"
	_tmp2_ = (*self).opponent_color;
#line 87 "../src/game.vala"
	(*self).current_color = player_flip_color (_tmp2_);
#line 90 "../src/game.vala"
	_tmp3_ = *game;
#line 90 "../src/game.vala"
	(*self).size = _tmp3_.size;
#line 91 "../src/game.vala"
	_tmp4_ = *game;
#line 91 "../src/game.vala"
	_tmp5_ = _tmp4_.neighbor_tiles;
#line 91 "../src/game.vala"
	_tmp5__length1 = _tmp4_.neighbor_tiles_length1;
#line 91 "../src/game.vala"
	_tmp5__length2 = _tmp4_.neighbor_tiles_length2;
#line 91 "../src/game.vala"
	(*self).neighbor_tiles = _tmp5_;
#line 91 "../src/game.vala"
	(*self).neighbor_tiles_length1 = _tmp5__length1;
#line 91 "../src/game.vala"
	(*self).neighbor_tiles_length2 = _tmp5__length2;
#line 94 "../src/game.vala"
	_tmp6_ = *game;
#line 94 "../src/game.vala"
	_tmp7_ = _tmp6_.tiles;
#line 94 "../src/game.vala"
	_tmp7__length1 = _tmp6_.tiles_length1;
#line 94 "../src/game.vala"
	_tmp7__length2 = _tmp6_.tiles_length2;
#line 94 "../src/game.vala"
	_tmp8_ = (_tmp7_ != NULL) ? _vala_array_dup4 (_tmp7_, _tmp7__length1 * _tmp7__length2) : ((gpointer) _tmp7_);
#line 94 "../src/game.vala"
	_tmp8__length1 = _tmp7__length1;
#line 94 "../src/game.vala"
	_tmp8__length2 = _tmp7__length2;
#line 94 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 94 "../src/game.vala"
	(*self).tiles = _tmp8_;
#line 94 "../src/game.vala"
	(*self).tiles_length1 = _tmp8__length1;
#line 94 "../src/game.vala"
	(*self).tiles_length2 = _tmp8__length2;
#line 95 "../src/game.vala"
	_tmp9_ = *move;
#line 95 "../src/game.vala"
	_tmp10_ = *move;
#line 95 "../src/game.vala"
	_tmp11_ = (*self).opponent_color;
#line 95 "../src/game.vala"
	_tmp12_ = *move;
#line 95 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp9_.x, _tmp10_.y, _tmp11_, (gint8) 0, (gint8) -1, _tmp12_.n_tiles_n);
#line 96 "../src/game.vala"
	_tmp13_ = *move;
#line 96 "../src/game.vala"
	_tmp14_ = *move;
#line 96 "../src/game.vala"
	_tmp15_ = (*self).opponent_color;
#line 96 "../src/game.vala"
	_tmp16_ = *move;
#line 96 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp13_.x, _tmp14_.y, _tmp15_, (gint8) 1, (gint8) -1, _tmp16_.n_tiles_ne);
#line 97 "../src/game.vala"
	_tmp17_ = *move;
#line 97 "../src/game.vala"
	_tmp18_ = *move;
#line 97 "../src/game.vala"
	_tmp19_ = (*self).opponent_color;
#line 97 "../src/game.vala"
	_tmp20_ = *move;
#line 97 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp17_.x, _tmp18_.y, _tmp19_, (gint8) 1, (gint8) 0, _tmp20_.n_tiles_e);
#line 98 "../src/game.vala"
	_tmp21_ = *move;
#line 98 "../src/game.vala"
	_tmp22_ = *move;
#line 98 "../src/game.vala"
	_tmp23_ = (*self).opponent_color;
#line 98 "../src/game.vala"
	_tmp24_ = *move;
#line 98 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp21_.x, _tmp22_.y, _tmp23_, (gint8) 1, (gint8) 1, _tmp24_.n_tiles_se);
#line 99 "../src/game.vala"
	_tmp25_ = *move;
#line 99 "../src/game.vala"
	_tmp26_ = *move;
#line 99 "../src/game.vala"
	_tmp27_ = (*self).opponent_color;
#line 99 "../src/game.vala"
	_tmp28_ = *move;
#line 99 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp25_.x, _tmp26_.y, _tmp27_, (gint8) 0, (gint8) 1, _tmp28_.n_tiles_s);
#line 100 "../src/game.vala"
	_tmp29_ = *move;
#line 100 "../src/game.vala"
	_tmp30_ = *move;
#line 100 "../src/game.vala"
	_tmp31_ = (*self).opponent_color;
#line 100 "../src/game.vala"
	_tmp32_ = *move;
#line 100 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp29_.x, _tmp30_.y, _tmp31_, (gint8) -1, (gint8) 1, _tmp32_.n_tiles_so);
#line 101 "../src/game.vala"
	_tmp33_ = *move;
#line 101 "../src/game.vala"
	_tmp34_ = *move;
#line 101 "../src/game.vala"
	_tmp35_ = (*self).opponent_color;
#line 101 "../src/game.vala"
	_tmp36_ = *move;
#line 101 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp33_.x, _tmp34_.y, _tmp35_, (gint8) -1, (gint8) 0, _tmp36_.n_tiles_o);
#line 102 "../src/game.vala"
	_tmp37_ = *move;
#line 102 "../src/game.vala"
	_tmp38_ = *move;
#line 102 "../src/game.vala"
	_tmp39_ = (*self).opponent_color;
#line 102 "../src/game.vala"
	_tmp40_ = *move;
#line 102 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp37_.x, _tmp38_.y, _tmp39_, (gint8) -1, (gint8) -1, _tmp40_.n_tiles_no);
#line 103 "../src/game.vala"
	_tmp41_ = *move;
#line 103 "../src/game.vala"
	_tmp42_ = *move;
#line 103 "../src/game.vala"
	_tmp43_ = (*self).opponent_color;
#line 103 "../src/game.vala"
	(*self).tiles[(_tmp41_.x * (*self).tiles_length2) + _tmp42_.y] = _tmp43_;
#line 106 "../src/game.vala"
	_tmp44_ = *game;
#line 106 "../src/game.vala"
	_tmp45_ = *move;
#line 106 "../src/game.vala"
	(*self).n_current_tiles = _tmp44_.n_opponent_tiles - _tmp45_.n_tiles;
#line 107 "../src/game.vala"
	_tmp46_ = *game;
#line 107 "../src/game.vala"
	_tmp47_ = *move;
#line 107 "../src/game.vala"
	(*self).n_opponent_tiles = (guint8) ((_tmp46_.n_current_tiles + _tmp47_.n_tiles) + 1);
#line 108 "../src/game.vala"
	(*self).n_tiles = (*self).n_current_tiles + (*self).n_opponent_tiles;
#line 111 "../src/game.vala"
	_tmp48_ = *game;
#line 111 "../src/game.vala"
	_tmp49_ = _tmp48_.empty_neighbors;
#line 111 "../src/game.vala"
	_tmp49__length1 = _tmp48_.empty_neighbors_length1;
#line 111 "../src/game.vala"
	_tmp49__length2 = _tmp48_.empty_neighbors_length2;
#line 111 "../src/game.vala"
	_tmp50_ = (_tmp49_ != NULL) ? _vala_array_dup5 (_tmp49_, _tmp49__length1 * _tmp49__length2) : ((gpointer) _tmp49_);
#line 111 "../src/game.vala"
	_tmp50__length1 = _tmp49__length1;
#line 111 "../src/game.vala"
	_tmp50__length2 = _tmp49__length2;
#line 111 "../src/game.vala"
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
#line 111 "../src/game.vala"
	(*self).empty_neighbors = _tmp50_;
#line 111 "../src/game.vala"
	(*self).empty_neighbors_length1 = _tmp50__length1;
#line 111 "../src/game.vala"
	(*self).empty_neighbors_length2 = _tmp50__length2;
#line 112 "../src/game.vala"
	_tmp51_ = *move;
#line 112 "../src/game.vala"
	_tmp52_ = *move;
#line 112 "../src/game.vala"
	game_state_struct_update_empty_neighbors (&(*self), _tmp51_.x, _tmp52_.y);
#line 115 "../src/game.vala"
	game_state_struct_update_who_can_move (&(*self));
#line 971 "game.c"
}

static inline void
game_state_struct_flip_tiles (Player** tiles,
                              gint* tiles_length1,
                              gint* tiles_length2,
                              guint8 x,
                              guint8 y,
                              Player color,
                              gint8 x_step,
                              gint8 y_step,
                              guint8 count)
{
	{
		gboolean _tmp0_ = FALSE;
#line 119 "../src/game.vala"
		_tmp0_ = TRUE;
#line 119 "../src/game.vala"
		while (TRUE) {
#line 119 "../src/game.vala"
			if (!_tmp0_) {
#line 993 "game.c"
				guint8 _tmp1_;
#line 119 "../src/game.vala"
				_tmp1_ = count;
#line 119 "../src/game.vala"
				count = _tmp1_ - 1;
#line 999 "game.c"
			}
#line 119 "../src/game.vala"
			_tmp0_ = FALSE;
#line 119 "../src/game.vala"
			if (!(((gint) count) > 0)) {
#line 119 "../src/game.vala"
				break;
#line 1007 "game.c"
			}
#line 121 "../src/game.vala"
			(*tiles)[((((gint8) x) + (((gint8) count) * x_step)) * (*tiles_length2)) + (((gint8) y) + (((gint8) count) * y_step))] = color;
#line 1011 "game.c"
		}
	}
}

static Player*
_vala_array_dup6 (Player* self,
                  int length)
{
#line 137 "../src/game.vala"
	return g_memdup (self, length * sizeof (Player));
#line 1022 "game.c"
}

void
game_state_struct_init_from_grid (GameStateStruct *self,
                                  guint8 _size,
                                  Player* _tiles,
                                  gint _tiles_length1,
                                  gint _tiles_length2,
                                  Player color,
                                  guint8* _neighbor_tiles,
                                  gint _neighbor_tiles_length1,
                                  gint _neighbor_tiles_length2)
{
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 126 "../src/game.vala"
	memset (self, 0, sizeof (GameStateStruct));
#line 129 "../src/game.vala"
	(*self).current_color = color;
#line 130 "../src/game.vala"
	(*self).opponent_color = player_flip_color (color);
#line 133 "../src/game.vala"
	(*self).size = _size;
#line 134 "../src/game.vala"
	(*self).neighbor_tiles = _neighbor_tiles;
#line 134 "../src/game.vala"
	(*self).neighbor_tiles_length1 = _neighbor_tiles_length1;
#line 134 "../src/game.vala"
	(*self).neighbor_tiles_length2 = _neighbor_tiles_length2;
#line 137 "../src/game.vala"
	_tmp0_ = (_tiles != NULL) ? _vala_array_dup6 (_tiles, _tiles_length1 * _tiles_length2) : ((gpointer) _tiles);
#line 137 "../src/game.vala"
	_tmp0__length1 = _tiles_length1;
#line 137 "../src/game.vala"
	_tmp0__length2 = _tiles_length2;
#line 137 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 137 "../src/game.vala"
	(*self).tiles = _tmp0_;
#line 137 "../src/game.vala"
	(*self).tiles_length1 = _tmp0__length1;
#line 137 "../src/game.vala"
	(*self).tiles_length2 = _tmp0__length2;
#line 140 "../src/game.vala"
	(*self).n_current_tiles = (guint8) 0;
#line 141 "../src/game.vala"
	(*self).n_opponent_tiles = (guint8) 0;
#line 1071 "game.c"
	{
		guint8 x = 0U;
#line 142 "../src/game.vala"
		x = (guint8) 0;
#line 1076 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 142 "../src/game.vala"
			_tmp1_ = TRUE;
#line 142 "../src/game.vala"
			while (TRUE) {
#line 142 "../src/game.vala"
				if (!_tmp1_) {
#line 1085 "game.c"
					guint8 _tmp2_;
#line 142 "../src/game.vala"
					_tmp2_ = x;
#line 142 "../src/game.vala"
					x = _tmp2_ + 1;
#line 1091 "game.c"
				}
#line 142 "../src/game.vala"
				_tmp1_ = FALSE;
#line 142 "../src/game.vala"
				if (!(x < _size)) {
#line 142 "../src/game.vala"
					break;
#line 1099 "game.c"
				}
				{
					guint8 y = 0U;
#line 143 "../src/game.vala"
					y = (guint8) 0;
#line 1105 "game.c"
					{
						gboolean _tmp3_ = FALSE;
#line 143 "../src/game.vala"
						_tmp3_ = TRUE;
#line 143 "../src/game.vala"
						while (TRUE) {
#line 1112 "game.c"
							Player _tmp5_;
#line 143 "../src/game.vala"
							if (!_tmp3_) {
#line 1116 "game.c"
								guint8 _tmp4_;
#line 143 "../src/game.vala"
								_tmp4_ = y;
#line 143 "../src/game.vala"
								y = _tmp4_ + 1;
#line 1122 "game.c"
							}
#line 143 "../src/game.vala"
							_tmp3_ = FALSE;
#line 143 "../src/game.vala"
							if (!(y < _size)) {
#line 143 "../src/game.vala"
								break;
#line 1130 "game.c"
							}
#line 144 "../src/game.vala"
							_tmp5_ = _tiles[(x * _tiles_length2) + y];
#line 144 "../src/game.vala"
							game_state_struct_add_tile_of_color (&(*self), _tmp5_);
#line 1136 "game.c"
						}
					}
				}
			}
		}
	}
#line 145 "../src/game.vala"
	(*self).n_tiles = (*self).n_current_tiles + (*self).n_opponent_tiles;
#line 148 "../src/game.vala"
	game_state_struct_init_empty_neighbors (&(*self));
#line 151 "../src/game.vala"
	game_state_struct_update_who_can_move (&(*self));
#line 1149 "game.c"
}

static inline void
game_state_struct_add_tile_of_color (GameStateStruct *self,
                                     Player color)
{
	Player _tmp0_;
#line 155 "../src/game.vala"
	_tmp0_ = (*self).current_color;
#line 155 "../src/game.vala"
	if (color == _tmp0_) {
#line 1161 "game.c"
		guint8 _tmp1_;
#line 156 "../src/game.vala"
		_tmp1_ = (*self).n_current_tiles;
#line 156 "../src/game.vala"
		(*self).n_current_tiles = _tmp1_ + 1;
#line 1167 "game.c"
	} else {
#line 157 "../src/game.vala"
		if (color != PLAYER_NONE) {
#line 1171 "game.c"
			guint8 _tmp2_;
#line 158 "../src/game.vala"
			_tmp2_ = (*self).n_opponent_tiles;
#line 158 "../src/game.vala"
			(*self).n_opponent_tiles = _tmp2_ + 1;
#line 1177 "game.c"
		}
	}
}

inline gboolean
game_state_struct_is_current_color (GameStateStruct *self,
                                    guint8 x,
                                    guint8 y)
{
	gboolean result = FALSE;
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
	Player _tmp2_;
#line 168 "../src/game.vala"
	_tmp0_ = (*self).tiles;
#line 168 "../src/game.vala"
	_tmp0__length1 = (*self).tiles_length1;
#line 168 "../src/game.vala"
	_tmp0__length2 = (*self).tiles_length2;
#line 168 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 168 "../src/game.vala"
	_tmp2_ = (*self).current_color;
#line 168 "../src/game.vala"
	result = _tmp1_ == _tmp2_;
#line 168 "../src/game.vala"
	return result;
#line 1207 "game.c"
}

inline gboolean
game_state_struct_is_opponent_color (GameStateStruct *self,
                                     guint8 x,
                                     guint8 y)
{
	gboolean result = FALSE;
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
	Player _tmp2_;
#line 174 "../src/game.vala"
	_tmp0_ = (*self).tiles;
#line 174 "../src/game.vala"
	_tmp0__length1 = (*self).tiles_length1;
#line 174 "../src/game.vala"
	_tmp0__length2 = (*self).tiles_length2;
#line 174 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 174 "../src/game.vala"
	_tmp2_ = (*self).opponent_color;
#line 174 "../src/game.vala"
	result = _tmp1_ == _tmp2_;
#line 174 "../src/game.vala"
	return result;
#line 1235 "game.c"
}

static inline gboolean
game_state_struct_is_valid_location_signed (GameStateStruct *self,
                                            gint8 x,
                                            gint8 y)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 179 "../src/game.vala"
	if (((gint) x) >= 0) {
#line 179 "../src/game.vala"
		_tmp2_ = ((guint8) x) < (*self).size;
#line 1251 "game.c"
	} else {
#line 179 "../src/game.vala"
		_tmp2_ = FALSE;
#line 1255 "game.c"
	}
#line 179 "../src/game.vala"
	if (_tmp2_) {
#line 180 "../src/game.vala"
		_tmp1_ = ((gint) y) >= 0;
#line 1261 "game.c"
	} else {
#line 179 "../src/game.vala"
		_tmp1_ = FALSE;
#line 1265 "game.c"
	}
#line 179 "../src/game.vala"
	if (_tmp1_) {
#line 180 "../src/game.vala"
		_tmp0_ = ((guint8) y) < (*self).size;
#line 1271 "game.c"
	} else {
#line 179 "../src/game.vala"
		_tmp0_ = FALSE;
#line 1275 "game.c"
	}
#line 179 "../src/game.vala"
	result = _tmp0_;
#line 179 "../src/game.vala"
	return result;
#line 1281 "game.c"
}

static void
game_state_struct_update_who_can_move (GameStateStruct *self)
{
	Player enemy = 0;
	Player _tmp0_;
	gboolean opponent_can_move = FALSE;
#line 197 "../src/game.vala"
	_tmp0_ = (*self).current_color;
#line 197 "../src/game.vala"
	enemy = player_flip_color (_tmp0_);
#line 198 "../src/game.vala"
	opponent_can_move = FALSE;
#line 1296 "game.c"
	{
		gboolean _tmp1_ = FALSE;
#line 199 "../src/game.vala"
		(*self).x_saved = (guint8) 0;
#line 199 "../src/game.vala"
		_tmp1_ = TRUE;
#line 199 "../src/game.vala"
		while (TRUE) {
#line 199 "../src/game.vala"
			if (!_tmp1_) {
#line 1307 "game.c"
				guint8 _tmp2_;
#line 199 "../src/game.vala"
				_tmp2_ = (*self).x_saved;
#line 199 "../src/game.vala"
				(*self).x_saved = _tmp2_ + 1;
#line 1313 "game.c"
			}
#line 199 "../src/game.vala"
			_tmp1_ = FALSE;
#line 199 "../src/game.vala"
			if (!((*self).x_saved < (*self).size)) {
#line 199 "../src/game.vala"
				break;
#line 1321 "game.c"
			}
			{
				gboolean _tmp3_ = FALSE;
#line 201 "../src/game.vala"
				(*self).y_saved = (guint8) 0;
#line 201 "../src/game.vala"
				_tmp3_ = TRUE;
#line 201 "../src/game.vala"
				while (TRUE) {
#line 1331 "game.c"
					Player _tmp5_;
					Player _tmp6_;
#line 201 "../src/game.vala"
					if (!_tmp3_) {
#line 1336 "game.c"
						guint8 _tmp4_;
#line 201 "../src/game.vala"
						_tmp4_ = (*self).y_saved;
#line 201 "../src/game.vala"
						(*self).y_saved = _tmp4_ + 1;
#line 1342 "game.c"
					}
#line 201 "../src/game.vala"
					_tmp3_ = FALSE;
#line 201 "../src/game.vala"
					if (!((*self).y_saved < (*self).size)) {
#line 201 "../src/game.vala"
						break;
#line 1350 "game.c"
					}
#line 203 "../src/game.vala"
					if (game_state_struct_is_unplayable_basic (&(*self), (*self).x_saved, (*self).y_saved)) {
#line 204 "../src/game.vala"
						continue;
#line 1356 "game.c"
					}
#line 205 "../src/game.vala"
					_tmp5_ = (*self).current_color;
#line 205 "../src/game.vala"
					if (game_state_struct_can_place (&(*self), (*self).x_saved, (*self).y_saved, _tmp5_)) {
#line 207 "../src/game.vala"
						(*self).current_player_can_move = TRUE;
#line 208 "../src/game.vala"
						(*self).is_complete = FALSE;
#line 209 "../src/game.vala"
						return;
#line 1368 "game.c"
					}
#line 211 "../src/game.vala"
					if (opponent_can_move) {
#line 212 "../src/game.vala"
						continue;
#line 1374 "game.c"
					}
#line 213 "../src/game.vala"
					_tmp6_ = enemy;
#line 213 "../src/game.vala"
					if (game_state_struct_can_place (&(*self), (*self).x_saved, (*self).y_saved, _tmp6_)) {
#line 215 "../src/game.vala"
						opponent_can_move = TRUE;
#line 216 "../src/game.vala"
						(*self).is_complete = FALSE;
#line 1384 "game.c"
					}
				}
			}
		}
	}
#line 220 "../src/game.vala"
	(*self).current_player_can_move = FALSE;
#line 221 "../src/game.vala"
	if (!opponent_can_move) {
#line 222 "../src/game.vala"
		(*self).is_complete = TRUE;
#line 1396 "game.c"
	}
}

static void
_possible_move_free0_ (gpointer var)
{
#line 227 "../src/game.vala"
	(var == NULL) ? NULL : (var = (possible_move_free (var), NULL));
#line 1405 "game.c"
}

static inline void
_g_slist_free__possible_move_free0_ (GSList* self)
{
#line 227 "../src/game.vala"
	g_slist_free_full (self, (GDestroyNotify) _possible_move_free0_);
#line 1413 "game.c"
}

static gpointer
_possible_move_dup0 (gpointer self)
{
#line 238 "../src/game.vala"
	return self ? possible_move_dup (self) : NULL;
#line 1421 "game.c"
}

void
game_state_struct_get_possible_moves (GameStateStruct *self,
                                      GSList* * moves)
{
	GSList* _vala_moves = NULL;
	guint8 x = 0U;
	guint8 y = 0U;
#line 227 "../src/game.vala"
	(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 227 "../src/game.vala"
	_vala_moves = NULL;
#line 230 "../src/game.vala"
	x = (*self).x_saved;
#line 231 "../src/game.vala"
	y = (*self).y_saved;
#line 1439 "game.c"
	{
		gboolean _tmp0_ = FALSE;
#line 232 "../src/game.vala"
		_tmp0_ = TRUE;
#line 232 "../src/game.vala"
		while (TRUE) {
#line 232 "../src/game.vala"
			if (!_tmp0_) {
#line 1448 "game.c"
				guint8 _tmp1_;
#line 232 "../src/game.vala"
				_tmp1_ = x;
#line 232 "../src/game.vala"
				x = _tmp1_ + 1;
#line 1454 "game.c"
			}
#line 232 "../src/game.vala"
			_tmp0_ = FALSE;
#line 232 "../src/game.vala"
			if (!(x < (*self).size)) {
#line 232 "../src/game.vala"
				break;
#line 1462 "game.c"
			}
			{
				gboolean _tmp2_ = FALSE;
#line 234 "../src/game.vala"
				_tmp2_ = TRUE;
#line 234 "../src/game.vala"
				while (TRUE) {
#line 1470 "game.c"
					PossibleMove move = {0};
					Player _tmp4_;
					PossibleMove _tmp5_ = {0};
					gboolean _tmp6_;
#line 234 "../src/game.vala"
					if (!_tmp2_) {
#line 1477 "game.c"
						guint8 _tmp3_;
#line 234 "../src/game.vala"
						_tmp3_ = y;
#line 234 "../src/game.vala"
						y = _tmp3_ + 1;
#line 1483 "game.c"
					}
#line 234 "../src/game.vala"
					_tmp2_ = FALSE;
#line 234 "../src/game.vala"
					if (!(y < (*self).size)) {
#line 234 "../src/game.vala"
						break;
#line 1491 "game.c"
					}
#line 237 "../src/game.vala"
					_tmp4_ = (*self).current_color;
#line 237 "../src/game.vala"
					_tmp6_ = game_state_struct_place_tile (&(*self), x, y, _tmp4_, &_tmp5_);
#line 237 "../src/game.vala"
					move = _tmp5_;
#line 237 "../src/game.vala"
					if (_tmp6_) {
#line 1501 "game.c"
						PossibleMove _tmp7_;
						PossibleMove* _tmp8_;
#line 238 "../src/game.vala"
						_tmp7_ = move;
#line 238 "../src/game.vala"
						_tmp8_ = _possible_move_dup0 (&_tmp7_);
#line 238 "../src/game.vala"
						_vala_moves = g_slist_prepend (_vala_moves, _tmp8_);
#line 1510 "game.c"
					}
				}
			}
#line 240 "../src/game.vala"
			y = (guint8) 0;
#line 1516 "game.c"
		}
	}
#line 225 "../src/game.vala"
	if (moves) {
#line 225 "../src/game.vala"
		*moves = _vala_moves;
#line 1523 "game.c"
	} else {
#line 225 "../src/game.vala"
		(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 1527 "game.c"
	}
}

inline gboolean
game_state_struct_test_placing_tile (GameStateStruct *self,
                                     guint8 x,
                                     guint8 y,
                                     PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	gboolean result = FALSE;
	Player _tmp0_;
	PossibleMove _tmp1_ = {0};
	gboolean _tmp2_;
#line 250 "../src/game.vala"
	_tmp0_ = (*self).current_color;
#line 250 "../src/game.vala"
	_tmp2_ = game_state_struct_place_tile (&(*self), x, y, _tmp0_, &_tmp1_);
#line 250 "../src/game.vala"
	_vala_move = _tmp1_;
#line 250 "../src/game.vala"
	result = _tmp2_;
#line 250 "../src/game.vala"
	if (move) {
#line 250 "../src/game.vala"
		*move = _vala_move;
#line 1554 "game.c"
	}
#line 250 "../src/game.vala"
	return result;
#line 1558 "game.c"
}

static inline gboolean
game_state_struct_is_unplayable_basic (GameStateStruct *self,
                                       guint8 x,
                                       guint8 y)
{
	gboolean result = FALSE;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	guint8 _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	guint8 _tmp3_;
	Player* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	Player _tmp5_;
#line 255 "../src/game.vala"
	_tmp0_ = (*self).empty_neighbors;
#line 255 "../src/game.vala"
	_tmp0__length1 = (*self).empty_neighbors_length1;
#line 255 "../src/game.vala"
	_tmp0__length2 = (*self).empty_neighbors_length2;
#line 255 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 255 "../src/game.vala"
	_tmp2_ = (*self).neighbor_tiles;
#line 255 "../src/game.vala"
	_tmp2__length1 = (*self).neighbor_tiles_length1;
#line 255 "../src/game.vala"
	_tmp2__length2 = (*self).neighbor_tiles_length2;
#line 255 "../src/game.vala"
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
#line 255 "../src/game.vala"
	if (_tmp1_ == _tmp3_) {
#line 256 "../src/game.vala"
		result = TRUE;
#line 256 "../src/game.vala"
		return result;
#line 1601 "game.c"
	}
#line 257 "../src/game.vala"
	_tmp4_ = (*self).tiles;
#line 257 "../src/game.vala"
	_tmp4__length1 = (*self).tiles_length1;
#line 257 "../src/game.vala"
	_tmp4__length2 = (*self).tiles_length2;
#line 257 "../src/game.vala"
	_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
#line 257 "../src/game.vala"
	if (_tmp5_ != PLAYER_NONE) {
#line 258 "../src/game.vala"
		result = TRUE;
#line 258 "../src/game.vala"
		return result;
#line 1617 "game.c"
	}
#line 259 "../src/game.vala"
	result = FALSE;
#line 259 "../src/game.vala"
	return result;
#line 1623 "game.c"
}

static inline gboolean
game_state_struct_place_tile (GameStateStruct *self,
                              guint8 x,
                              guint8 y,
                              Player color,
                              PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	gboolean result = FALSE;
	PossibleMove _tmp0_;
	PossibleMove _tmp1_;
	PossibleMove _tmp2_;
	PossibleMove _tmp3_;
	PossibleMove _tmp4_;
	PossibleMove _tmp5_;
	PossibleMove _tmp6_;
	PossibleMove _tmp7_;
	PossibleMove _tmp8_;
#line 265 "../src/game.vala"
	possible_move_init (&_vala_move, x, y);
#line 267 "../src/game.vala"
	if (game_state_struct_is_unplayable_basic (&(*self), x, y)) {
#line 268 "../src/game.vala"
		result = FALSE;
#line 268 "../src/game.vala"
		if (move) {
#line 268 "../src/game.vala"
			*move = _vala_move;
#line 1654 "game.c"
		}
#line 268 "../src/game.vala"
		return result;
#line 1658 "game.c"
	}
#line 270 "../src/game.vala"
	_vala_move.n_tiles_n = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) -1);
#line 271 "../src/game.vala"
	_vala_move.n_tiles_ne = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) -1);
#line 272 "../src/game.vala"
	_vala_move.n_tiles_e = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 0);
#line 273 "../src/game.vala"
	_vala_move.n_tiles_se = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 1);
#line 274 "../src/game.vala"
	_vala_move.n_tiles_s = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) 1);
#line 275 "../src/game.vala"
	_vala_move.n_tiles_so = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 1);
#line 276 "../src/game.vala"
	_vala_move.n_tiles_o = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 0);
#line 277 "../src/game.vala"
	_vala_move.n_tiles_no = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) -1);
#line 279 "../src/game.vala"
	_tmp0_ = _vala_move;
#line 279 "../src/game.vala"
	_tmp1_ = _vala_move;
#line 279 "../src/game.vala"
	_tmp2_ = _vala_move;
#line 279 "../src/game.vala"
	_tmp3_ = _vala_move;
#line 279 "../src/game.vala"
	_tmp4_ = _vala_move;
#line 279 "../src/game.vala"
	_tmp5_ = _vala_move;
#line 279 "../src/game.vala"
	_tmp6_ = _vala_move;
#line 279 "../src/game.vala"
	_tmp7_ = _vala_move;
#line 279 "../src/game.vala"
	_vala_move.n_tiles = ((((((_tmp0_.n_tiles_n + _tmp1_.n_tiles_ne) + _tmp2_.n_tiles_e) + _tmp3_.n_tiles_se) + _tmp4_.n_tiles_s) + _tmp5_.n_tiles_so) + _tmp6_.n_tiles_o) + _tmp7_.n_tiles_no;
#line 283 "../src/game.vala"
	_tmp8_ = _vala_move;
#line 283 "../src/game.vala"
	result = ((gint) _tmp8_.n_tiles) != 0;
#line 283 "../src/game.vala"
	if (move) {
#line 283 "../src/game.vala"
		*move = _vala_move;
#line 1702 "game.c"
	}
#line 283 "../src/game.vala"
	return result;
#line 1706 "game.c"
}

/**
     * can_place:
     * @x: the x coordinate of the tile to test
     * @y: the y coordinate of the tile to test
     * @color: the player color to test
     *
     * You should test is_unplayable_basic() before launching this.
     *
     * This method is faster than place_tile(), as it returns early
     * when some turnable tiles are found in one of the directions.
     *
     * Returns: %true if the given @color can be play there
     */
static inline gboolean
game_state_struct_can_place (GameStateStruct *self,
                             guint8 x,
                             guint8 y,
                             Player color)
{
	gboolean result = FALSE;
#line 302 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) -1)) > 0) {
#line 302 "../src/game.vala"
		result = TRUE;
#line 302 "../src/game.vala"
		return result;
#line 1735 "game.c"
	}
#line 303 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 1)) > 0) {
#line 303 "../src/game.vala"
		result = TRUE;
#line 303 "../src/game.vala"
		return result;
#line 1743 "game.c"
	}
#line 304 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 1)) > 0) {
#line 304 "../src/game.vala"
		result = TRUE;
#line 304 "../src/game.vala"
		return result;
#line 1751 "game.c"
	}
#line 305 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) -1)) > 0) {
#line 305 "../src/game.vala"
		result = TRUE;
#line 305 "../src/game.vala"
		return result;
#line 1759 "game.c"
	}
#line 306 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 0)) > 0) {
#line 306 "../src/game.vala"
		result = TRUE;
#line 306 "../src/game.vala"
		return result;
#line 1767 "game.c"
	}
#line 307 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 0)) > 0) {
#line 307 "../src/game.vala"
		result = TRUE;
#line 307 "../src/game.vala"
		return result;
#line 1775 "game.c"
	}
#line 308 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) 1)) > 0) {
#line 308 "../src/game.vala"
		result = TRUE;
#line 308 "../src/game.vala"
		return result;
#line 1783 "game.c"
	}
#line 309 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) -1)) > 0) {
#line 309 "../src/game.vala"
		result = TRUE;
#line 309 "../src/game.vala"
		return result;
#line 1791 "game.c"
	}
#line 310 "../src/game.vala"
	result = FALSE;
#line 310 "../src/game.vala"
	return result;
#line 1797 "game.c"
}

/**
     * can_flip_tiles:
     * @x: the x coordinate to start with
     * @y: the y coordinate to start with
     * @color: the player color to test
     * @x_step: the step on the x direction, %1, %0 or %-1
     * @y_step: the step on the y direction, %1, %0 or %-1
     *
     * Returns: the number of turnable tiles in the given direction
     */
static inline guint8
game_state_struct_can_flip_tiles (GameStateStruct *self,
                                  guint8 x,
                                  guint8 y,
                                  Player color,
                                  gint8 x_step,
                                  gint8 y_step)
{
	guint8 result = 0U;
	Player enemy = 0;
	gint8 enemy_count = 0;
	gboolean is_valid_location = FALSE;
	gint8 xt = 0;
	gint8 yt = 0;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
#line 325 "../src/game.vala"
	enemy = player_flip_color (color);
#line 328 "../src/game.vala"
	enemy_count = (gint8) -1;
#line 329 "../src/game.vala"
	is_valid_location = FALSE;
#line 330 "../src/game.vala"
	xt = (gint8) x;
#line 331 "../src/game.vala"
	yt = (gint8) y;
#line 1836 "game.c"
	{
		gboolean _tmp0_ = FALSE;
#line 332 "../src/game.vala"
		_tmp0_ = TRUE;
#line 332 "../src/game.vala"
		while (TRUE) {
#line 1843 "game.c"
			gint8 _tmp5_;
#line 332 "../src/game.vala"
			if (!_tmp0_) {
#line 1847 "game.c"
				gboolean _tmp1_ = FALSE;
#line 338 "../src/game.vala"
				if (is_valid_location) {
#line 1851 "game.c"
					Player* _tmp2_;
					gint _tmp2__length1;
					gint _tmp2__length2;
					Player _tmp3_;
					Player _tmp4_;
#line 338 "../src/game.vala"
					_tmp2_ = (*self).tiles;
#line 338 "../src/game.vala"
					_tmp2__length1 = (*self).tiles_length1;
#line 338 "../src/game.vala"
					_tmp2__length2 = (*self).tiles_length2;
#line 338 "../src/game.vala"
					_tmp3_ = _tmp2_[(xt * _tmp2__length2) + yt];
#line 338 "../src/game.vala"
					_tmp4_ = enemy;
#line 338 "../src/game.vala"
					_tmp1_ = _tmp3_ == _tmp4_;
#line 1869 "game.c"
				} else {
#line 338 "../src/game.vala"
					_tmp1_ = FALSE;
#line 1873 "game.c"
				}
#line 338 "../src/game.vala"
				if (!_tmp1_) {
#line 338 "../src/game.vala"
					break;
#line 1879 "game.c"
				}
			}
#line 332 "../src/game.vala"
			_tmp0_ = FALSE;
#line 333 "../src/game.vala"
			_tmp5_ = enemy_count;
#line 333 "../src/game.vala"
			enemy_count = _tmp5_ + 1;
#line 334 "../src/game.vala"
			xt += x_step;
#line 335 "../src/game.vala"
			yt += y_step;
#line 336 "../src/game.vala"
			is_valid_location = game_state_struct_is_valid_location_signed (&(*self), xt, yt);
#line 1894 "game.c"
		}
	}
#line 341 "../src/game.vala"
	if (((gint) enemy_count) <= 0) {
#line 341 "../src/game.vala"
		_tmp7_ = TRUE;
#line 1901 "game.c"
	} else {
#line 341 "../src/game.vala"
		_tmp7_ = !is_valid_location;
#line 1905 "game.c"
	}
#line 341 "../src/game.vala"
	if (_tmp7_) {
#line 341 "../src/game.vala"
		_tmp6_ = TRUE;
#line 1911 "game.c"
	} else {
		Player* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		Player _tmp9_;
#line 341 "../src/game.vala"
		_tmp8_ = (*self).tiles;
#line 341 "../src/game.vala"
		_tmp8__length1 = (*self).tiles_length1;
#line 341 "../src/game.vala"
		_tmp8__length2 = (*self).tiles_length2;
#line 341 "../src/game.vala"
		_tmp9_ = _tmp8_[(xt * _tmp8__length2) + yt];
#line 341 "../src/game.vala"
		_tmp6_ = _tmp9_ != color;
#line 1927 "game.c"
	}
#line 341 "../src/game.vala"
	if (_tmp6_) {
#line 342 "../src/game.vala"
		result = (guint8) 0;
#line 342 "../src/game.vala"
		return result;
#line 1935 "game.c"
	}
#line 344 "../src/game.vala"
	result = (guint8) enemy_count;
#line 344 "../src/game.vala"
	return result;
#line 1941 "game.c"
}

guint8
game_state_struct_get_empty_neighbors (GameStateStruct *self,
                                       guint8 x,
                                       guint8 y)
{
	guint8 result = 0U;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	guint8 _tmp1_;
#line 355 "../src/game.vala"
	_tmp0_ = (*self).empty_neighbors;
#line 355 "../src/game.vala"
	_tmp0__length1 = (*self).empty_neighbors_length1;
#line 355 "../src/game.vala"
	_tmp0__length2 = (*self).empty_neighbors_length2;
#line 355 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 355 "../src/game.vala"
	result = _tmp1_;
#line 355 "../src/game.vala"
	return result;
#line 1966 "game.c"
}

static inline void
game_state_struct_init_empty_neighbors (GameStateStruct *self)
{
	guint8* _tmp0_;
	gint8 _size = 0;
	gint8 xmm = 0;
	gint8 ymm = 0;
	gint8 xpp = 0;
	gint8 ypp = 0;
	gboolean xmm_is_valid = FALSE;
	gboolean xpp_is_valid = FALSE;
#line 360 "../src/game.vala"
	_tmp0_ = g_new0 (guint8, (*self).size * (*self).size);
#line 360 "../src/game.vala"
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
#line 360 "../src/game.vala"
	(*self).empty_neighbors = _tmp0_;
#line 360 "../src/game.vala"
	(*self).empty_neighbors_length1 = (*self).size;
#line 360 "../src/game.vala"
	(*self).empty_neighbors_length2 = (*self).size;
#line 361 "../src/game.vala"
	_size = (gint8) (*self).size;
#line 1992 "game.c"
	{
		gint8 x = 0;
#line 367 "../src/game.vala"
		x = (gint8) 0;
#line 1997 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 367 "../src/game.vala"
			_tmp1_ = TRUE;
#line 367 "../src/game.vala"
			while (TRUE) {
#line 367 "../src/game.vala"
				if (!_tmp1_) {
#line 2006 "game.c"
					gint8 _tmp2_;
#line 367 "../src/game.vala"
					_tmp2_ = x;
#line 367 "../src/game.vala"
					x = _tmp2_ + 1;
#line 2012 "game.c"
				}
#line 367 "../src/game.vala"
				_tmp1_ = FALSE;
#line 367 "../src/game.vala"
				if (!(x < _size)) {
#line 367 "../src/game.vala"
					break;
#line 2020 "game.c"
				}
#line 369 "../src/game.vala"
				xmm = (gint8) (x - 1);
#line 370 "../src/game.vala"
				xpp = (gint8) (x + 1);
#line 371 "../src/game.vala"
				xmm_is_valid = ((gint) xmm) >= 0;
#line 372 "../src/game.vala"
				xpp_is_valid = ((guint8) xpp) < (*self).size;
#line 2030 "game.c"
				{
					gint8 y = 0;
#line 374 "../src/game.vala"
					y = (gint8) 0;
#line 2035 "game.c"
					{
						gboolean _tmp3_ = FALSE;
#line 374 "../src/game.vala"
						_tmp3_ = TRUE;
#line 374 "../src/game.vala"
						while (TRUE) {
#line 2042 "game.c"
							guint8 empty_neighbors_x_y = 0U;
#line 374 "../src/game.vala"
							if (!_tmp3_) {
#line 2046 "game.c"
								gint8 _tmp4_;
#line 374 "../src/game.vala"
								_tmp4_ = y;
#line 374 "../src/game.vala"
								y = _tmp4_ + 1;
#line 2052 "game.c"
							}
#line 374 "../src/game.vala"
							_tmp3_ = FALSE;
#line 374 "../src/game.vala"
							if (!(y < _size)) {
#line 374 "../src/game.vala"
								break;
#line 2060 "game.c"
							}
#line 376 "../src/game.vala"
							ymm = (gint8) (y - 1);
#line 377 "../src/game.vala"
							ypp = (gint8) (y + 1);
#line 379 "../src/game.vala"
							empty_neighbors_x_y = game_state_struct_is_empty (&(*self), x, ymm) + game_state_struct_is_empty (&(*self), x, ypp);
#line 381 "../src/game.vala"
							if (xmm_is_valid) {
#line 382 "../src/game.vala"
								empty_neighbors_x_y += (game_state_struct_is_empty (&(*self), xmm, y) + game_state_struct_is_empty (&(*self), xmm, ymm)) + game_state_struct_is_empty (&(*self), xmm, ypp);
#line 2072 "game.c"
							}
#line 385 "../src/game.vala"
							if (xpp_is_valid) {
#line 386 "../src/game.vala"
								empty_neighbors_x_y += (game_state_struct_is_empty (&(*self), xpp, y) + game_state_struct_is_empty (&(*self), xpp, ymm)) + game_state_struct_is_empty (&(*self), xpp, ypp);
#line 2078 "game.c"
							}
#line 390 "../src/game.vala"
							(*self).empty_neighbors[(x * (*self).empty_neighbors_length2) + y] = empty_neighbors_x_y;
#line 2082 "game.c"
						}
					}
				}
			}
		}
	}
}

static inline guint8
game_state_struct_is_empty (GameStateStruct *self,
                            gint8 x,
                            gint8 y)
{
	guint8 result = 0U;
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
#line 397 "../src/game.vala"
	if (!game_state_struct_is_valid_location_signed (&(*self), x, y)) {
#line 398 "../src/game.vala"
		result = (guint8) 0;
#line 398 "../src/game.vala"
		return result;
#line 2107 "game.c"
	}
#line 399 "../src/game.vala"
	_tmp0_ = (*self).tiles;
#line 399 "../src/game.vala"
	_tmp0__length1 = (*self).tiles_length1;
#line 399 "../src/game.vala"
	_tmp0__length2 = (*self).tiles_length2;
#line 399 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 399 "../src/game.vala"
	if (_tmp1_ != PLAYER_NONE) {
#line 400 "../src/game.vala"
		result = (guint8) 0;
#line 400 "../src/game.vala"
		return result;
#line 2123 "game.c"
	}
#line 402 "../src/game.vala"
	result = (guint8) 1;
#line 402 "../src/game.vala"
	return result;
#line 2129 "game.c"
}

static inline void
game_state_struct_update_empty_neighbors (GameStateStruct *self,
                                          guint8 x,
                                          guint8 y)
{
	gint8 xmm = 0;
	gint8 ymm = 0;
	gint8 xpp = 0;
	gint8 ypp = 0;
	gboolean ymm_is_valid = FALSE;
	gboolean ypp_is_valid = FALSE;
#line 407 "../src/game.vala"
	xmm = (gint8) (((gint8) x) - 1);
#line 408 "../src/game.vala"
	ymm = (gint8) (((gint8) y) - 1);
#line 409 "../src/game.vala"
	xpp = (gint8) (xmm + 2);
#line 410 "../src/game.vala"
	ypp = (gint8) (ymm + 2);
#line 412 "../src/game.vala"
	ymm_is_valid = ((gint) ymm) >= 0;
#line 413 "../src/game.vala"
	ypp_is_valid = ((guint8) ypp) < (*self).size;
#line 415 "../src/game.vala"
	if (((gint) xmm) >= 0) {
#line 417 "../src/game.vala"
		(*self).empty_neighbors[(xmm * (*self).empty_neighbors_length2) + y] -= (guint8) 1;
#line 418 "../src/game.vala"
		if (ymm_is_valid) {
#line 418 "../src/game.vala"
			(*self).empty_neighbors[(xmm * (*self).empty_neighbors_length2) + ymm] -= (guint8) 1;
#line 2163 "game.c"
		}
#line 419 "../src/game.vala"
		if (ypp_is_valid) {
#line 419 "../src/game.vala"
			(*self).empty_neighbors[(xmm * (*self).empty_neighbors_length2) + ypp] -= (guint8) 1;
#line 2169 "game.c"
		}
	}
#line 421 "../src/game.vala"
	if (ymm_is_valid) {
#line 421 "../src/game.vala"
		(*self).empty_neighbors[(x * (*self).empty_neighbors_length2) + ymm] -= (guint8) 1;
#line 2176 "game.c"
	}
#line 422 "../src/game.vala"
	if (ypp_is_valid) {
#line 422 "../src/game.vala"
		(*self).empty_neighbors[(x * (*self).empty_neighbors_length2) + ypp] -= (guint8) 1;
#line 2182 "game.c"
	}
#line 423 "../src/game.vala"
	if (((guint8) xpp) < (*self).size) {
#line 425 "../src/game.vala"
		(*self).empty_neighbors[(xpp * (*self).empty_neighbors_length2) + y] -= (guint8) 1;
#line 426 "../src/game.vala"
		if (ymm_is_valid) {
#line 426 "../src/game.vala"
			(*self).empty_neighbors[(xpp * (*self).empty_neighbors_length2) + ymm] -= (guint8) 1;
#line 2192 "game.c"
		}
#line 427 "../src/game.vala"
		if (ypp_is_valid) {
#line 427 "../src/game.vala"
			(*self).empty_neighbors[(xpp * (*self).empty_neighbors_length2) + ypp] -= (guint8) 1;
#line 2198 "game.c"
		}
	}
}

static Player*
_vala_array_dup7 (Player* self,
                  int length)
{
#line 23 "../src/game.vala"
	return g_memdup (self, length * sizeof (Player));
#line 2209 "game.c"
}

static guint8*
_vala_array_dup8 (guint8* self,
                  int length)
{
#line 23 "../src/game.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 2218 "game.c"
}

void
game_state_struct_copy (const GameStateStruct* self,
                        GameStateStruct* dest)
{
	Player _tmp0_;
	Player _tmp1_;
	Player* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	Player* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	guint8* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	guint8* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	guint8* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
#line 23 "../src/game.vala"
	_tmp0_ = (*self).current_color;
#line 23 "../src/game.vala"
	(*dest).current_color = _tmp0_;
#line 23 "../src/game.vala"
	_tmp1_ = (*self).opponent_color;
#line 23 "../src/game.vala"
	(*dest).opponent_color = _tmp1_;
#line 23 "../src/game.vala"
	(*dest).size = (*self).size;
#line 23 "../src/game.vala"
	(*dest).n_current_tiles = (*self).n_current_tiles;
#line 23 "../src/game.vala"
	(*dest).n_opponent_tiles = (*self).n_opponent_tiles;
#line 23 "../src/game.vala"
	(*dest).n_tiles = (*self).n_tiles;
#line 23 "../src/game.vala"
	(*dest).current_player_can_move = (*self).current_player_can_move;
#line 23 "../src/game.vala"
	(*dest).is_complete = (*self).is_complete;
#line 23 "../src/game.vala"
	_tmp2_ = (*self).tiles;
#line 23 "../src/game.vala"
	_tmp2__length1 = (*self).tiles_length1;
#line 23 "../src/game.vala"
	_tmp2__length2 = (*self).tiles_length2;
#line 23 "../src/game.vala"
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup7 (_tmp2_, _tmp2__length1 * _tmp2__length2) : ((gpointer) _tmp2_);
#line 23 "../src/game.vala"
	_tmp3__length1 = _tmp2__length1;
#line 23 "../src/game.vala"
	_tmp3__length2 = _tmp2__length2;
#line 23 "../src/game.vala"
	(*dest).tiles = (g_free ((*dest).tiles), NULL);
#line 23 "../src/game.vala"
	(*dest).tiles = _tmp3_;
#line 23 "../src/game.vala"
	(*dest).tiles_length1 = _tmp3__length1;
#line 23 "../src/game.vala"
	(*dest).tiles_length2 = _tmp3__length2;
#line 23 "../src/game.vala"
	_tmp4_ = (*self).neighbor_tiles;
#line 23 "../src/game.vala"
	_tmp4__length1 = (*self).neighbor_tiles_length1;
#line 23 "../src/game.vala"
	_tmp4__length2 = (*self).neighbor_tiles_length2;
#line 23 "../src/game.vala"
	(*dest).neighbor_tiles = _tmp4_;
#line 23 "../src/game.vala"
	(*dest).neighbor_tiles_length1 = _tmp4__length1;
#line 23 "../src/game.vala"
	(*dest).neighbor_tiles_length2 = _tmp4__length2;
#line 23 "../src/game.vala"
	(*dest).x_saved = (*self).x_saved;
#line 23 "../src/game.vala"
	(*dest).y_saved = (*self).y_saved;
#line 23 "../src/game.vala"
	_tmp5_ = (*self).empty_neighbors;
#line 23 "../src/game.vala"
	_tmp5__length1 = (*self).empty_neighbors_length1;
#line 23 "../src/game.vala"
	_tmp5__length2 = (*self).empty_neighbors_length2;
#line 23 "../src/game.vala"
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup8 (_tmp5_, _tmp5__length1 * _tmp5__length2) : ((gpointer) _tmp5_);
#line 23 "../src/game.vala"
	_tmp6__length1 = _tmp5__length1;
#line 23 "../src/game.vala"
	_tmp6__length2 = _tmp5__length2;
#line 23 "../src/game.vala"
	(*dest).empty_neighbors = (g_free ((*dest).empty_neighbors), NULL);
#line 23 "../src/game.vala"
	(*dest).empty_neighbors = _tmp6_;
#line 23 "../src/game.vala"
	(*dest).empty_neighbors_length1 = _tmp6__length1;
#line 23 "../src/game.vala"
	(*dest).empty_neighbors_length2 = _tmp6__length2;
#line 2318 "game.c"
}

void
game_state_struct_destroy (GameStateStruct* self)
{
#line 36 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 351 "../src/game.vala"
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
#line 2328 "game.c"
}

GameStateStruct*
game_state_struct_dup (const GameStateStruct* self)
{
	GameStateStruct* dup;
#line 23 "../src/game.vala"
	dup = g_new0 (GameStateStruct, 1);
#line 23 "../src/game.vala"
	game_state_struct_copy (self, dup);
#line 23 "../src/game.vala"
	return dup;
#line 2341 "game.c"
}

void
game_state_struct_free (GameStateStruct* self)
{
#line 23 "../src/game.vala"
	game_state_struct_destroy (self);
#line 23 "../src/game.vala"
	g_free (self);
#line 2351 "game.c"
}

GType
game_state_struct_get_type (void)
{
	static volatile gsize game_state_struct_type_id__volatile = 0;
	if (g_once_init_enter (&game_state_struct_type_id__volatile)) {
		GType game_state_struct_type_id;
		game_state_struct_type_id = g_boxed_type_register_static ("GameStateStruct", (GBoxedCopyFunc) game_state_struct_dup, (GBoxedFreeFunc) game_state_struct_free);
		g_once_init_leave (&game_state_struct_type_id__volatile, game_state_struct_type_id);
	}
	return game_state_struct_type_id__volatile;
}

static inline gpointer
game_state_object_get_instance_private (GameStateObject* self)
{
	return G_STRUCT_MEMBER_P (self, GameStateObject_private_offset);
}

gchar*
game_state_object_to_string (GameStateObject* self)
{
	gchar* result = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	gchar* _tmp2_;
#line 457 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 459 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 459 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 459 "../src/game.vala"
	_tmp2_ = game_state_struct_to_string (&_tmp1_);
#line 459 "../src/game.vala"
	result = _tmp2_;
#line 459 "../src/game.vala"
	return result;
#line 2391 "game.c"
}

GameStateObject*
game_state_object_construct_copy_and_pass (GType object_type,
                                           GameStateObject* game)
{
	GameStateObject * self = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
#line 466 "../src/game.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 466 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 468 "../src/game.vala"
	game_state_object_get_game_state_struct (game, &_tmp0_);
#line 468 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 468 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 468 "../src/game.vala"
	game_state_struct_init_copy_and_pass (&self->priv->_game_state_struct, &_tmp1_);
#line 466 "../src/game.vala"
	return self;
#line 2415 "game.c"
}

GameStateObject*
game_state_object_new_copy_and_pass (GameStateObject* game)
{
#line 466 "../src/game.vala"
	return game_state_object_construct_copy_and_pass (TYPE_GAME_STATE_OBJECT, game);
#line 2423 "game.c"
}

GameStateObject*
game_state_object_construct_copy_and_move (GType object_type,
                                           GameStateObject* game,
                                           PossibleMove* move)
{
	GameStateObject * self = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	PossibleMove _tmp2_;
#line 471 "../src/game.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 471 "../src/game.vala"
	g_return_val_if_fail (move != NULL, NULL);
#line 471 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 473 "../src/game.vala"
	game_state_object_get_game_state_struct (game, &_tmp0_);
#line 473 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 473 "../src/game.vala"
	_tmp2_ = *move;
#line 473 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 473 "../src/game.vala"
	game_state_struct_init_copy_and_move (&self->priv->_game_state_struct, &_tmp1_, &_tmp2_);
#line 471 "../src/game.vala"
	return self;
#line 2453 "game.c"
}

GameStateObject*
game_state_object_new_copy_and_move (GameStateObject* game,
                                     PossibleMove* move)
{
#line 471 "../src/game.vala"
	return game_state_object_construct_copy_and_move (TYPE_GAME_STATE_OBJECT, game, move);
#line 2462 "game.c"
}

GameStateObject*
game_state_object_construct_from_grid (GType object_type,
                                       guint8 size,
                                       Player* tiles,
                                       gint tiles_length1,
                                       gint tiles_length2,
                                       Player color,
                                       guint8* neighbor_tiles,
                                       gint neighbor_tiles_length1,
                                       gint neighbor_tiles_length2)
{
	GameStateObject * self = NULL;
#line 476 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 478 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 478 "../src/game.vala"
	game_state_struct_init_from_grid (&self->priv->_game_state_struct, size, tiles, tiles_length1, tiles_length2, color, neighbor_tiles, neighbor_tiles_length1, neighbor_tiles_length2);
#line 476 "../src/game.vala"
	return self;
#line 2485 "game.c"
}

GameStateObject*
game_state_object_new_from_grid (guint8 size,
                                 Player* tiles,
                                 gint tiles_length1,
                                 gint tiles_length2,
                                 Player color,
                                 guint8* neighbor_tiles,
                                 gint neighbor_tiles_length1,
                                 gint neighbor_tiles_length2)
{
#line 476 "../src/game.vala"
	return game_state_object_construct_from_grid (TYPE_GAME_STATE_OBJECT, size, tiles, tiles_length1, tiles_length2, color, neighbor_tiles, neighbor_tiles_length1, neighbor_tiles_length2);
#line 2500 "game.c"
}

Player
game_state_object_get_owner (GameStateObject* self,
                             guint8 x,
                             guint8 y)
{
	Player result = 0;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	Player* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	Player _tmp3_;
#line 485 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 488 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 488 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 488 "../src/game.vala"
	_tmp2_ = _tmp1_.tiles;
#line 488 "../src/game.vala"
	_tmp2__length1 = _tmp1_.tiles_length1;
#line 488 "../src/game.vala"
	_tmp2__length2 = _tmp1_.tiles_length2;
#line 488 "../src/game.vala"
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
#line 488 "../src/game.vala"
	result = _tmp3_;
#line 488 "../src/game.vala"
	return result;
#line 2533 "game.c"
}

void
game_state_object_get_possible_moves (GameStateObject* self,
                                      GSList* * moves)
{
	GSList* _vala_moves = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	GSList* _tmp2_ = NULL;
#line 495 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 497 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 497 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 497 "../src/game.vala"
	game_state_struct_get_possible_moves (&_tmp1_, &_tmp2_);
#line 497 "../src/game.vala"
	(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 497 "../src/game.vala"
	_vala_moves = _tmp2_;
#line 495 "../src/game.vala"
	if (moves) {
#line 495 "../src/game.vala"
		*moves = _vala_moves;
#line 2560 "game.c"
	} else {
#line 495 "../src/game.vala"
		(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 2564 "game.c"
	}
}

gboolean
game_state_object_test_placing_tile (GameStateObject* self,
                                     guint8 x,
                                     guint8 y,
                                     PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	gboolean result = FALSE;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	PossibleMove _tmp2_ = {0};
	gboolean _tmp3_;
#line 500 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 502 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 502 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 502 "../src/game.vala"
	_tmp3_ = game_state_struct_test_placing_tile (&_tmp1_, x, y, &_tmp2_);
#line 502 "../src/game.vala"
	_vala_move = _tmp2_;
#line 502 "../src/game.vala"
	result = _tmp3_;
#line 502 "../src/game.vala"
	if (move) {
#line 502 "../src/game.vala"
		*move = _vala_move;
#line 2596 "game.c"
	}
#line 502 "../src/game.vala"
	return result;
#line 2600 "game.c"
}

GameStateObject*
game_state_object_construct (GType object_type)
{
	GameStateObject * self = NULL;
#line 432 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 432 "../src/game.vala"
	return self;
#line 2611 "game.c"
}

GameStateObject*
game_state_object_new (void)
{
#line 432 "../src/game.vala"
	return game_state_object_construct (TYPE_GAME_STATE_OBJECT);
#line 2619 "game.c"
}

void
game_state_object_get_game_state_struct (GameStateObject* self,
                                         GameStateStruct * result)
{
	GameStateStruct _tmp0_;
#line 435 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 435 "../src/game.vala"
	_tmp0_ = self->priv->_game_state_struct;
#line 435 "../src/game.vala"
	*result = _tmp0_;
#line 435 "../src/game.vala"
	return;
#line 2635 "game.c"
}

Player
game_state_object_get_current_color (GameStateObject* self)
{
	Player result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	Player _tmp2_;
#line 437 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 437 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 437 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 437 "../src/game.vala"
	_tmp2_ = _tmp1_.current_color;
#line 437 "../src/game.vala"
	result = _tmp2_;
#line 437 "../src/game.vala"
	return result;
#line 2657 "game.c"
}

guint8
game_state_object_get_n_light_tiles (GameStateObject* self)
{
	guint8 result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	Player _tmp2_;
	GameStateStruct _tmp5_ = {0};
	GameStateStruct _tmp6_;
#line 439 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 440 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 440 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 440 "../src/game.vala"
	_tmp2_ = _tmp1_.current_color;
#line 440 "../src/game.vala"
	if (_tmp2_ == PLAYER_LIGHT) {
#line 2679 "game.c"
		GameStateStruct _tmp3_ = {0};
		GameStateStruct _tmp4_;
#line 441 "../src/game.vala"
		game_state_object_get_game_state_struct (self, &_tmp3_);
#line 441 "../src/game.vala"
		_tmp4_ = _tmp3_;
#line 441 "../src/game.vala"
		result = _tmp4_.n_current_tiles;
#line 441 "../src/game.vala"
		return result;
#line 2690 "game.c"
	}
#line 443 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp5_);
#line 443 "../src/game.vala"
	_tmp6_ = _tmp5_;
#line 443 "../src/game.vala"
	result = _tmp6_.n_opponent_tiles;
#line 443 "../src/game.vala"
	return result;
#line 2700 "game.c"
}

guint8
game_state_object_get_n_dark_tiles (GameStateObject* self)
{
	guint8 result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	Player _tmp2_;
	GameStateStruct _tmp5_ = {0};
	GameStateStruct _tmp6_;
#line 446 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 447 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 447 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 447 "../src/game.vala"
	_tmp2_ = _tmp1_.current_color;
#line 447 "../src/game.vala"
	if (_tmp2_ == PLAYER_DARK) {
#line 2722 "game.c"
		GameStateStruct _tmp3_ = {0};
		GameStateStruct _tmp4_;
#line 448 "../src/game.vala"
		game_state_object_get_game_state_struct (self, &_tmp3_);
#line 448 "../src/game.vala"
		_tmp4_ = _tmp3_;
#line 448 "../src/game.vala"
		result = _tmp4_.n_current_tiles;
#line 448 "../src/game.vala"
		return result;
#line 2733 "game.c"
	}
#line 450 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp5_);
#line 450 "../src/game.vala"
	_tmp6_ = _tmp5_;
#line 450 "../src/game.vala"
	result = _tmp6_.n_opponent_tiles;
#line 450 "../src/game.vala"
	return result;
#line 2743 "game.c"
}

gboolean
game_state_object_get_current_player_can_move (GameStateObject* self)
{
	gboolean result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
#line 454 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 454 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 454 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 454 "../src/game.vala"
	result = _tmp1_.current_player_can_move;
#line 454 "../src/game.vala"
	return result;
#line 2762 "game.c"
}

gboolean
game_state_object_get_is_complete (GameStateObject* self)
{
	gboolean result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
#line 455 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 455 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 455 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 455 "../src/game.vala"
	result = _tmp1_.is_complete;
#line 455 "../src/game.vala"
	return result;
#line 2781 "game.c"
}

static void
game_state_object_class_init (GameStateObjectClass * klass,
                              gpointer klass_data)
{
#line 432 "../src/game.vala"
	game_state_object_parent_class = g_type_class_peek_parent (klass);
#line 432 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &GameStateObject_private_offset);
#line 432 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_state_object_get_property;
#line 432 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_state_object_finalize;
#line 432 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY] = g_param_spec_boxed ("game-state-struct", "game-state-struct", "game-state-struct", TYPE_GAME_STATE_STRUCT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 432 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY] = g_param_spec_enum ("current-color", "current-color", "current-color", TYPE_PLAYER, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 432 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY] = g_param_spec_uchar ("n-light-tiles", "n-light-tiles", "n-light-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 432 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY] = g_param_spec_uchar ("n-dark-tiles", "n-dark-tiles", "n-dark-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 432 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY] = g_param_spec_boolean ("current-player-can-move", "current-player-can-move", "current-player-can-move", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 432 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY] = g_param_spec_boolean ("is-complete", "is-complete", "is-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 2808 "game.c"
}

static void
game_state_object_instance_init (GameStateObject * self,
                                 gpointer klass)
{
#line 432 "../src/game.vala"
	self->priv = game_state_object_get_instance_private (self);
#line 2817 "game.c"
}

static void
game_state_object_finalize (GObject * obj)
{
	GameStateObject * self;
#line 432 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_STATE_OBJECT, GameStateObject);
#line 434 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 432 "../src/game.vala"
	G_OBJECT_CLASS (game_state_object_parent_class)->finalize (obj);
#line 2830 "game.c"
}

GType
game_state_object_get_type (void)
{
	static volatile gsize game_state_object_type_id__volatile = 0;
	if (g_once_init_enter (&game_state_object_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameStateObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_state_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameStateObject), 0, (GInstanceInitFunc) game_state_object_instance_init, NULL };
		GType game_state_object_type_id;
		game_state_object_type_id = g_type_register_static (G_TYPE_OBJECT, "GameStateObject", &g_define_type_info, 0);
		GameStateObject_private_offset = g_type_add_instance_private (game_state_object_type_id, sizeof (GameStateObjectPrivate));
		g_once_init_leave (&game_state_object_type_id__volatile, game_state_object_type_id);
	}
	return game_state_object_type_id__volatile;
}

static void
_vala_game_state_object_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	GameStateObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_STATE_OBJECT, GameStateObject);
#line 432 "../src/game.vala"
	switch (property_id) {
#line 432 "../src/game.vala"
		case GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY:
#line 2859 "game.c"
		{
			GameStateStruct boxed;
#line 432 "../src/game.vala"
			game_state_object_get_game_state_struct (self, &boxed);
#line 432 "../src/game.vala"
			g_value_set_boxed (value, &boxed);
#line 2866 "game.c"
		}
#line 432 "../src/game.vala"
		break;
#line 432 "../src/game.vala"
		case GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY:
#line 432 "../src/game.vala"
		g_value_set_enum (value, game_state_object_get_current_color (self));
#line 432 "../src/game.vala"
		break;
#line 432 "../src/game.vala"
		case GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY:
#line 432 "../src/game.vala"
		g_value_set_uchar (value, game_state_object_get_n_light_tiles (self));
#line 432 "../src/game.vala"
		break;
#line 432 "../src/game.vala"
		case GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY:
#line 432 "../src/game.vala"
		g_value_set_uchar (value, game_state_object_get_n_dark_tiles (self));
#line 432 "../src/game.vala"
		break;
#line 432 "../src/game.vala"
		case GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY:
#line 432 "../src/game.vala"
		g_value_set_boolean (value, game_state_object_get_current_player_can_move (self));
#line 432 "../src/game.vala"
		break;
#line 432 "../src/game.vala"
		case GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY:
#line 432 "../src/game.vala"
		g_value_set_boolean (value, game_state_object_get_is_complete (self));
#line 432 "../src/game.vala"
		break;
#line 2900 "game.c"
		default:
#line 432 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 432 "../src/game.vala"
		break;
#line 2906 "game.c"
	}
}

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

Game*
game_construct (GType object_type,
                gboolean _alternative_start,
                guint8 _size)
{
	Game * self = NULL;
	gboolean even_board = FALSE;
	Player* tiles = NULL;
	Player* _tmp0_;
	gint tiles_length1;
	gint tiles_length2;
	guint8 _initial_number_of_tiles = 0U;
	guint8* _neighbor_tiles = NULL;
	gint _neighbor_tiles_length1 = 0;
	gint _neighbor_tiles_length2 = 0;
	guint8* _tmp23_ = NULL;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	GameStateObject* _current_state = NULL;
	Player* _tmp26_;
	gint _tmp26__length1;
	gint _tmp26__length2;
	guint8* _tmp27_;
	gint _tmp27__length1;
	gint _tmp27__length2;
	GameStateObject* _tmp28_;
	guint8* _tmp29_;
	gint _tmp29__length1;
	gint _tmp29__length2;
#line 538 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) >= 4, "_size >= 4", NULL);
#line 538 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) <= 16, "_size <= 16", NULL);
#line 542 "../src/game.vala"
	even_board = (_size % 2) == 0;
#line 544 "../src/game.vala"
	_tmp0_ = g_new0 (Player, _size * _size);
#line 544 "../src/game.vala"
	tiles = _tmp0_;
#line 544 "../src/game.vala"
	tiles_length1 = _size;
#line 544 "../src/game.vala"
	tiles_length2 = _size;
#line 2959 "game.c"
	{
		guint8 x = 0U;
#line 546 "../src/game.vala"
		x = (guint8) 0;
#line 2964 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 546 "../src/game.vala"
			_tmp1_ = TRUE;
#line 546 "../src/game.vala"
			while (TRUE) {
#line 546 "../src/game.vala"
				if (!_tmp1_) {
#line 2973 "game.c"
					guint8 _tmp2_;
#line 546 "../src/game.vala"
					_tmp2_ = x;
#line 546 "../src/game.vala"
					x = _tmp2_ + 1;
#line 2979 "game.c"
				}
#line 546 "../src/game.vala"
				_tmp1_ = FALSE;
#line 546 "../src/game.vala"
				if (!(x < _size)) {
#line 546 "../src/game.vala"
					break;
#line 2987 "game.c"
				}
				{
					guint8 y = 0U;
#line 547 "../src/game.vala"
					y = (guint8) 0;
#line 2993 "game.c"
					{
						gboolean _tmp3_ = FALSE;
#line 547 "../src/game.vala"
						_tmp3_ = TRUE;
#line 547 "../src/game.vala"
						while (TRUE) {
#line 3000 "game.c"
							Player* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
#line 547 "../src/game.vala"
							if (!_tmp3_) {
#line 3006 "game.c"
								guint8 _tmp4_;
#line 547 "../src/game.vala"
								_tmp4_ = y;
#line 547 "../src/game.vala"
								y = _tmp4_ + 1;
#line 3012 "game.c"
							}
#line 547 "../src/game.vala"
							_tmp3_ = FALSE;
#line 547 "../src/game.vala"
							if (!(y < _size)) {
#line 547 "../src/game.vala"
								break;
#line 3020 "game.c"
							}
#line 548 "../src/game.vala"
							_tmp5_ = tiles;
#line 548 "../src/game.vala"
							_tmp5__length1 = tiles_length1;
#line 548 "../src/game.vala"
							_tmp5__length2 = tiles_length2;
#line 548 "../src/game.vala"
							_tmp5_[(x * _tmp5__length2) + y] = PLAYER_NONE;
#line 3030 "game.c"
						}
					}
				}
			}
		}
	}
#line 551 "../src/game.vala"
	if (even_board) {
#line 3039 "game.c"
		guint8 half_size = 0U;
		Player _tmp6_ = 0;
		Player* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		Player* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		Player _tmp9_ = 0;
		Player* _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		Player* _tmp11_;
		gint _tmp11__length1;
		gint _tmp11__length2;
#line 554 "../src/game.vala"
		half_size = (guint8) (_size / 2);
#line 555 "../src/game.vala"
		_initial_number_of_tiles = (guint8) 4;
#line 556 "../src/game.vala"
		if (_alternative_start) {
#line 556 "../src/game.vala"
			_tmp6_ = PLAYER_DARK;
#line 3063 "game.c"
		} else {
#line 556 "../src/game.vala"
			_tmp6_ = PLAYER_LIGHT;
#line 3067 "game.c"
		}
#line 556 "../src/game.vala"
		_tmp7_ = tiles;
#line 556 "../src/game.vala"
		_tmp7__length1 = tiles_length1;
#line 556 "../src/game.vala"
		_tmp7__length2 = tiles_length2;
#line 556 "../src/game.vala"
		_tmp7_[((half_size - 1) * _tmp7__length2) + (half_size - 1)] = _tmp6_;
#line 557 "../src/game.vala"
		_tmp8_ = tiles;
#line 557 "../src/game.vala"
		_tmp8__length1 = tiles_length1;
#line 557 "../src/game.vala"
		_tmp8__length2 = tiles_length2;
#line 557 "../src/game.vala"
		_tmp8_[((half_size - 1) * _tmp8__length2) + half_size] = PLAYER_DARK;
#line 558 "../src/game.vala"
		if (_alternative_start) {
#line 558 "../src/game.vala"
			_tmp9_ = PLAYER_LIGHT;
#line 3089 "game.c"
		} else {
#line 558 "../src/game.vala"
			_tmp9_ = PLAYER_DARK;
#line 3093 "game.c"
		}
#line 558 "../src/game.vala"
		_tmp10_ = tiles;
#line 558 "../src/game.vala"
		_tmp10__length1 = tiles_length1;
#line 558 "../src/game.vala"
		_tmp10__length2 = tiles_length2;
#line 558 "../src/game.vala"
		_tmp10_[(half_size * _tmp10__length2) + (half_size - 1)] = _tmp9_;
#line 559 "../src/game.vala"
		_tmp11_ = tiles;
#line 559 "../src/game.vala"
		_tmp11__length1 = tiles_length1;
#line 559 "../src/game.vala"
		_tmp11__length2 = tiles_length2;
#line 559 "../src/game.vala"
		_tmp11_[(half_size * _tmp11__length2) + half_size] = PLAYER_LIGHT;
#line 3111 "game.c"
	} else {
		guint8 mid_board = 0U;
		Player* _tmp12_;
		gint _tmp12__length1;
		gint _tmp12__length2;
		Player _tmp13_ = 0;
		Player* _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		Player _tmp15_ = 0;
		Player* _tmp16_;
		gint _tmp16__length1;
		gint _tmp16__length2;
		Player* _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		Player _tmp18_ = 0;
		Player* _tmp19_;
		gint _tmp19__length1;
		gint _tmp19__length2;
		Player _tmp20_ = 0;
		Player* _tmp21_;
		gint _tmp21__length1;
		gint _tmp21__length2;
		Player* _tmp22_;
		gint _tmp22__length1;
		gint _tmp22__length2;
#line 564 "../src/game.vala"
		mid_board = (guint8) ((_size - 1) / 2);
#line 565 "../src/game.vala"
		_initial_number_of_tiles = (guint8) 7;
#line 566 "../src/game.vala"
		_tmp12_ = tiles;
#line 566 "../src/game.vala"
		_tmp12__length1 = tiles_length1;
#line 566 "../src/game.vala"
		_tmp12__length2 = tiles_length2;
#line 566 "../src/game.vala"
		_tmp12_[(mid_board * _tmp12__length2) + mid_board] = PLAYER_DARK;
#line 567 "../src/game.vala"
		if (_alternative_start) {
#line 567 "../src/game.vala"
			_tmp13_ = PLAYER_LIGHT;
#line 3155 "game.c"
		} else {
#line 567 "../src/game.vala"
			_tmp13_ = PLAYER_DARK;
#line 3159 "game.c"
		}
#line 567 "../src/game.vala"
		_tmp14_ = tiles;
#line 567 "../src/game.vala"
		_tmp14__length1 = tiles_length1;
#line 567 "../src/game.vala"
		_tmp14__length2 = tiles_length2;
#line 567 "../src/game.vala"
		_tmp14_[((mid_board + 1) * _tmp14__length2) + (mid_board - 1)] = _tmp13_;
#line 568 "../src/game.vala"
		if (_alternative_start) {
#line 568 "../src/game.vala"
			_tmp15_ = PLAYER_LIGHT;
#line 3173 "game.c"
		} else {
#line 568 "../src/game.vala"
			_tmp15_ = PLAYER_DARK;
#line 3177 "game.c"
		}
#line 568 "../src/game.vala"
		_tmp16_ = tiles;
#line 568 "../src/game.vala"
		_tmp16__length1 = tiles_length1;
#line 568 "../src/game.vala"
		_tmp16__length2 = tiles_length2;
#line 568 "../src/game.vala"
		_tmp16_[((mid_board - 1) * _tmp16__length2) + (mid_board + 1)] = _tmp15_;
#line 569 "../src/game.vala"
		_tmp17_ = tiles;
#line 569 "../src/game.vala"
		_tmp17__length1 = tiles_length1;
#line 569 "../src/game.vala"
		_tmp17__length2 = tiles_length2;
#line 569 "../src/game.vala"
		_tmp17_[(mid_board * _tmp17__length2) + (mid_board - 1)] = PLAYER_LIGHT;
#line 570 "../src/game.vala"
		if (_alternative_start) {
#line 570 "../src/game.vala"
			_tmp18_ = PLAYER_DARK;
#line 3199 "game.c"
		} else {
#line 570 "../src/game.vala"
			_tmp18_ = PLAYER_LIGHT;
#line 3203 "game.c"
		}
#line 570 "../src/game.vala"
		_tmp19_ = tiles;
#line 570 "../src/game.vala"
		_tmp19__length1 = tiles_length1;
#line 570 "../src/game.vala"
		_tmp19__length2 = tiles_length2;
#line 570 "../src/game.vala"
		_tmp19_[((mid_board - 1) * _tmp19__length2) + mid_board] = _tmp18_;
#line 571 "../src/game.vala"
		if (_alternative_start) {
#line 571 "../src/game.vala"
			_tmp20_ = PLAYER_DARK;
#line 3217 "game.c"
		} else {
#line 571 "../src/game.vala"
			_tmp20_ = PLAYER_LIGHT;
#line 3221 "game.c"
		}
#line 571 "../src/game.vala"
		_tmp21_ = tiles;
#line 571 "../src/game.vala"
		_tmp21__length1 = tiles_length1;
#line 571 "../src/game.vala"
		_tmp21__length2 = tiles_length2;
#line 571 "../src/game.vala"
		_tmp21_[((mid_board + 1) * _tmp21__length2) + mid_board] = _tmp20_;
#line 572 "../src/game.vala"
		_tmp22_ = tiles;
#line 572 "../src/game.vala"
		_tmp22__length1 = tiles_length1;
#line 572 "../src/game.vala"
		_tmp22__length2 = tiles_length2;
#line 572 "../src/game.vala"
		_tmp22_[(mid_board * _tmp22__length2) + (mid_board + 1)] = PLAYER_LIGHT;
#line 3239 "game.c"
	}
#line 576 "../src/game.vala"
	game_init_neighbor_tiles (_size, &_tmp23_, &_tmp24_, &_tmp25_);
#line 576 "../src/game.vala"
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
#line 576 "../src/game.vala"
	_neighbor_tiles = _tmp23_;
#line 576 "../src/game.vala"
	_neighbor_tiles_length1 = _tmp24_;
#line 576 "../src/game.vala"
	_neighbor_tiles_length2 = _tmp25_;
#line 577 "../src/game.vala"
	_tmp26_ = tiles;
#line 577 "../src/game.vala"
	_tmp26__length1 = tiles_length1;
#line 577 "../src/game.vala"
	_tmp26__length2 = tiles_length2;
#line 577 "../src/game.vala"
	_tmp27_ = _neighbor_tiles;
#line 577 "../src/game.vala"
	_tmp27__length1 = _neighbor_tiles_length1;
#line 577 "../src/game.vala"
	_tmp27__length2 = _neighbor_tiles_length2;
#line 577 "../src/game.vala"
	_tmp28_ = game_state_object_new_from_grid (_size, _tmp26_, _tmp26__length1, _tmp26__length2, PLAYER_DARK, _tmp27_, _tmp27__length1, _tmp27__length2);
#line 577 "../src/game.vala"
	_current_state = _tmp28_;
#line 579 "../src/game.vala"
	self = (Game*) g_object_new (object_type, "size", _size, "current-state", _current_state, "alternative-start", _alternative_start, "initial-number-of-tiles", _initial_number_of_tiles, NULL);
#line 583 "../src/game.vala"
	_tmp29_ = _neighbor_tiles;
#line 583 "../src/game.vala"
	_tmp29__length1 = _neighbor_tiles_length1;
#line 583 "../src/game.vala"
	_tmp29__length2 = _neighbor_tiles_length2;
#line 583 "../src/game.vala"
	_neighbor_tiles = NULL;
#line 583 "../src/game.vala"
	_neighbor_tiles_length1 = 0;
#line 583 "../src/game.vala"
	_neighbor_tiles_length2 = 0;
#line 583 "../src/game.vala"
	self->priv->neighbor_tiles = (g_free (self->priv->neighbor_tiles), NULL);
#line 583 "../src/game.vala"
	self->priv->neighbor_tiles = _tmp29_;
#line 583 "../src/game.vala"
	self->priv->neighbor_tiles_length1 = _tmp29__length1;
#line 583 "../src/game.vala"
	self->priv->neighbor_tiles_length2 = _tmp29__length2;
#line 538 "../src/game.vala"
	_g_object_unref0 (_current_state);
#line 538 "../src/game.vala"
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
#line 538 "../src/game.vala"
	tiles = (g_free (tiles), NULL);
#line 538 "../src/game.vala"
	return self;
#line 3297 "game.c"
}

Game*
game_new (gboolean _alternative_start,
          guint8 _size)
{
#line 538 "../src/game.vala"
	return game_construct (TYPE_GAME, _alternative_start, _size);
#line 3306 "game.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 3323 "game.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
#line 1148 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1149 "glib-2.0.vapi"
		separator = "";
#line 3337 "game.c"
	}
#line 1151 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 3341 "game.c"
		gboolean _tmp1_ = FALSE;
#line 1151 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1151 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 3347 "game.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1151 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 3352 "game.c"
				const gchar* _tmp3_;
#line 1151 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1151 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 3358 "game.c"
			} else {
#line 1151 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 3362 "game.c"
			}
#line 1151 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 3366 "game.c"
		}
#line 1151 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 3370 "game.c"
	} else {
#line 1151 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 3374 "game.c"
	}
#line 1151 "glib-2.0.vapi"
	if (_tmp0_) {
#line 3378 "game.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
#line 1153 "glib-2.0.vapi"
		len = (gsize) 1;
#line 3392 "game.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
			i = 0;
#line 1154 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1154 "glib-2.0.vapi"
			while (TRUE) {
#line 3401 "game.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1154 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 3408 "game.c"
					gint _tmp5_;
#line 1154 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1154 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 3414 "game.c"
				}
#line 1154 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 3422 "game.c"
				} else {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 3426 "game.c"
				}
#line 1154 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1154 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 3432 "game.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1154 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 3437 "game.c"
						const gchar* _tmp9_;
#line 1154 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1154 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 3443 "game.c"
					} else {
#line 1154 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 3447 "game.c"
					}
#line 1154 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 3451 "game.c"
				}
#line 1154 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1154 "glib-2.0.vapi"
					break;
#line 3457 "game.c"
				}
#line 1155 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1155 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 3463 "game.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1155 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1155 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1155 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1155 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 3475 "game.c"
				} else {
#line 1155 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 3479 "game.c"
				}
#line 1155 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 3483 "game.c"
			}
		}
#line 1157 "glib-2.0.vapi"
		if (i == 0) {
#line 3488 "game.c"
			gchar* _tmp15_;
#line 1158 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1158 "glib-2.0.vapi"
			result = _tmp15_;
#line 1158 "glib-2.0.vapi"
			return result;
#line 3496 "game.c"
		}
#line 1160 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1161 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1161 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1161 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1163 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1163 "glib-2.0.vapi"
		res = _tmp18_;
#line 1164 "glib-2.0.vapi"
		_tmp19_ = res;
#line 1164 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1164 "glib-2.0.vapi"
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
#line 1164 "glib-2.0.vapi"
		ptr = _tmp21_;
#line 3518 "game.c"
		{
			gboolean _tmp22_ = FALSE;
#line 1165 "glib-2.0.vapi"
			i = 1;
#line 1165 "glib-2.0.vapi"
			_tmp22_ = TRUE;
#line 1165 "glib-2.0.vapi"
			while (TRUE) {
#line 3527 "game.c"
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
#line 1165 "glib-2.0.vapi"
				if (!_tmp22_) {
#line 3536 "game.c"
					gint _tmp23_;
#line 1165 "glib-2.0.vapi"
					_tmp23_ = i;
#line 1165 "glib-2.0.vapi"
					i = _tmp23_ + 1;
#line 3542 "game.c"
				}
#line 1165 "glib-2.0.vapi"
				_tmp22_ = FALSE;
#line 1165 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1165 "glib-2.0.vapi"
					break;
#line 3550 "game.c"
				}
#line 1166 "glib-2.0.vapi"
				_tmp24_ = ptr;
#line 1166 "glib-2.0.vapi"
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
#line 1166 "glib-2.0.vapi"
				ptr = _tmp25_;
#line 1167 "glib-2.0.vapi"
				_tmp27_ = str_array[i];
#line 1167 "glib-2.0.vapi"
				if (_tmp27_ != NULL) {
#line 3562 "game.c"
					const gchar* _tmp28_;
#line 1167 "glib-2.0.vapi"
					_tmp28_ = str_array[i];
#line 1167 "glib-2.0.vapi"
					_tmp26_ = (const gchar*) _tmp28_;
#line 3568 "game.c"
				} else {
#line 1167 "glib-2.0.vapi"
					_tmp26_ = "";
#line 3572 "game.c"
				}
#line 1167 "glib-2.0.vapi"
				_tmp29_ = ptr;
#line 1167 "glib-2.0.vapi"
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
#line 1167 "glib-2.0.vapi"
				ptr = _tmp30_;
#line 3580 "game.c"
			}
		}
#line 1170 "glib-2.0.vapi"
		_tmp31_ = res;
#line 1170 "glib-2.0.vapi"
		res = NULL;
#line 1170 "glib-2.0.vapi"
		result = (gchar*) _tmp31_;
#line 1170 "glib-2.0.vapi"
		return result;
#line 3591 "game.c"
	} else {
		gchar* _tmp32_;
#line 1172 "glib-2.0.vapi"
		_tmp32_ = g_strdup ("");
#line 1172 "glib-2.0.vapi"
		result = _tmp32_;
#line 1172 "glib-2.0.vapi"
		return result;
#line 3600 "game.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 3625 "game.c"
}

Game*
game_construct_from_strings (GType object_type,
                             gchar** setup,
                             gint setup_length1,
                             Player to_move,
                             guint8 _size)
{
	Game * self = NULL;
	Player* tiles = NULL;
	Player* _tmp0_;
	gint tiles_length1;
	gint tiles_length2;
	guint8* _neighbor_tiles = NULL;
	gint _neighbor_tiles_length1 = 0;
	gint _neighbor_tiles_length2 = 0;
	guint8* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	GameStateObject* _current_state = NULL;
	Player* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	guint8* _tmp14_;
	gint _tmp14__length1;
	gint _tmp14__length2;
	GameStateObject* _tmp15_;
	gint _tmp16_ = 0;
	GameStateObject* _tmp17_;
	guint8* _tmp18_;
	gint _tmp18__length1;
	gint _tmp18__length2;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
#line 586 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) >= 4, "_size >= 4", NULL);
#line 586 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) <= 16, "_size <= 16", NULL);
#line 586 "../src/game.vala"
	_vala_return_val_if_fail (to_move != PLAYER_NONE, "to_move != Player.NONE", NULL);
#line 586 "../src/game.vala"
	_vala_return_val_if_fail (setup_length1 == ((gint) _size), "setup.length == _size", NULL);
#line 592 "../src/game.vala"
	_tmp0_ = g_new0 (Player, _size * _size);
#line 592 "../src/game.vala"
	tiles = _tmp0_;
#line 592 "../src/game.vala"
	tiles_length1 = _size;
#line 592 "../src/game.vala"
	tiles_length2 = _size;
#line 3683 "game.c"
	{
		guint8 y = 0U;
#line 594 "../src/game.vala"
		y = (guint8) 0;
#line 3688 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 594 "../src/game.vala"
			_tmp1_ = TRUE;
#line 594 "../src/game.vala"
			while (TRUE) {
#line 3695 "game.c"
				const gchar* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 594 "../src/game.vala"
				if (!_tmp1_) {
#line 3701 "game.c"
					guint8 _tmp2_;
#line 594 "../src/game.vala"
					_tmp2_ = y;
#line 594 "../src/game.vala"
					y = _tmp2_ + 1;
#line 3707 "game.c"
				}
#line 594 "../src/game.vala"
				_tmp1_ = FALSE;
#line 594 "../src/game.vala"
				if (!(y < _size)) {
#line 594 "../src/game.vala"
					break;
#line 3715 "game.c"
				}
#line 596 "../src/game.vala"
				_tmp3_ = setup[y];
#line 596 "../src/game.vala"
				_tmp4_ = strlen (_tmp3_);
#line 596 "../src/game.vala"
				_tmp5_ = _tmp4_;
#line 596 "../src/game.vala"
				if (_tmp5_ != (_size * 2)) {
#line 597 "../src/game.vala"
					g_warn_if_reached ();
#line 3727 "game.c"
				}
				{
					guint8 x = 0U;
#line 598 "../src/game.vala"
					x = (guint8) 0;
#line 3733 "game.c"
					{
						gboolean _tmp6_ = FALSE;
#line 598 "../src/game.vala"
						_tmp6_ = TRUE;
#line 598 "../src/game.vala"
						while (TRUE) {
#line 3740 "game.c"
							Player* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							const gchar* _tmp9_;
#line 598 "../src/game.vala"
							if (!_tmp6_) {
#line 3747 "game.c"
								guint8 _tmp7_;
#line 598 "../src/game.vala"
								_tmp7_ = x;
#line 598 "../src/game.vala"
								x = _tmp7_ + 1;
#line 3753 "game.c"
							}
#line 598 "../src/game.vala"
							_tmp6_ = FALSE;
#line 598 "../src/game.vala"
							if (!(x < _size)) {
#line 598 "../src/game.vala"
								break;
#line 3761 "game.c"
							}
#line 599 "../src/game.vala"
							_tmp8_ = tiles;
#line 599 "../src/game.vala"
							_tmp8__length1 = tiles_length1;
#line 599 "../src/game.vala"
							_tmp8__length2 = tiles_length2;
#line 599 "../src/game.vala"
							_tmp9_ = setup[y];
#line 599 "../src/game.vala"
							_tmp8_[(x * _tmp8__length2) + y] = player_from_char (string_get (_tmp9_, (glong) ((x * 2) + 1)));
#line 3773 "game.c"
						}
					}
				}
			}
		}
	}
#line 603 "../src/game.vala"
	game_init_neighbor_tiles (_size, &_tmp10_, &_tmp11_, &_tmp12_);
#line 603 "../src/game.vala"
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
#line 603 "../src/game.vala"
	_neighbor_tiles = _tmp10_;
#line 603 "../src/game.vala"
	_neighbor_tiles_length1 = _tmp11_;
#line 603 "../src/game.vala"
	_neighbor_tiles_length2 = _tmp12_;
#line 604 "../src/game.vala"
	_tmp13_ = tiles;
#line 604 "../src/game.vala"
	_tmp13__length1 = tiles_length1;
#line 604 "../src/game.vala"
	_tmp13__length2 = tiles_length2;
#line 604 "../src/game.vala"
	_tmp14_ = _neighbor_tiles;
#line 604 "../src/game.vala"
	_tmp14__length1 = _neighbor_tiles_length1;
#line 604 "../src/game.vala"
	_tmp14__length2 = _neighbor_tiles_length2;
#line 604 "../src/game.vala"
	_tmp15_ = game_state_object_new_from_grid (_size, _tmp13_, _tmp13__length1, _tmp13__length2, to_move, _tmp14_, _tmp14__length1, _tmp14__length2);
#line 604 "../src/game.vala"
	_current_state = _tmp15_;
#line 609 "../src/game.vala"
	if ((_size % 2) == 0) {
#line 609 "../src/game.vala"
		_tmp16_ = 4;
#line 3810 "game.c"
	} else {
#line 609 "../src/game.vala"
		_tmp16_ = 7;
#line 3814 "game.c"
	}
#line 606 "../src/game.vala"
	_tmp17_ = _current_state;
#line 606 "../src/game.vala"
	self = (Game*) g_object_new (object_type, "size", _size, "current-state", _tmp17_, "alternative-start", FALSE, "initial-number-of-tiles", _tmp16_, NULL);
#line 610 "../src/game.vala"
	_tmp18_ = _neighbor_tiles;
#line 610 "../src/game.vala"
	_tmp18__length1 = _neighbor_tiles_length1;
#line 610 "../src/game.vala"
	_tmp18__length2 = _neighbor_tiles_length2;
#line 610 "../src/game.vala"
	_neighbor_tiles = NULL;
#line 610 "../src/game.vala"
	_neighbor_tiles_length1 = 0;
#line 610 "../src/game.vala"
	_neighbor_tiles_length2 = 0;
#line 610 "../src/game.vala"
	self->priv->neighbor_tiles = (g_free (self->priv->neighbor_tiles), NULL);
#line 610 "../src/game.vala"
	self->priv->neighbor_tiles = _tmp18_;
#line 610 "../src/game.vala"
	self->priv->neighbor_tiles_length1 = _tmp18__length1;
#line 610 "../src/game.vala"
	self->priv->neighbor_tiles_length2 = _tmp18__length2;
#line 612 "../src/game.vala"
	_tmp19_ = _vala_g_strjoinv ("\n", (gchar**) setup, (gint) ((setup_length1 * sizeof (gchar*)) / sizeof (gchar*)));
#line 612 "../src/game.vala"
	_tmp20_ = _tmp19_;
#line 612 "../src/game.vala"
	_tmp21_ = string_strip (_tmp20_);
#line 612 "../src/game.vala"
	_tmp22_ = _tmp21_;
#line 612 "../src/game.vala"
	_tmp23_ = game_to_string (self);
#line 612 "../src/game.vala"
	_tmp24_ = _tmp23_;
#line 612 "../src/game.vala"
	_tmp25_ = string_strip (_tmp24_);
#line 612 "../src/game.vala"
	_tmp26_ = _tmp25_;
#line 612 "../src/game.vala"
	g_warn_if_fail (g_strcmp0 (_tmp22_, _tmp26_) == 0);
#line 612 "../src/game.vala"
	_g_free0 (_tmp26_);
#line 612 "../src/game.vala"
	_g_free0 (_tmp24_);
#line 612 "../src/game.vala"
	_g_free0 (_tmp22_);
#line 612 "../src/game.vala"
	_g_free0 (_tmp20_);
#line 586 "../src/game.vala"
	_g_object_unref0 (_current_state);
#line 586 "../src/game.vala"
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
#line 586 "../src/game.vala"
	tiles = (g_free (tiles), NULL);
#line 586 "../src/game.vala"
	return self;
#line 3874 "game.c"
}

Game*
game_new_from_strings (gchar** setup,
                       gint setup_length1,
                       Player to_move,
                       guint8 _size)
{
#line 586 "../src/game.vala"
	return game_construct_from_strings (TYPE_GAME, setup, setup_length1, to_move, _size);
#line 3885 "game.c"
}

Player
game_get_owner (Game* self,
                guint8 x,
                guint8 y)
{
	Player result = 0;
	GameStateObject* _tmp0_;
#line 619 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 621 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 621 "../src/game.vala"
	result = game_state_object_get_owner (_tmp0_, x, y);
#line 621 "../src/game.vala"
	return result;
#line 3903 "game.c"
}

gchar*
game_to_string (Game* self)
{
	gchar* result = NULL;
	GameStateObject* _tmp0_;
	gchar* _tmp1_;
#line 632 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 634 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 634 "../src/game.vala"
	_tmp1_ = game_state_object_to_string (_tmp0_);
#line 634 "../src/game.vala"
	result = _tmp1_;
#line 634 "../src/game.vala"
	return result;
#line 3922 "game.c"
}

gboolean
game_place_tile (Game* self,
                 guint8 x,
                 guint8 y)
{
	gboolean result = FALSE;
	PossibleMove move = {0};
	GameStateObject* _tmp0_;
	PossibleMove _tmp1_ = {0};
	gboolean _tmp2_;
	GameStateObject* _tmp3_;
	PossibleMove _tmp4_;
	GameStateObject* _tmp5_;
	GameStateObject* _tmp6_;
	GListStore* _tmp7_;
	GameStateObject* _tmp8_;
#line 641 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 644 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 644 "../src/game.vala"
	_tmp2_ = game_state_object_test_placing_tile (_tmp0_, x, y, &_tmp1_);
#line 644 "../src/game.vala"
	move = _tmp1_;
#line 644 "../src/game.vala"
	if (!_tmp2_) {
#line 645 "../src/game.vala"
		result = FALSE;
#line 645 "../src/game.vala"
		return result;
#line 3955 "game.c"
	}
#line 647 "../src/game.vala"
	_tmp3_ = self->priv->_current_state;
#line 647 "../src/game.vala"
	_tmp4_ = move;
#line 647 "../src/game.vala"
	_tmp5_ = game_state_object_new_copy_and_move (_tmp3_, &_tmp4_);
#line 647 "../src/game.vala"
	_tmp6_ = _tmp5_;
#line 647 "../src/game.vala"
	game_set_current_state (self, _tmp6_);
#line 647 "../src/game.vala"
	_g_object_unref0 (_tmp6_);
#line 648 "../src/game.vala"
	_tmp7_ = self->priv->undo_stack;
#line 648 "../src/game.vala"
	_tmp8_ = self->priv->_current_state;
#line 648 "../src/game.vala"
	g_list_store_append (_tmp7_, (GObject*) _tmp8_);
#line 649 "../src/game.vala"
	game_end_of_turn (self, FALSE, FALSE);
#line 650 "../src/game.vala"
	result = TRUE;
#line 650 "../src/game.vala"
	return result;
#line 3981 "game.c"
}

gboolean
game_pass (Game* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GameStateObject* _tmp2_;
	GameStateObject* _tmp3_;
	GameStateObject* _tmp4_;
	GListStore* _tmp5_;
	GameStateObject* _tmp6_;
#line 653 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 655 "../src/game.vala"
	_tmp0_ = game_get_current_player_can_move (self);
#line 655 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 655 "../src/game.vala"
	if (_tmp1_) {
#line 656 "../src/game.vala"
		result = FALSE;
#line 656 "../src/game.vala"
		return result;
#line 4007 "game.c"
	}
#line 658 "../src/game.vala"
	_tmp2_ = self->priv->_current_state;
#line 658 "../src/game.vala"
	_tmp3_ = game_state_object_new_copy_and_pass (_tmp2_);
#line 658 "../src/game.vala"
	_tmp4_ = _tmp3_;
#line 658 "../src/game.vala"
	game_set_current_state (self, _tmp4_);
#line 658 "../src/game.vala"
	_g_object_unref0 (_tmp4_);
#line 659 "../src/game.vala"
	_tmp5_ = self->priv->undo_stack;
#line 659 "../src/game.vala"
	_tmp6_ = self->priv->_current_state;
#line 659 "../src/game.vala"
	g_list_store_append (_tmp5_, (GObject*) _tmp6_);
#line 660 "../src/game.vala"
	game_end_of_turn (self, FALSE, TRUE);
#line 661 "../src/game.vala"
	result = TRUE;
#line 661 "../src/game.vala"
	return result;
#line 4031 "game.c"
}

static void
game_end_of_turn (Game* self,
                  gboolean undoing,
                  gboolean no_draw)
{
	GameStateObject* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 664 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 666 "../src/game.vala"
	game_update_possible_moves (self);
#line 667 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 667 "../src/game.vala"
	_tmp1_ = game_state_object_get_is_complete (_tmp0_);
#line 667 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 667 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_COMPLETENESS_UPDATED_SIGNAL], 0, _tmp2_);
#line 668 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_TURN_ENDED_SIGNAL], 0, undoing, no_draw);
#line 4056 "game.c"
}

void
game_undo (Game* self,
           guint8 count)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint undo_stack_n_items = 0U;
	GListStore* _tmp2_;
	GObject* tmp_current_state = NULL;
	GListStore* _tmp3_;
	GObject* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GObject* _tmp6_;
	GObject* _tmp8_;
	GListStore* _tmp9_;
	gboolean _tmp10_ = FALSE;
#line 675 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 675 "../src/game.vala"
	_vala_return_if_fail ((((gint) count) == 1) || (((gint) count) == 2), "count == 1 || count == 2");
#line 675 "../src/game.vala"
	_tmp0_ = game_get_number_of_moves (self);
#line 675 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 675 "../src/game.vala"
	_vala_return_if_fail (_tmp1_ >= count, "number_of_moves >= count");
#line 679 "../src/game.vala"
	_tmp2_ = self->priv->undo_stack;
#line 679 "../src/game.vala"
	undo_stack_n_items = g_list_model_get_n_items ((GListModel*) _tmp2_);
#line 680 "../src/game.vala"
	_tmp3_ = self->priv->undo_stack;
#line 680 "../src/game.vala"
	_tmp4_ = g_list_model_get_object ((GListModel*) _tmp3_, undo_stack_n_items - 2);
#line 680 "../src/game.vala"
	tmp_current_state = _tmp4_;
#line 681 "../src/game.vala"
	_tmp6_ = tmp_current_state;
#line 681 "../src/game.vala"
	if (_tmp6_ == NULL) {
#line 681 "../src/game.vala"
		_tmp5_ = TRUE;
#line 4101 "game.c"
	} else {
		GObject* _tmp7_;
#line 681 "../src/game.vala"
		_tmp7_ = tmp_current_state;
#line 681 "../src/game.vala"
		_tmp5_ = !G_TYPE_CHECK_INSTANCE_TYPE (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, G_TYPE_OBJECT, GObject), TYPE_GAME_STATE_OBJECT);
#line 4108 "game.c"
	}
#line 681 "../src/game.vala"
	if (_tmp5_) {
#line 682 "../src/game.vala"
		g_assert_not_reached ();
#line 4114 "game.c"
	}
#line 683 "../src/game.vala"
	_tmp8_ = tmp_current_state;
#line 683 "../src/game.vala"
	game_set_current_state (self, G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, G_TYPE_OBJECT, GObject), TYPE_GAME_STATE_OBJECT, GameStateObject));
#line 687 "../src/game.vala"
	_tmp9_ = self->priv->undo_stack;
#line 687 "../src/game.vala"
	g_list_store_remove (_tmp9_, undo_stack_n_items - 1);
#line 689 "../src/game.vala"
	if (((gint) count) == 1) {
#line 4126 "game.c"
		gboolean _tmp11_;
		gboolean _tmp12_;
#line 689 "../src/game.vala"
		_tmp11_ = game_get_current_player_can_move (self);
#line 689 "../src/game.vala"
		_tmp12_ = _tmp11_;
#line 689 "../src/game.vala"
		_tmp10_ = _tmp12_;
#line 4135 "game.c"
	} else {
#line 689 "../src/game.vala"
		_tmp10_ = FALSE;
#line 4139 "game.c"
	}
#line 689 "../src/game.vala"
	if (_tmp10_) {
#line 690 "../src/game.vala"
		game_end_of_turn (self, TRUE, FALSE);
#line 4145 "game.c"
	} else {
#line 691 "../src/game.vala"
		if (((gint) count) == 2) {
#line 693 "../src/game.vala"
			game_end_of_turn (self, TRUE, TRUE);
#line 694 "../src/game.vala"
			game_undo (self, (guint8) (count - 1));
#line 4153 "game.c"
		}
	}
#line 675 "../src/game.vala"
	_g_object_unref0 (tmp_current_state);
#line 4158 "game.c"
}

static guint8*
_vala_array_dup9 (guint8* self,
                  int length)
{
#line 706 "../src/game.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 4167 "game.c"
}

guint8*
game_copy_neighbor_tiles (Game* self,
                          gint* result_length1,
                          gint* result_length2)
{
	guint8* result = NULL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
#line 704 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 706 "../src/game.vala"
	_tmp0_ = self->priv->neighbor_tiles;
#line 706 "../src/game.vala"
	_tmp0__length1 = self->priv->neighbor_tiles_length1;
#line 706 "../src/game.vala"
	_tmp0__length2 = self->priv->neighbor_tiles_length2;
#line 706 "../src/game.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup9 (_tmp0_, _tmp0__length1 * _tmp0__length2) : ((gpointer) _tmp0_);
#line 706 "../src/game.vala"
	_tmp1__length1 = _tmp0__length1;
#line 706 "../src/game.vala"
	_tmp1__length2 = _tmp0__length2;
#line 706 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 706 "../src/game.vala"
	_tmp2__length1 = _tmp1__length1;
#line 706 "../src/game.vala"
	_tmp2__length2 = _tmp1__length2;
#line 706 "../src/game.vala"
	if (result_length1) {
#line 706 "../src/game.vala"
		*result_length1 = _tmp2__length1;
#line 4209 "game.c"
	}
#line 706 "../src/game.vala"
	if (result_length2) {
#line 706 "../src/game.vala"
		*result_length2 = _tmp2__length2;
#line 4215 "game.c"
	}
#line 706 "../src/game.vala"
	result = _tmp2_;
#line 706 "../src/game.vala"
	return result;
#line 4221 "game.c"
}

static void
game_init_neighbor_tiles (guint8 size,
                          guint8** neighbor_tiles,
                          gint* neighbor_tiles_length1,
                          gint* neighbor_tiles_length2)
{
	guint8* _vala_neighbor_tiles = NULL;
	gint _vala_neighbor_tiles_length1 = 0;
	gint _vala_neighbor_tiles_length2 = 0;
	guint8* _tmp0_;
	guint8 max = 0U;
	guint8* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	guint8* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	guint8* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	guint8* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
#line 711 "../src/game.vala"
	_tmp0_ = g_new0 (guint8, size * size);
#line 711 "../src/game.vala"
	_vala_neighbor_tiles = (g_free (_vala_neighbor_tiles), NULL);
#line 711 "../src/game.vala"
	_vala_neighbor_tiles = _tmp0_;
#line 711 "../src/game.vala"
	_vala_neighbor_tiles_length1 = size;
#line 711 "../src/game.vala"
	_vala_neighbor_tiles_length2 = size;
#line 712 "../src/game.vala"
	max = (guint8) (size - 1);
#line 4259 "game.c"
	{
		guint8 i = 0U;
#line 714 "../src/game.vala"
		i = (guint8) 1;
#line 4264 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 714 "../src/game.vala"
			_tmp1_ = TRUE;
#line 714 "../src/game.vala"
			while (TRUE) {
#line 4271 "game.c"
				guint8* _tmp3_;
				gint _tmp3__length1;
				gint _tmp3__length2;
				guint8* _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				guint8* _tmp5_;
				gint _tmp5__length1;
				gint _tmp5__length2;
				guint8* _tmp6_;
				gint _tmp6__length1;
				gint _tmp6__length2;
#line 714 "../src/game.vala"
				if (!_tmp1_) {
#line 4286 "game.c"
					guint8 _tmp2_;
#line 714 "../src/game.vala"
					_tmp2_ = i;
#line 714 "../src/game.vala"
					i = _tmp2_ + 1;
#line 4292 "game.c"
				}
#line 714 "../src/game.vala"
				_tmp1_ = FALSE;
#line 714 "../src/game.vala"
				if (!(i < max)) {
#line 714 "../src/game.vala"
					break;
#line 4300 "game.c"
				}
#line 717 "../src/game.vala"
				_tmp3_ = _vala_neighbor_tiles;
#line 717 "../src/game.vala"
				_tmp3__length1 = _vala_neighbor_tiles_length1;
#line 717 "../src/game.vala"
				_tmp3__length2 = _vala_neighbor_tiles_length2;
#line 717 "../src/game.vala"
				_tmp3_[(i * _tmp3__length2) + 0] = (guint8) 5;
#line 718 "../src/game.vala"
				_tmp4_ = _vala_neighbor_tiles;
#line 718 "../src/game.vala"
				_tmp4__length1 = _vala_neighbor_tiles_length1;
#line 718 "../src/game.vala"
				_tmp4__length2 = _vala_neighbor_tiles_length2;
#line 718 "../src/game.vala"
				_tmp4_[(i * _tmp4__length2) + max] = (guint8) 5;
#line 719 "../src/game.vala"
				_tmp5_ = _vala_neighbor_tiles;
#line 719 "../src/game.vala"
				_tmp5__length1 = _vala_neighbor_tiles_length1;
#line 719 "../src/game.vala"
				_tmp5__length2 = _vala_neighbor_tiles_length2;
#line 719 "../src/game.vala"
				_tmp5_[(0 * _tmp5__length2) + i] = (guint8) 5;
#line 720 "../src/game.vala"
				_tmp6_ = _vala_neighbor_tiles;
#line 720 "../src/game.vala"
				_tmp6__length1 = _vala_neighbor_tiles_length1;
#line 720 "../src/game.vala"
				_tmp6__length2 = _vala_neighbor_tiles_length2;
#line 720 "../src/game.vala"
				_tmp6_[(max * _tmp6__length2) + i] = (guint8) 5;
#line 4334 "game.c"
				{
					guint8 j = 0U;
#line 723 "../src/game.vala"
					j = (guint8) 1;
#line 4339 "game.c"
					{
						gboolean _tmp7_ = FALSE;
#line 723 "../src/game.vala"
						_tmp7_ = TRUE;
#line 723 "../src/game.vala"
						while (TRUE) {
#line 4346 "game.c"
							guint8* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
#line 723 "../src/game.vala"
							if (!_tmp7_) {
#line 4352 "game.c"
								guint8 _tmp8_;
#line 723 "../src/game.vala"
								_tmp8_ = j;
#line 723 "../src/game.vala"
								j = _tmp8_ + 1;
#line 4358 "game.c"
							}
#line 723 "../src/game.vala"
							_tmp7_ = FALSE;
#line 723 "../src/game.vala"
							if (!(j < max)) {
#line 723 "../src/game.vala"
								break;
#line 4366 "game.c"
							}
#line 724 "../src/game.vala"
							_tmp9_ = _vala_neighbor_tiles;
#line 724 "../src/game.vala"
							_tmp9__length1 = _vala_neighbor_tiles_length1;
#line 724 "../src/game.vala"
							_tmp9__length2 = _vala_neighbor_tiles_length2;
#line 724 "../src/game.vala"
							_tmp9_[(i * _tmp9__length2) + j] = (guint8) 8;
#line 4376 "game.c"
						}
					}
				}
			}
		}
	}
#line 728 "../src/game.vala"
	_tmp10_ = _vala_neighbor_tiles;
#line 728 "../src/game.vala"
	_tmp10__length1 = _vala_neighbor_tiles_length1;
#line 728 "../src/game.vala"
	_tmp10__length2 = _vala_neighbor_tiles_length2;
#line 728 "../src/game.vala"
	_tmp10_[(0 * _tmp10__length2) + 0] = (guint8) 3;
#line 729 "../src/game.vala"
	_tmp11_ = _vala_neighbor_tiles;
#line 729 "../src/game.vala"
	_tmp11__length1 = _vala_neighbor_tiles_length1;
#line 729 "../src/game.vala"
	_tmp11__length2 = _vala_neighbor_tiles_length2;
#line 729 "../src/game.vala"
	_tmp11_[(0 * _tmp11__length2) + max] = (guint8) 3;
#line 730 "../src/game.vala"
	_tmp12_ = _vala_neighbor_tiles;
#line 730 "../src/game.vala"
	_tmp12__length1 = _vala_neighbor_tiles_length1;
#line 730 "../src/game.vala"
	_tmp12__length2 = _vala_neighbor_tiles_length2;
#line 730 "../src/game.vala"
	_tmp12_[(max * _tmp12__length2) + max] = (guint8) 3;
#line 731 "../src/game.vala"
	_tmp13_ = _vala_neighbor_tiles;
#line 731 "../src/game.vala"
	_tmp13__length1 = _vala_neighbor_tiles_length1;
#line 731 "../src/game.vala"
	_tmp13__length2 = _vala_neighbor_tiles_length2;
#line 731 "../src/game.vala"
	_tmp13_[(max * _tmp13__length2) + 0] = (guint8) 3;
#line 709 "../src/game.vala"
	if (neighbor_tiles) {
#line 709 "../src/game.vala"
		*neighbor_tiles = _vala_neighbor_tiles;
#line 4419 "game.c"
	} else {
#line 709 "../src/game.vala"
		_vala_neighbor_tiles = (g_free (_vala_neighbor_tiles), NULL);
#line 4423 "game.c"
	}
#line 709 "../src/game.vala"
	if (neighbor_tiles_length1) {
#line 709 "../src/game.vala"
		*neighbor_tiles_length1 = _vala_neighbor_tiles_length1;
#line 4429 "game.c"
	}
#line 709 "../src/game.vala"
	if (neighbor_tiles_length2) {
#line 709 "../src/game.vala"
		*neighbor_tiles_length2 = _vala_neighbor_tiles_length2;
#line 4435 "game.c"
	}
}

gboolean
game_test_placing_tile (Game* self,
                        guint8 x,
                        guint8 y,
                        PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	gboolean result = FALSE;
	GSList* test_move = NULL;
	GSList* _tmp0_;
	GSList* _tmp1_;
#line 740 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 742 "../src/game.vala"
	_tmp0_ = self->priv->possible_moves;
#line 742 "../src/game.vala"
	_tmp1_ = g_slist_nth (_tmp0_, (guint) 0);
#line 742 "../src/game.vala"
	test_move = _tmp1_;
#line 743 "../src/game.vala"
	while (TRUE) {
#line 4460 "game.c"
		GSList* _tmp2_;
		GSList* _tmp3_;
		gconstpointer _tmp4_;
		gboolean _tmp5_ = FALSE;
		PossibleMove _tmp6_;
		GSList* _tmp8_;
		GSList* _tmp9_;
#line 743 "../src/game.vala"
		_tmp2_ = test_move;
#line 743 "../src/game.vala"
		if (!(_tmp2_ != NULL)) {
#line 743 "../src/game.vala"
			break;
#line 4474 "game.c"
		}
#line 745 "../src/game.vala"
		_tmp3_ = test_move;
#line 745 "../src/game.vala"
		_tmp4_ = ((GSList*) _tmp3_)->data;
#line 745 "../src/game.vala"
		_vala_move = (PossibleMove) (*((PossibleMove*) _tmp4_));
#line 746 "../src/game.vala"
		_tmp6_ = _vala_move;
#line 746 "../src/game.vala"
		if (_tmp6_.x == x) {
#line 4486 "game.c"
			PossibleMove _tmp7_;
#line 746 "../src/game.vala"
			_tmp7_ = _vala_move;
#line 746 "../src/game.vala"
			_tmp5_ = _tmp7_.y == y;
#line 4492 "game.c"
		} else {
#line 746 "../src/game.vala"
			_tmp5_ = FALSE;
#line 4496 "game.c"
		}
#line 746 "../src/game.vala"
		if (_tmp5_) {
#line 747 "../src/game.vala"
			result = TRUE;
#line 747 "../src/game.vala"
			if (move) {
#line 747 "../src/game.vala"
				*move = _vala_move;
#line 4506 "game.c"
			}
#line 747 "../src/game.vala"
			return result;
#line 4510 "game.c"
		}
#line 748 "../src/game.vala"
		_tmp8_ = test_move;
#line 748 "../src/game.vala"
		_tmp9_ = ((GSList*) _tmp8_)->next;
#line 748 "../src/game.vala"
		test_move = _tmp9_;
#line 4518 "game.c"
	}
#line 750 "../src/game.vala"
	result = FALSE;
#line 750 "../src/game.vala"
	if (move) {
#line 750 "../src/game.vala"
		*move = _vala_move;
#line 4526 "game.c"
	}
#line 750 "../src/game.vala"
	return result;
#line 4530 "game.c"
}

static PossibleMove*
__lambda6_ (Game* self,
            PossibleMove* a)
{
	PossibleMove* result = NULL;
	PossibleMove* _tmp0_;
#line 758 "../src/game.vala"
	_tmp0_ = _possible_move_dup0 (a);
#line 758 "../src/game.vala"
	result = _tmp0_;
#line 758 "../src/game.vala"
	return result;
#line 4545 "game.c"
}

static gpointer
___lambda6__gcopy_func (gconstpointer src,
                        gpointer self)
{
	gpointer result;
	result = __lambda6_ ((Game*) self, (PossibleMove*) src);
#line 755 "../src/game.vala"
	return result;
#line 4556 "game.c"
}

void
game_get_possible_moves (Game* self,
                         GSList* * moves)
{
	GSList* _vala_moves = NULL;
	GSList* _tmp0_;
	GSList* _tmp1_;
#line 753 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 755 "../src/game.vala"
	_tmp0_ = self->priv->possible_moves;
#line 755 "../src/game.vala"
	_tmp1_ = g_slist_copy_deep (_tmp0_, ___lambda6__gcopy_func, self);
#line 755 "../src/game.vala"
	(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 755 "../src/game.vala"
	_vala_moves = _tmp1_;
#line 753 "../src/game.vala"
	if (moves) {
#line 753 "../src/game.vala"
		*moves = _vala_moves;
#line 4580 "game.c"
	} else {
#line 753 "../src/game.vala"
		(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 4584 "game.c"
	}
}

static inline void
game_update_possible_moves (Game* self)
{
	GameStateObject* _tmp0_;
	GSList* _tmp1_ = NULL;
#line 762 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 764 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 764 "../src/game.vala"
	game_state_object_get_possible_moves (_tmp0_, &_tmp1_);
#line 764 "../src/game.vala"
	(self->priv->possible_moves == NULL) ? NULL : (self->priv->possible_moves = (_g_slist_free__possible_move_free0_ (self->priv->possible_moves), NULL));
#line 764 "../src/game.vala"
	self->priv->possible_moves = _tmp1_;
#line 4603 "game.c"
}

guint8
game_get_number_of_moves (Game* self)
{
	guint8 result;
	guint n_items = 0U;
	GListStore* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 511 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 513 "../src/game.vala"
	_tmp0_ = self->priv->undo_stack;
#line 513 "../src/game.vala"
	n_items = g_list_model_get_n_items ((GListModel*) _tmp0_);
#line 514 "../src/game.vala"
	if (n_items == ((guint) 0)) {
#line 514 "../src/game.vala"
		_tmp1_ = TRUE;
#line 4623 "game.c"
	} else {
#line 514 "../src/game.vala"
		_tmp1_ = n_items >= ((guint) 256);
#line 4627 "game.c"
	}
#line 514 "../src/game.vala"
	if (_tmp1_) {
#line 515 "../src/game.vala"
		g_assert_not_reached ();
#line 4633 "game.c"
	}
#line 516 "../src/game.vala"
	result = (guint8) (n_items - 1);
#line 516 "../src/game.vala"
	return result;
#line 4639 "game.c"
}

guint8
game_get_size (Game* self)
{
	guint8 result;
#line 527 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 527 "../src/game.vala"
	result = self->priv->_size;
#line 527 "../src/game.vala"
	return result;
#line 4652 "game.c"
}

static void
game_set_size (Game* self,
               guint8 value)
{
#line 527 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 527 "../src/game.vala"
	self->priv->_size = value;
#line 4663 "game.c"
}

GameStateObject*
game_get_current_state (Game* self)
{
	GameStateObject* result;
	GameStateObject* _tmp0_;
#line 528 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 528 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 528 "../src/game.vala"
	result = _tmp0_;
#line 528 "../src/game.vala"
	return result;
#line 4679 "game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 528 "../src/game.vala"
	return self ? g_object_ref (self) : NULL;
#line 4687 "game.c"
}

void
game_set_current_state (Game* self,
                        GameStateObject* value)
{
	GameStateObject* _tmp0_;
#line 528 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 528 "../src/game.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 528 "../src/game.vala"
	_g_object_unref0 (self->priv->_current_state);
#line 528 "../src/game.vala"
	self->priv->_current_state = _tmp0_;
#line 4703 "game.c"
}

gboolean
game_get_alternative_start (Game* self)
{
	gboolean result;
#line 529 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 529 "../src/game.vala"
	result = self->priv->_alternative_start;
#line 529 "../src/game.vala"
	return result;
#line 4716 "game.c"
}

static void
game_set_alternative_start (Game* self,
                            gboolean value)
{
#line 529 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 529 "../src/game.vala"
	self->priv->_alternative_start = value;
#line 4727 "game.c"
}

guint8
game_get_initial_number_of_tiles (Game* self)
{
	guint8 result;
#line 530 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 530 "../src/game.vala"
	result = self->priv->_initial_number_of_tiles;
#line 530 "../src/game.vala"
	return result;
#line 4740 "game.c"
}

static void
game_set_initial_number_of_tiles (Game* self,
                                  guint8 value)
{
#line 530 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 530 "../src/game.vala"
	self->priv->_initial_number_of_tiles = value;
#line 4751 "game.c"
}

gboolean
game_get_is_complete (Game* self)
{
	gboolean result;
	GameStateObject* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 626 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 626 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 626 "../src/game.vala"
	_tmp1_ = game_state_object_get_is_complete (_tmp0_);
#line 626 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 626 "../src/game.vala"
	result = _tmp2_;
#line 626 "../src/game.vala"
	return result;
#line 4773 "game.c"
}

guint8
game_get_n_light_tiles (Game* self)
{
	guint8 result;
	GameStateObject* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
#line 627 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 627 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 627 "../src/game.vala"
	_tmp1_ = game_state_object_get_n_light_tiles (_tmp0_);
#line 627 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 627 "../src/game.vala"
	result = _tmp2_;
#line 627 "../src/game.vala"
	return result;
#line 4795 "game.c"
}

guint8
game_get_n_dark_tiles (Game* self)
{
	guint8 result;
	GameStateObject* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
#line 628 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 628 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 628 "../src/game.vala"
	_tmp1_ = game_state_object_get_n_dark_tiles (_tmp0_);
#line 628 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 628 "../src/game.vala"
	result = _tmp2_;
#line 628 "../src/game.vala"
	return result;
#line 4817 "game.c"
}

gboolean
game_get_current_player_can_move (Game* self)
{
	gboolean result;
	GameStateObject* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 629 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 629 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 629 "../src/game.vala"
	_tmp1_ = game_state_object_get_current_player_can_move (_tmp0_);
#line 629 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 629 "../src/game.vala"
	result = _tmp2_;
#line 629 "../src/game.vala"
	return result;
#line 4839 "game.c"
}

Player
game_get_current_color (Game* self)
{
	Player result;
	GameStateObject* _tmp0_;
	Player _tmp1_;
	Player _tmp2_;
#line 630 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 630 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 630 "../src/game.vala"
	_tmp1_ = game_state_object_get_current_color (_tmp0_);
#line 630 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 630 "../src/game.vala"
	result = _tmp2_;
#line 630 "../src/game.vala"
	return result;
#line 4861 "game.c"
}

static void
g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOOLEAN_BOOLEAN) (gpointer data1, gboolean arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOOLEAN_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 506 "../src/game.vala"
	g_return_if_fail (n_param_values == 3);
#line 506 "../src/game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 506 "../src/game.vala"
		data1 = closure->data;
#line 506 "../src/game.vala"
		data2 = param_values->data[0].v_pointer;
#line 4886 "game.c"
	} else {
#line 506 "../src/game.vala"
		data1 = param_values->data[0].v_pointer;
#line 506 "../src/game.vala"
		data2 = closure->data;
#line 4892 "game.c"
	}
#line 506 "../src/game.vala"
	callback = (GMarshalFunc_VOID__BOOLEAN_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 506 "../src/game.vala"
	callback (data1, g_value_get_boolean (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 4898 "game.c"
}

static GObject *
game_constructor (GType type,
                  guint n_construct_properties,
                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Game * self;
	GListStore* _tmp0_;
	GameStateObject* _tmp1_;
#line 532 "../src/game.vala"
	parent_class = G_OBJECT_CLASS (game_parent_class);
#line 532 "../src/game.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 532 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 534 "../src/game.vala"
	_tmp0_ = self->priv->undo_stack;
#line 534 "../src/game.vala"
	_tmp1_ = self->priv->_current_state;
#line 534 "../src/game.vala"
	g_list_store_append (_tmp0_, (GObject*) _tmp1_);
#line 535 "../src/game.vala"
	game_update_possible_moves (self);
#line 532 "../src/game.vala"
	return obj;
#line 4927 "game.c"
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
#line 506 "../src/game.vala"
	game_parent_class = g_type_class_peek_parent (klass);
#line 506 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
#line 506 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
#line 506 "../src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
#line 506 "../src/game.vala"
	G_OBJECT_CLASS (klass)->constructor = game_constructor;
#line 506 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
#line 506 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_NUMBER_OF_MOVES_PROPERTY, game_properties[GAME_NUMBER_OF_MOVES_PROPERTY] = g_param_spec_uchar ("number-of-moves", "number-of-moves", "number-of-moves", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 506 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SIZE_PROPERTY, game_properties[GAME_SIZE_PROPERTY] = g_param_spec_uchar ("size", "size", "size", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 506 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_STATE_PROPERTY, game_properties[GAME_CURRENT_STATE_PROPERTY] = g_param_spec_object ("current-state", "current-state", "current-state", TYPE_GAME_STATE_OBJECT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT | G_PARAM_EXPLICIT_NOTIFY));
#line 506 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_ALTERNATIVE_START_PROPERTY, game_properties[GAME_ALTERNATIVE_START_PROPERTY] = g_param_spec_boolean ("alternative-start", "alternative-start", "alternative-start", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 506 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_INITIAL_NUMBER_OF_TILES_PROPERTY, game_properties[GAME_INITIAL_NUMBER_OF_TILES_PROPERTY] = g_param_spec_uchar ("initial-number-of-tiles", "initial-number-of-tiles", "initial-number-of-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 506 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_IS_COMPLETE_PROPERTY, game_properties[GAME_IS_COMPLETE_PROPERTY] = g_param_spec_boolean ("is-complete", "is-complete", "is-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 506 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_LIGHT_TILES_PROPERTY, game_properties[GAME_N_LIGHT_TILES_PROPERTY] = g_param_spec_uchar ("n-light-tiles", "n-light-tiles", "n-light-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 506 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_DARK_TILES_PROPERTY, game_properties[GAME_N_DARK_TILES_PROPERTY] = g_param_spec_uchar ("n-dark-tiles", "n-dark-tiles", "n-dark-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 506 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY, game_properties[GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY] = g_param_spec_boolean ("current-player-can-move", "current-player-can-move", "current-player-can-move", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 506 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_COLOR_PROPERTY, game_properties[GAME_CURRENT_COLOR_PROPERTY] = g_param_spec_enum ("current-color", "current-color", "current-color", TYPE_PLAYER, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 506 "../src/game.vala"
	game_signals[GAME_TURN_ENDED_SIGNAL] = g_signal_new ("turn-ended", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN);
#line 506 "../src/game.vala"
	game_signals[GAME_COMPLETENESS_UPDATED_SIGNAL] = g_signal_new ("completeness-updated", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 4970 "game.c"
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
	GListStore* _tmp0_;
#line 506 "../src/game.vala"
	self->priv = game_get_instance_private (self);
#line 508 "../src/game.vala"
	_tmp0_ = g_list_store_new (TYPE_GAME_STATE_OBJECT);
#line 508 "../src/game.vala"
	self->priv->undo_stack = _tmp0_;
#line 4984 "game.c"
}

static void
game_finalize (GObject * obj)
{
	Game * self;
#line 506 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 508 "../src/game.vala"
	_g_object_unref0 (self->priv->undo_stack);
#line 528 "../src/game.vala"
	_g_object_unref0 (self->priv->_current_state);
#line 702 "../src/game.vala"
	self->priv->neighbor_tiles = (g_free (self->priv->neighbor_tiles), NULL);
#line 738 "../src/game.vala"
	(self->priv->possible_moves == NULL) ? NULL : (self->priv->possible_moves = (_g_slist_free__possible_move_free0_ (self->priv->possible_moves), NULL));
#line 506 "../src/game.vala"
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
#line 5003 "game.c"
}

GType
game_get_type (void)
{
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
		GType game_type_id;
		game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
		Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}

static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 506 "../src/game.vala"
	switch (property_id) {
#line 506 "../src/game.vala"
		case GAME_NUMBER_OF_MOVES_PROPERTY:
#line 506 "../src/game.vala"
		g_value_set_uchar (value, game_get_number_of_moves (self));
#line 506 "../src/game.vala"
		break;
#line 506 "../src/game.vala"
		case GAME_SIZE_PROPERTY:
#line 506 "../src/game.vala"
		g_value_set_uchar (value, game_get_size (self));
#line 506 "../src/game.vala"
		break;
#line 506 "../src/game.vala"
		case GAME_CURRENT_STATE_PROPERTY:
#line 506 "../src/game.vala"
		g_value_set_object (value, game_get_current_state (self));
#line 506 "../src/game.vala"
		break;
#line 506 "../src/game.vala"
		case GAME_ALTERNATIVE_START_PROPERTY:
#line 506 "../src/game.vala"
		g_value_set_boolean (value, game_get_alternative_start (self));
#line 506 "../src/game.vala"
		break;
#line 506 "../src/game.vala"
		case GAME_INITIAL_NUMBER_OF_TILES_PROPERTY:
#line 506 "../src/game.vala"
		g_value_set_uchar (value, game_get_initial_number_of_tiles (self));
#line 506 "../src/game.vala"
		break;
#line 506 "../src/game.vala"
		case GAME_IS_COMPLETE_PROPERTY:
#line 506 "../src/game.vala"
		g_value_set_boolean (value, game_get_is_complete (self));
#line 506 "../src/game.vala"
		break;
#line 506 "../src/game.vala"
		case GAME_N_LIGHT_TILES_PROPERTY:
#line 506 "../src/game.vala"
		g_value_set_uchar (value, game_get_n_light_tiles (self));
#line 506 "../src/game.vala"
		break;
#line 506 "../src/game.vala"
		case GAME_N_DARK_TILES_PROPERTY:
#line 506 "../src/game.vala"
		g_value_set_uchar (value, game_get_n_dark_tiles (self));
#line 506 "../src/game.vala"
		break;
#line 506 "../src/game.vala"
		case GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY:
#line 506 "../src/game.vala"
		g_value_set_boolean (value, game_get_current_player_can_move (self));
#line 506 "../src/game.vala"
		break;
#line 506 "../src/game.vala"
		case GAME_CURRENT_COLOR_PROPERTY:
#line 506 "../src/game.vala"
		g_value_set_enum (value, game_get_current_color (self));
#line 506 "../src/game.vala"
		break;
#line 5090 "game.c"
		default:
#line 506 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 506 "../src/game.vala"
		break;
#line 5096 "game.c"
	}
}

static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 506 "../src/game.vala"
	switch (property_id) {
#line 506 "../src/game.vala"
		case GAME_SIZE_PROPERTY:
#line 506 "../src/game.vala"
		game_set_size (self, g_value_get_uchar (value));
#line 506 "../src/game.vala"
		break;
#line 506 "../src/game.vala"
		case GAME_CURRENT_STATE_PROPERTY:
#line 506 "../src/game.vala"
		game_set_current_state (self, g_value_get_object (value));
#line 506 "../src/game.vala"
		break;
#line 506 "../src/game.vala"
		case GAME_ALTERNATIVE_START_PROPERTY:
#line 506 "../src/game.vala"
		game_set_alternative_start (self, g_value_get_boolean (value));
#line 506 "../src/game.vala"
		break;
#line 506 "../src/game.vala"
		case GAME_INITIAL_NUMBER_OF_TILES_PROPERTY:
#line 506 "../src/game.vala"
		game_set_initial_number_of_tiles (self, g_value_get_uchar (value));
#line 506 "../src/game.vala"
		break;
#line 5134 "game.c"
		default:
#line 506 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 506 "../src/game.vala"
		break;
#line 5140 "game.c"
	}
}

